Ext.data.ProxyMgr.registerType("userStorage",
    Ext.extend(Ext.data.Proxy, {
        create: function(operation, callback, scope) {
        },
        read: function(operation, callback, scope) {
        },
        update: function(operation, callback, scope) {
        },
        destroy: function(operation, callback, scope) {
        }
    })
);

Ext.regModel ("app.models.User", {
	fields: [
		// this is my internal primary key, doesn't relate to the primary key in your database table
		{name : 'id', 		type : 'int'},
		
		
		// this value will be the primary key from your user table, if I need it. Your table doesn't need to use web_id as the field name
		// it can be whatever you want
		{name : 'web_id', 		type : 'int'},
		
		// notification identifier
		{name : 'notification_id', 		type : 'string'},
		
		// type will dictate if they are patient or carer
		// perhaps 1=patient, 2=carer
		{name : 'type', 	type : 'int'},
		{name : 'name',		type : 'string'},
		{name : 'age', 		type : 'int'},
		
		// the int here is a foreign key to your table of towns
		{name : 'town',		type : 'int'},
		
		// note - the web version also has a country, so will need that in the model too (again, as a foreign key to the country table
		{name : 'email', 	type : 'string'},
		
		{name : 'password', type : 'string'},
		
		// i'll just be storing the current token, if any, here..
		{name : 'token', 	type : 'string'},
		
		// this is the 'where did you hear of myasthma' field from the registration form
		{name : 'origin', 	type : 'int'},
		
		// assuming this will be a foreign key to your table of languages
		{name : 'language', type : 'int'},
		
		// device type - where was the user account created
		{name : 'deviceType',	type : 'int'},
		
		// the frequency of notifications 
		// - the web version lets them switch off notifications entirely, the mobile apps dont seem to have this option
		// - 0 = OFF
		// - 1 = Twice a day
		// - 2 = Once a day
		// - 3 = Three times a week
		// - 4 = Once a week
		{name : 'frequency',type : 'int', defaultValue : 2},
		
	] , 
	
	 hasMany: [
		// note - the relationship with Profile is actually one-to-one, not one-to-many
	 	{model: 'app.models.Profile', name: 'profiles'},
	 	
        {model: 'app.models.Mood', name: 'moods'},
        {model: 'app.models.Act', name: 'acts'}
    ] ,
    
    proxy: {
        type: "userStorage"
    }
    
});