 var p = new Ext.data.LocalStorageProxy({
        id: 'act-items'
    })
 
 
 app.stores.actstore = new Ext.data.Store({
    model: "Act",
    proxy: p
});

Ext.regModel ("Act", {
	fields: [
		// my internal primary key, doesn't need to relate to your primary key
		{name : 'id', 			type : 'int'},
		
		{name : 'user_id', 			type : 'int'},
		
		

		
		// date of completion
		{name : 'date',			type : 'int'},
		{name : 'datestr',			type : 'string'},
		
		// answers for questions 1-5, all integers
		{name : 'q1',			type : 'int'},
		{name : 'q2',			type : 'int'},
		{name : 'q3',			type : 'int'},
		{name : 'q4',			type : 'int'},
		{name : 'q5',			type : 'int'},
		
		// device type - where was the ACT completed
		{name : 'platform',	type : 'int'},
		
		{name : 'submitted',	type : 'int', defaultValue: 0},
		
		// the score for the ACT
		{name : 'score',		type : 'int'}
	],
	associations: [
        {type: 'belongsTo', model: 'User',  getterName: "getUser", setterName: "setUser", foreignKey: "user_id" }
    ],
    proxy: p
  });

app.models.loadActs = function () {
	 // get unsycned data…
            Ext.Ajax.request({
                url: apiURL,
                method: "POST",
                params: {
                    action: "getacts",
                    token: app.currentUser.data.token,
                    user_id: app.currentUser.data.web_id


                },
                success: function (result) {
                	
                    var jsonData = Ext.util.JSON.decode(result.responseText);
                    
                    if (jsonData.statuscode == 200) {
                        for (var i = 0; i < jsonData.data.length; i++) {

                            var arr = jsonData.data[i].submitted.split(/[- :]/),
   								 timestamp = new Date(arr[0], arr[1]-1, arr[2], arr[3], arr[4], arr[5]).getTime();
                            
                            //alert (timestamp);
                         //   var d = t;
                            var existing = app.currentUser.acts().find("date", Math.round(Number(timestamp) / 1000));
                            if (existing >= 0) {
                                //alert ("FOUND ONE THAT ALREADY EXISTS");
                            } else {
                                var data = jsonData.data[i];
                                app.models.createACTFromJSON (data);
								
                            }
                        }
                        // all good
                        //alert (result.responseText);
                    }
                },
                failure: function (e) {

                }

            });
}
app.models.createACTFromJSON = function (data) {
	var arr = data.submitted.split(/[- :]/),
    d = new Date(arr[0], arr[1]-1, arr[2], arr[3], arr[4], arr[5]);
	//alert (data.date + "," +  data.submitted);
	//console.log ("CREATE ACT",data);
	 var newAct = app.currentUser.acts().add({
        user_id: app.currentUser.data.id,
        date: Math.round(d.getTime() / 1000),
        datestr: d.getFullYear() + "-" + d.getMonth() + "-" + d.getDate(),

        submitted: 1,
        q1: data.q1,
        q2: data.q2,
        q3: data.q3,
        q4: data.q4,
        q5: data.q5,
        score: data.score
    })[0];
    // alert (newAct);
    app.currentUser.acts().sync();
}

app.models.sendACTToServer = function (item) {
	Ext.Ajax.request({
			url: apiURL ,
			method: "POST",
			params: {
				action : "submitact",
				token : app.currentUser.data.token,
				user_id : app.currentUser.data.web_id,
				score : item.data.q5 + item.data.q1 + item.data.q2 + item.data.q3 + item.data.q4,
				date : item.data.date,
				q1 : item.data.q1,
				q2 : item.data.q2,
				q3 : item.data.q3,
				q4 : item.data.q4,
				q5 : item.data.q5
				
				
			},
			success: function(result){
				var jsonData = Ext.util.JSON.decode(result.responseText);
				if (jsonData.statuscode == 200) {
					if (item) {
					
						item.data.submitted = 1;
						item.save ();
					} else {
					
					}
				}
			},
			failure: function(e){ 
					
			}
		
		});

}
app.models.createAct = function (data) {
	var d = new Date ();
	//d = new Date (d.getFullYear (), d.getMonth () - Math.round (10 * Math.random()), Math.round (15*Math.random()) + 3);
    
	var newAct = app.currentUser.acts().add({
        user_id: 1,
        date: Math.round (d.getTime() / 1000),
        datestr: d.getFullYear() + "-" + d.getMonth() + "-" + d.getDate(),
        
        platform : platform,
        q1: data.q1,
        q2 : data.q2,
        q3 : data.q3,
        q4 : data.q4,
        q5 : data.q5, 
        score : data.q1 + data.q2 + data.q3 + data.q4 + data.q5
    })[0];
    
    app.currentUser.acts().sync();
    
    if (registered && window.navigator.onLine && !isHCP) {
    	// get unsycned data…
    	app.models.sendACTToServer (newAct);
    }
    
    
   
    
}
