 var m = new Ext.data.LocalStorageProxy({
        id: 'message-items'
    })
 
 
 app.stores.messagestore = new Ext.data.Store({
    model: "Message",
    
    autoLoad : true,
    
    autoSave : true,
    proxy: m
});


// Messages are sent to the user in one of two ways:
//  - Mobile users are sent notifications
//  - Web users are sent emails
// Additionally to that, your messages are available within the app, kind of like an inbox
// This data model relates to the list of messages within the app, and it's separate from the notifications / emails
// When the notification is received, I will create a new Message and store it in my local database, but I will also need 
// to load in these objects from your API to make sure everything is in sync. 
// For example, some users will turn off Notifications, but they will still want to see messages in the app
Ext.regModel ("Message", {
	fields: [
		// this is just an internal reference I'm using, doesn't need to relate to your primary key or anything
		{name : 'id', 		type : 'int'},
		
		// the date of the message
		{name : 'date',		type : 'int'},
		
		// the text of the message
		{name : 'message',	type : 'string'},
		
		// I guess there will be various actions in the notifications… something of them will take you to a piece of content,
		// others will prompt you to visit the GP, others will be more general. 
		// I suppose this field will have one of a number of different strings, could be 'content', 'visitGP' etc etc
		{name : 'action',	type : 'string'},
		
		// where required, this field will contain the additional detail for the message
		// for example, if action is 'content', the detail field will contain a reference to the content ID we are linking to
		// I've put it as a string here so it can handle lots of different types of data
		{name : 'detail',	type : 'string'},
		
		{name : 'read', type : 'int', defaultValue : 0}
	],
    proxy: m
});

app.models.createMessageFromNotification = function (data,unread) {
	var readVar = 1;
	if (unread) {
		readVar = 0;
	}
	//var arr = data.date.split(/[- :]/),
   // d = new Date(arr[0], arr[1]-1, arr[2], arr[3], arr[4], arr[5]);
	var d = new Date ();
	
	//alert ("FROM NOT");
			
		if (app.stores.messagestore.find ("id", data.id) >=0) {
		var curr = app.stores.messagestore.getAt (app.stores.messagestore.find ("id", data.id));
		curr.data.read = readVar;
		curr.save ();

	} else {
	
			var dat = Math.round (d.getTime () / 1000);
			
		//d = new Date (d.getFullYear (), d.getMonth () - Math.round (10 * Math.random()), Math.round (15*Math.random()) + 3);
	   var m = Ext.ModelMgr.create({
	        id:data.id,
	        date: Math.round (d.getTime() / 1000),
	        message:data.message,
	        action:data.action,
	        details:data.detail,
	        read:readVar
	    }, 'Message');	    
		app.stores.messagestore.add(m);
	    
	    app.stores.messagestore.sync();
	}    
   // alert (app.stores.messagestore.getCount () + " Messages");
   
    
}

app.models.loadMessages = function () {
if (!registered) {
return;
}
	 // get unsycned data…
	 var p =  {
                    action: "get_messages",
                    token: app.currentUser.data.token,
                    user_id: app.currentUser.data.web_id,
					language_id : app.currentUser.data.language

                };
              //  alert (app.currentUser.data.token + "," +  app.currentUser.data.web_id);
	 var lms = app.currentUser.data.message_sync;
	// lms = -1;
	 if (lms > -1) {
	 	p.since_date = app.currentUser.data.message_sync;
	 } else {
         var nowD = new Date ();
         
         p.since_date = Math.round (nowD.getTime ()/1000);
	 }
	// alert (p.since_date);
            Ext.Ajax.request({
                url: apiURL,
                method: "POST",
                params:p,
                success: function (result) {
                	//alert (result.responseText);
                    var jsonData = Ext.util.JSON.decode(result.responseText);
                             try {
                    if (jsonData.statuscode == 200) {
                    	var nowD = new Date ();
                    	 app.currentUser.data.message_sync = Math.round (nowD.getTime ()/1000);
                    	 app.currentUser.save ();
                        for (var i = 0; i < jsonData.data.length; i++) {
							var id = jsonData.data[i].messageid;
							jsonData.data[i].id = id;
							switch (jsonData.data[i].action) {
								case "content":
								jsonData.data[i].action = "c";
								break;
								case "register":
								jsonData.data[i].action = "r";
								break;

								case "profile":
								jsonData.data[i].action = "p";
								break;

								case "message":
								jsonData.data[i].action = "m";
								break;

							}
							
								jsonData.data[i].message =  unescape (jsonData.data[i].message.split ("+").join (" "))
							//alert (id);
							console.log (jsonData.data[i]);
							//alert (app.stores.messagestore.find ("id",id));
							if (app.stores.messagestore.find ("id",id) == -1) {
						//	alert ("YES");
							//console.log ("CREATING");
								app.models.createMessageFromJSON (jsonData.data[i],true);
							}
                            
                        }
                         app.stores.messagestore.sync();
                        if (app.views.home) {
                        	app.views.home.updateProfileSection ();
                        }
                            
                        // all good
                        //alert (result.responseText);
                    }
                              } catch (e) {}
                },
                failure: function (e) {

                }

            });
}



app.models.createMessageFromJSON = function (data) {
	var arr = data.date.split(/[- :]/);
//	alert (arr.length + "," + arr.toString ());
    var d = new Date(arr[0], arr[1]-1, arr[2], arr[3], arr[4], arr[5]);
 //   alert (d.getTime ());
	//var d = new Date ();
//	alert (data.id + "," + app.stores.messagestore.getCount ());
	//alert (app.stores.messagestore.find ("id", data.id));
	if (app.stores.messagestore.find ("id", data.id) >=0) {
		
	} else {
	
		var m = Ext.ModelMgr.create({
        id:data.id,
        date: Math.round (d.getTime() / 1000),
        message:data.message,
        action:data.action,
        details:data.detail,
        read:0
    }, 'Message');	 
  //  alert (m.data.id);   
	app.stores.messagestore.add(m);
    
   
    

	}
	//d = new Date (d.getFullYear (), d.getMonth () - Math.round (10 * Math.random()), Math.round (15*Math.random()) + 3);
      // alert (app.stores.messagestore.getCount () + " Messages");
   
    
}
