Ext.regModel ("Mood", {
	fields: [
		// this is my internal primary key, doesn't need to relate to yours
		{name : 'id', type : 'int'},
		{name : 'user_id', 			type : 'int'},
		
		// date of submission
		{name : 'date', type : 'int'},
		{name : 'datestr',			type : 'string'},
		
		// the mood of the user, think it'll be an integer between 1-3
		{name : 'result',	type : 'int'},
		
		{name : 'submitted',	type : 'int', defaultValue: 0},
		
		
		// device type - where was the Mood entered
		{name : 'platform',	type : 'int'},
	],
	associations: [
        {type: 'belongsTo', model: 'User',  getterName: "getUser", setterName: "setUser", foreignKey: "user_id" }
    ], 
    proxy: new Ext.data.LocalStorageProxy({
        id: 'mood-items'
    })

});

app.models.loadMoods = function () {
	 // get unsycned data…
            Ext.Ajax.request({
                url: apiURL,
                method: "POST",
                params: {
                    action: "get_feel_goods",
                    token: app.currentUser.data.token,
                    user_id: app.currentUser.data.web_id


                },
                success: function (result) {
                    var jsonData = Ext.util.JSON.decode(result.responseText);
                   
                    if (jsonData.statuscode == 200) {
                        for (var i = 0; i < jsonData.data.length; i++) {
							var arr = jsonData.data[i].date.split(/[- :]/),
   								 timestamp = new Date(arr[0], arr[1]-1, arr[2], arr[3], arr[4], arr[5]).getTime ();
                            
                         //  alert (app.currentUser.moods().getCount());
                           // alert (app.currentUser.moods().getAt(0).data.date == Math.round(Number(timestamp) / 1000));
                            var existing = app.currentUser.moods().find("date", Math.round(Number(timestamp) / 1000));
                            if (existing >= 0) {
                                
                            } else {
                            
                                var data = jsonData.data[i];
                                app.models.createMoodFromJSON (data);
								
                            }
                        }
                        if (app.views.moodSelector) {
                        	app.views.moodSelector.sortToday ();
                        }
                        // all good
                        //alert (result.responseText);
                    }
                },
                failure: function (e) {

                }

            });
}

app.models.sendMoodToServer = function (item) {
	Ext.Ajax.request({
			url: apiURL ,
			method: "POST",
			params: {
				action : "submit_feel_good",
				token : app.currentUser.data.token,
				user_id : app.currentUser.data.web_id,
				result : item.data.result,
				date : item.data.date,
								
				
			},
			success: function(result){
				var jsonData = Ext.util.JSON.decode(result.responseText);
				if (jsonData.statuscode == 200) {
					if (item) {
					
						item.data.submitted = 1;
						item.save ();
					} else {
					
					}
				}
			},
			failure: function(e){ 
					
			}
		
		});

}


app.models.createMoodFromJSON = function (data) {
	var arr = data.date.split(/[- :]/),
    d = new Date(arr[0], arr[1]-1, arr[2], arr[3], arr[4], arr[5]);
	//alert (data.date + "," +  data.submitted);
	//console.log ("CREATE ACT",data);

    
    var newMood = app.currentUser.moods().add({
        user_id: 1,
        date: Math.round (d.getTime() / 1000),
        datestr: d.getFullYear() + "-" + d.getMonth() + "-" + d.getDate(),
        submitted:1,
        result : data.result
    })[0];
    
    
    // alert (newAct);
    app.currentUser.moods().sync();
}



app.models.submitMood = function (data) {
	var d = new Date ();
	var dstr = d.getYear() + "-" + d.getMonth() + "-" + d.getDate();
	// now we want to delete existing moods for that day…
	var r = app.currentUser.moods().findRecord('datestr',dstr); 
	while (r ) {
		app.currentUser.moods().remove ( r );
		r = app.currentUser.moods().findRecord('datestr',dstr);
	}
   
	var newMood = app.currentUser.moods().add({
        user_id: 1,
        date: Math.round (d.getTime() / 1000),
        datestr: d.getFullYear() + "-" + d.getMonth() + "-" + d.getDate(),
        platform : platform,
        result : data.result
    })[0];
    
    app.currentUser.moods().sync();
    if (registered && window.navigator.onLine) {
    	// get unsycned data…
    	app.models.sendMoodToServer (newMood);
    }
    
}


app.models.getTodaysMood = function () {
	var d = new Date ();
	var dstr = d.getFullYear() + "-" + d.getMonth() + "-" + d.getDate();
	//alert (dstr + "," + app.currentUser.moods().getCount());
	// now we want to delete existing moods for that day…
	var r = app.currentUser.moods().findRecord('datestr',dstr); 
	if( r) {
		return r.data.result;
	}
	return null;
	    
}
