var p = new Ext.data.LocalStorageProxy({
        id: 'user-items'
    });
    
    
    app.stores.user = new Ext.data.Store({
    model: "User",
    proxy: p,
    autoLoad : true
});



Ext.regModel ("User", {
	fields: [
		// this is my internal primary key, doesn't relate to the primary key in your database table
		{name : 'id', 		type : 'int'},
		
		
		// this value will be the primary key from your user table, if I need it. Your table doesn't need to use web_id as the field name
		// it can be whatever you want
		{name : 'web_id', 		type : 'int', defaultValue : -1},
		
		// notification identifier
		{name : 'notification_id', 		type : 'string'},
		
		// type will dictate if they are patient or carer
		// perhaps 1=patient, 2=carer
		{name : 'type', 	type : 'int'},
		{name : 'name',		type : 'string'},
		{name : 'age', 		type : 'int'},
		
		// the int here is a foreign key to your table of towns
		{name : 'nearest_town',		type : 'int'},
		
		{name : 'town',		type : 'string'},
		
		
		{name : 'country_id',		type : 'int'},
		{name : 'chosen_town',		type : 'int'},
		{name : 'country', type : 'string'},
		// note - the web version also has a country, so will need that in the model too (again, as a foreign key to the country table
		{name : 'email', 	type : 'string'},
		
		{name : 'password', type : 'string'},
		
		// i'll just be storing the current token, if any, here..
		{name : 'token', 	type : 'string'},
		
		{name : 'device_token', 	type : 'string'},
		{name : 'device_token_status', 	type : 'int', defaultValue:0},
		
		
		// this is the 'where did you hear of myasthma' field from the registration form
		{name : 'how_found_my_asthma', 	type : 'int'},
		
		// assuming this will be a foreign key to your table of languages
		{name : 'language', type : 'int'},
		
		{name : 'message_sync', type : 'int', defaultValue:-1},
		
		//
		{name : 'last_sync', type : 'int'},
		
		{name : 'last_content_sync', type:'date'},
		
		{name : 'version', type : 'int', defaultValue : -1},
		
		// the frequency of notifications 
		// - the web version lets them switch off notifications entirely, the mobile apps dont seem to have this option
		// - 0 = OFF
		// - 1 = Twice a day
		// - 2 = Once a day
		// - 3 = Three times a week
		// - 4 = Once a week
		{name : 'frequency',type : 'int', defaultValue : 2},
		
		// numeric answers for questions 1-20. You can use these answers to weight the notifications
		{name : 'q1',	type : 'int', defaultValue:-1},
		{name : 'q2',	type : 'int', defaultValue:-1},
		{name : 'q3',	type : 'int', defaultValue:-1},
		{name : 'q4',	type : 'int', defaultValue:-1},
		{name : 'q5',	type : 'int', defaultValue:-1},
		{name : 'q6',	type : 'int', defaultValue:-1},
		{name : 'q7',	type : 'int', defaultValue:-1},
		{name : 'q8',	type : 'int', defaultValue:-1},
		{name : 'q9',	type : 'int', defaultValue:-1},
		{name : 'q10',	type : 'int', defaultValue:-1},
		{name : 'q11',	type : 'int', defaultValue:-1},
		{name : 'q12',	type : 'int', defaultValue:-1},
		{name : 'q13',	type : 'int', defaultValue:-1},
		{name : 'q14',	type : 'int', defaultValue:-1},
		{name : 'q15',	type : 'int', defaultValue:-1},
		{name : 'q16',	type : 'int', defaultValue:-1},
		{name : 'q17',	type : 'int', defaultValue:-1},
		{name : 'q18',	type : 'int', defaultValue:-1},
		{name : 'q19',	type : 'int', defaultValue:-1},
		{name : 'q20',	type : 'int', defaultValue:-1},
		
		{name : 'w1',	type : 'int', defaultValue:-1},
		{name : 'w2',	type : 'int', defaultValue:-1},
		{name : 'w3',	type : 'int', defaultValue:-1},
		{name : 'w4',	type : 'int', defaultValue:-1}
		
	] , 
		proxy: p
		
		,
		
		associations: [
        {type: 'hasMany', model: 'Act', name: 'acts',
        
        	storeConfig: {
            autoLoad: true
        	}
        },
        {type: 'hasMany', model: 'Mood', name: 'moods',storeConfig: {
            autoLoad: true
        	}}
    ],
    
   
    
});

app.stores.createUserFromJSON = function (data) {
	
	
	app.currentUser.data.nearest_town = data.nearest_town;
	app.currentUser.data.town = data.town;
	app.currentUser.data.name = data.name;
	app.currentUser.data.type = data.user_type;
	app.currentUser.data.email = data.email;
	app.currentUser.data.q1 = Number(data.q1);
	app.currentUser.data.q2 = Number(data.q2);
	app.currentUser.data.q3 = Number(data.q3);
	app.currentUser.data.q4 = Number(data.q4);
	app.currentUser.data.q5 = Number(data.q5);
	app.currentUser.data.q6 = Number(data.q6);
	app.currentUser.data.q7 = Number(data.q7);
	app.currentUser.data.q8 = Number(data.q8);
	app.currentUser.data.q9 = Number(data.q9);
	app.currentUser.data.q10 = Number(data.q10);
	app.currentUser.data.q11 = Number(data.q11);
	app.currentUser.data.q12 = Number(data.q12);
	app.currentUser.data.q13 = Number(data.q13);
	app.currentUser.data.q14 = Number(data.q14);
	app.currentUser.data.q15 = Number(data.q15);
	app.currentUser.data.q16 = Number(data.q16);
	app.currentUser.data.q17 = Number(data.q17);
	app.currentUser.data.q18 = Number(data.q18);
	app.currentUser.data.q19 = Number(data.q19);
	app.currentUser.data.q20 = Number(data.q20);
	
	/**/
	app.currentUser.save ();
	isPatient = app.currentUser.data.type != 2;
	isHCP = app.currentUser.data.type == 3;

	
}

app.stores.beginEverything = function () {

	 if (window.plugins && window.navigator.onLine) {
     try {
     
     
        	//window.plugins.pushNotification.startNotify();
            registerAPN ();
            window.plugins.pushNotification.getApid ();
            
            

            
            } catch (e) {console.log (e);}
        }
        
        var doneWelcome = registered || app.currentUser.acts().getCount() > 0;
        
        if (!doneWelcome) {
            Ext.dispatch({
                controller: app.controllers.asthmaController,
                action: 'showCarerPatient',
                animation: false
            });
        } else {

            Ext.dispatch({
                controller: app.controllers.asthmaController,
                action: 'showMain',
                score: 20,
                animation: false
            });
        }
        
        if (registered) {
     	  // app.models.loadMessages ();
        }
        if (navigator && navigator.splashscreen && navigator.splashscreen.hide) {
        	navigator.splashscreen.hide();
        }
}
 
app.stores.resumeApp = function () {
	//console.log ("RESUMING!");
	if (app.views.moodSelector) {
		app.views.moodSelector.sortToday ();
	}
	if (app.views.home) {
		app.views.home.loadWeather ();
	}
	app.models.loadMessages ();
}

app.stores.updateUnregPref = function () {
	console.log ("UPDATING UNREG PREF");
	if (!window.navigator.onLine) {
		return;
	}
	if (app.currentUser.data.device_token == "") {
		return;
	}
	 Ext.Ajax.request({
            url: apiURL,
            method: "POST",
            params: {
                action: "set_preferences",
               
                notification_key : app.currentUser.data.device_token,
                message_frequency : isHCP ? 0 : app.currentUser.data.frequency
            },
            success: function (result) {
            	console.log (result);
                
               
            },
            failure: function (e) {
				
            }

        });

}




app.stores.updateUserPrefs = function (newFreq) {
	
	app.currentUser.data.frequency = newFreq;
	app.currentUser.save ();
	if (!registered) {
		return;
	}
	console.log ("CALLING SET_PREF",newFreq);
	 Ext.Ajax.request({
            url: apiURL,
            method: "POST",
            params: {
                action: "save_preferences",
                token: app.currentUser.data.token,
                user_id: app.currentUser.data.web_id,
                notification_key : app.currentUser.data.device_token,
                message_frequency : newFreq
            },
            success: function (result) {
            	 console.log (result);
                
               
            },
            failure: function (e) {
				console.log (result);
            }

        });

}
app.stores.resetUser = function () {
	while (app.currentUser.moods().getCount () > 0) {
	//console.log ("REMOVE MOOD");
		app.currentUser.moods().removeAt (0);
	}
	app.currentUser.moods().sync ();
	app.currentUser.acts().clearFilter ();
	app.currentUser.acts().read ();
	while (app.currentUser.acts().getCount () > 0) {
		app.currentUser.acts().removeAt (0);
	}

	app.currentUser.acts().sync ();
	
	app.stores.user.removeAt (0);
	//app.currentUser.delete ();
	app.stores.user.removeAll ();
	app.stores.user.sync ();
	//alert (app.stores.user.getCount ());
	app.stores.user.read ();
	//alert (app.stores.user.getCount ());
	app.stores.initUser ();
}
app.stores.initUser = function () {
	var store = app.stores.user;
	store.read();

	var person = store.getAt(0);

	if (!person) {
		//console.log ("Creating user for the first time…");
	    person = Ext.ModelMgr.create({
	        id: 1,
                                     country_id: 484,
                                     nearest_town: 6691,
                                     town : "Ciudad de México",
                                     country : "México",
                                     frequency : 2,
                                     language : 13,	    }, 'User');
	    store.add(person);
	    store.sync();
	} else {
		//console.log ("Got person…");
		//console.log (person);
		//console.log (person.data.id, person.data.web_id);
	}
	
	app.currentUser = person;
	setupInitialContent ();
//	alert ("DEVICE STATUS " + app.currentUser.data.device_token_status);
	isPatient = app.currentUser.data.type != 2;
	isHCP = app.currentUser.data.type == 3;
	registered = app.currentUser.data.web_id >= 0;
	app.currentUser.acts().load();
    app.currentUser.moods().load();
     
    app.stores.messagestore.load ();
    app.stores.syncContent ();
    
     if (registered && window.navigator.onLine) {
        
       Ext.Ajax.request({
            url: apiURL,
            method: "POST",
            params: {
                action: "getprofile",
                token: app.currentUser.data.token,
                user_id: app.currentUser.data.web_id
            },
            success: function (result) {
            	
                var jsonData = Ext.util.JSON.decode(result.responseText);
				
                if (jsonData.statuscode == 200) {
              
                    app.stores.createUserFromJSON  (jsonData.data);
                   //  alert ("YES");
                    if (app.views.home) {
								app.views.home.reshowLocation ();
								
								app.views.home.updateProfileSection ();
							}
							
							
                }
               
            },
            failure: function (e) {
				
            }

        });
        
        
        
        // no we want to loop through all ACTS that have been created but not submitted
        app.currentUser.acts().filter("submitted", 0);
        app.currentUser.acts().each (function (record) {
        	app.models.sendACTToServer (record);
        });
        
        app.currentUser.acts().clearFilter();
        
        
         app.currentUser.moods().filter("submitted", 0);
        app.currentUser.moods().each (function (record) {
        	app.models.sendMoodToServer (record);
        });
        
        
        
        app.currentUser.moods().clearFilter();
        
        
        app.models.loadActs ();
        app.models.loadMoods ();
       
    }
    
    document.addEventListener("resume", app.stores.resumeApp, false);
       // addDeviceKeyToUser ("dfsdfsdf");
}

if (!PushNotification) {
	var PushNotification = function () {};
}

var tmp = 10;
/*setTimeout (function () {
	tmp ++;
	PushNotification.prototype.notificationCallback (
		{date:"2011-11-12 11:34:57",message:"Your preventer is the key to managing your asthma. Prevention is the best way to lock asthma away.",id:123,detail:10,action:"c"}
	
	)

}, 3000);*/

 // Customized callback for receiving notification
PushNotification.prototype.notificationCallback = function (notification) {
    app.models.createMessageFromNotification (notification);
    //console.log (notification);
    
    var msg = '';
    for (var property in notification) {
        msg += property + ' : ' + notification[property] + '\n';
    }
    
    var buttons = [{text : getString ("Notification_Popup_Close"), itemId : "no", cls:"cancelBtn"}, {text : getString ("Notification_Popup_LearnMore"), itemId : "yes", cls:"okBtn"}];
	
	if (notification["action"]) {
		switch (notification["action"]) {
			case "r":
				buttons = [{text : getString ("Notification_Popup_Close"), itemId : "no", cls:"cancelBtn"}, {text : getString ("Notification_Popup_Register"), itemId : "yes", cls:"okBtn"}];
			break;
			case "m":
				buttons = [{text : getString ("Notification_Popup_Close"), itemId : "no", cls:"wide cancelBtn"}];
			break;
			case "p":
				buttons = [{text : getString ("Notification_Popup_Close"), itemId : "no", cls:"cancelBtn"}, {text : getString ("Notification_Popup_Update"), itemId : "yes", cls:"okBtn"}];
			break;

		}
	}    
    
    Ext.Msg.show({
		  	   title: '',
			   msg: notification.message,
			   animate:false,
			   buttons:  buttons,
			   fn : function (a,b,c) { 
			   	if (a == "yes") {
			   		Ext.dispatch({
                        controller: app.controllers.asthmaController,
                        action: 'handleNotification',
                        notification : notification
                     });	
			   	}
			   }
			});
			
			
   // alert ('notification received:\n\n' + msg);
    // alert (notification.aps);
    // alert(notification['alert']);
    
};

var addDeviceKey = function (token) {
	var params = {
			action : "register_device",
			notification_key : token,
			platform : platform,
			language_id : app.currentUser.data.language
	}
	Ext.Ajax.request({
		url: apiURL ,
		method: "POST",
		params: params,
		success: function(result){
			var jsonData = Ext.util.JSON.decode(result.responseText);
			if (jsonData.statuscode == 200) {
				app.currentUser.data.device_token_status = 1;
				app.currentUser.save ();
			}			 else {
				//console.log ("ADD KEY ERROR " + jsonData.statusmessage);
			
			}
		},
		failure: function(e){ 
				//console.log ("KEY WAS NOT SAVED");
		}
	
	});
}

var  addDeviceKeyToUser = function (token) {
	//alert ("ADDDEVICEKEYTOUSER " + token);
	var params = {
			action : "register_device_with_user",
			token : app.currentUser.data.token,
			user_id : app.currentUser.data.web_id,
			notification_key : token,
			platform : platform,
			language_id : app.currentUser.data.language
	};
	Ext.Ajax.request({
		url: apiURL ,
		method: "POST",
		params: params,
		success: function(result){
			var jsonData = Ext.util.JSON.decode(result.responseText);
			if (jsonData.statuscode == 200) {
				app.currentUser.data.device_token_status = 2;
				app.currentUser.save ();
		//x		alert ("SAVED KEY");
			}			 else {
			//alert("ADD KEY ERROR " + jsonData.statusmessage);

			
			}
		},
		failure: function(e){ 
				//alert ("ADD BIG KEY ERROR");

		}
	
	});
}
            
            
            
            
// when APN register succeeded
function successCallback(e) {
    //   alert("Device registered. Device token:<br>" + e.deviceToken);
    registerUAPush(e.deviceToken, e.host, e.appKey, e.appSecret);
}

// when APN register failed
function errorCallback(e) {
   
}

// register button action
function registerAPN() {
    
    if (!window.plugins) {
    	return;
    }
    window.plugins.pushNotification.log("Registering with APNS via the App Delegate");
    window.plugins.pushNotification.register(successCallback, errorCallback, [{ alert:true, badge:true, sound:true }]);
    
    //or unregister
    //navigator.pushNotification.register();
}

// register urban airship push service after APN is registered successfully
function registerUAPush(deviceToken, host, appKey, appSecret) {
    
    window.plugins.pushNotification.log("Registering with Urban Airship.");
    
    // alert ( 'Registering with Urban Airship Push Service...' );
    
    var request = new XMLHttpRequest();
    
    // open the client and encode our URL
    request.open('PUT', host+'api/device_tokens/'+deviceToken, true, appKey, appSecret);
    
    // callback when request finished
    request.onload = function() {
        //  alert ('Status: ' + this.status);
        
        if(this.status == 200 || this.status == 201) {
        
	        	app.currentUser.data.device_token = deviceToken;
			    app.currentUser.save ();
			    if (app.currentUser.data.device_token_status == 0) {
			        if (!registered) {
			        	addDeviceKey (deviceToken);
			        } else {
			        	addDeviceKeyToUser (deviceToken);
			        }
			    }
			    
        
            // register UA push success
            window.plugins.pushNotification.log( 'UA push service successfully registered.');
        } else {
            // error
            window.plugins.pushNotification.log('Error when registering UA push service.<br>error: '+this.statusText );
        }
        
    };
    
    request.send();
}
