app.views.ActChart = Ext.extend(Ext.Panel, {
     cls: 'act_chart_page',
	 layout: {
        type: "vbox",
        align: "center",

    },
    id:"theChart",
	 width: "100%",
    defaults: {

    },
    scroll: "vertical",
    renderMonth: function () {
    	if (isHCP) {
    		return;
    	}
        var maxdays = [31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
        var monthSpan = 3;

        // last date is end of current month
        var endDate = new Date(this.currentYear, this.currentMonth, maxdays[this.currentMonth]);

        var startDate = new Date(this.currentYear, this.currentMonth - 2, 1);
        var midDate = new Date(this.currentYear, this.currentMonth - 1, 1);
        var label1 = "01 " + getString("Chart_Month" + (startDate.getMonth() + 1) + "_Short");
        var label2 = "01 " + getString("Chart_Month" + (midDate.getMonth() + 1) + "_Short");
        var label3 = "01 " + getString("Chart_Month" + (endDate.getMonth() + 1) + "_Short");
        var enddate = maxdays[this.currentMonth];
        var label4 = enddate + " " + getString("Chart_Month" + (endDate.getMonth() + 1) + "_Short");

        var mainlabel = getString("Chart_Month" + (startDate.getMonth() + 1) + "_Short") + " - " + getString("Chart_Month" + (endDate.getMonth() + 1) + "_Short") + " " + endDate.getFullYear();
        if (endDate.getFullYear() != startDate.getFullYear()) {
            mainlabel = getString("Chart_Month" + (startDate.getMonth() + 1) + "_Short") + " " + startDate.getFullYear() + " - " + getString("Chart_Month" + (endDate.getMonth() + 1) + "_Short") + " " + endDate.getFullYear();
        }

        var inner = '<canvas id="actCanvas" width="284" height="202"></canvas>';
        inner += "<div class='month_labels'><span class='l1'>" + label1 + "</span><span class='l2'>" + label2 + "</span><span class='l3'>" + label3 + "</span><span class='l4'>" + label4 + "</span></div>";
        inner += "<div class='good_score'></div>";
        //inner += "<div class='best_score'></div>";
        inner += "<div class='labels'>";
        inner += "<span class='label1'>0</span>";
        inner += "<span class='label2'>20</span>";
        inner += "<span class='label3'>25</span>";
        inner += "<span class='scorelabel'>Puntuación</span>";
        
        inner += "</div>";
        
        
         var today = new Date();

        if (this.currentYear == today.getFullYear() && this.currentMonth == today.getMonth()) {
            Ext.query(".act_current_month .next")[0].style.display = "none";
        } else {
            Ext.query(".act_current_month .next")[0].style.display = "block";
        }
        var todayD = Math.round (startDate.getTime ()/1000);
        var isData = app.currentUser.acts().findBy(function (a,b) { return a.get("date") < todayD});
    	//alert (isData);
    	if (isData ==-1) {
    	try {
    		Ext.query (".act_current_month .prev")[0].style.display = "none";
    		} catch (e) {}
    	} else {
    	try {
    		Ext.query (".act_current_month .prev")[0].style.display = "block";
    		} catch (e) {}
    	}
        
        
        Ext.query(".act_current_month strong")[0].innerHTML = mainlabel;

		var timeAtFirstOfMonth = Math.round (startDate.getTime ()/1000);
    	
    	var timeAtLastOfMonth = new Date (this.currentYear, this.currentMonth + 1, 1).getTime ();
    	timeAtLastOfMonth = Math.round (timeAtLastOfMonth/1000);
    	
    	// left = 29
    	// width = 228
    	var leftPos = 29;
    	var totalWidth = 228;
    	
    	var totalDurationOfSeconds = maxdays[endDate.getMonth ()] + maxdays[midDate.getMonth ()] + maxdays[startDate.getMonth ()];
    	//alert (totalDurationOfSeconds);
    	totalDurationOfSeconds *= 24 * 60 * 60;
    	//alert (totalDurationOfSeconds);
    	
    	var positions = [];
    	
		var getY = function (score) {
			return 18 + ((25-score) * 6.4);
			
		}
		app.currentUser.acts().clearFilter ();
		app.currentUser.acts ().filter (
    		[
    			{filterFn: function(item) { return item.get("date") >= timeAtFirstOfMonth && item.get("date") <= timeAtLastOfMonth; }}
			]
    	)
    	app.currentUser.acts().sort ('date','ASC');
    	app.currentUser.acts().each (function (record) {
    		var timeOffset = record.data.date - timeAtFirstOfMonth;
    		var perc = timeOffset / totalDurationOfSeconds;
    		var posOfItem = leftPos + Math.round(totalWidth * perc);
    		positions.push ({x:posOfItem, y:getY(record.data.score), score:record.data.score});
    	})
    	
    	inner += "<div class='dots'>";
    	//alert ("DOING IT " + positions.length);
    	for (var i=0;i<positions.length;i++) {
    		inner+= "<span style='left:" + positions[i].x + "px; top:" + positions[i].y + "px'>" + positions[i].score + "</span>";
    	}
    	inner += "</div>";
    	
    	
        var mc = Ext.getCmp("actChart");
        
            mc.el.dom.childNodes[0].innerHTML = inner;

            var addColorStops = function (gradient, amount) {
            		amount = Math.abs (amount);
            		amount -= 20;
            	
                    gradient.addColorStop(0, 'rgba(51, 67, 152, 0)');
                    if (amount > 0) {
                    	gradient.addColorStop(Math.min  (1,amount/80), 'rgba(51, 67, 152, 1)');
                    }
                    gradient.addColorStop(1, 'rgba(51, 67, 152, 1)');
                }
                // if (!this.ctx) {
                this.canvas = document.getElementById('actCanvas');

            this.ctx = this.canvas.getContext("2d");
            //} else {
            this.ctx.clearRect(0, 0, 284, 202);
            //  }
            



            // this.ctx.strokeStyle = '#334398'
            this.ctx.lineWidth = 5;
            this.ctx.moveTo(0, 100);
            this.ctx.lineTo(30, 30);
    //        this.ctx.stroke();
           // alert ("RENDERING MONTH" + positions.length);

            this.ctx.beginPath();

            this.ctx.strokeStyle = "rgb(51,67,152)";
            if (positions.length > 0) {
            	this.ctx.moveTo (positions[0].x, positions[0].y);
            }
            for (i=1;i<positions.length;i++) {
           // alert ("DRAWGIN TO " +  positions[i].x + "," + positions[i].y);
            	this.ctx.lineTo (positions[i].x, positions[i].y);
            	this.ctx.stroke ();
            }
           this.ctx.stroke();
			//alert (this.ctx);
			// now see if there are any items before the first item on the chart…
			app.currentUser.acts().clearFilter ();
			app.currentUser.acts ().filter (
	    		[
	    			{filterFn: function(item) { return item.get("date") < timeAtFirstOfMonth }}
				]
	    	)
	    	app.currentUser.acts().sort ('date','DESC');

			
			var firstPrevious;
			if (app.currentUser.acts().getCount () > 0) {
				firstPrevious = app.currentUser.acts().getAt(0);
			}
			if (positions.length > 0 && app.currentUser.acts().getCount () > 0) {
				
				var item = app.currentUser.acts().getAt (0);
				var timeOffset = item.data.date - timeAtFirstOfMonth;
    			var perc = timeOffset / totalDurationOfSeconds;
    			var posOfItem = leftPos + Math.round(totalWidth * perc);
    			var g = this.ctx.createLinearGradient(posOfItem, getY(item.data.score),positions[0].x, positions[0].y);
				 addColorStops(g, 0);
            	this.ctx.beginPath();
				this.ctx.strokeStyle = g;
				
				this.ctx.moveTo (positions[0].x, positions[0].y);
				this.ctx.lineTo (posOfItem, getY (item.data.score));
				this.ctx.stroke ();
			}
			
			
			// now see if there are any items after the last item on the chart…
			app.currentUser.acts().clearFilter ();
			app.currentUser.acts ().filter (
	    		[
	    			{filterFn: function(item) { return item.get("date") > timeAtLastOfMonth }}
				]
	    	)
	    	app.currentUser.acts().sort ('date','ASC');
//alert (timeAtLastOfMonth + "," + app.currentUser.acts().getCount () + " items");
			
			var lastPrevious;
			if (app.currentUser.acts().getCount () > 0) {
				lastPrevious = app.currentUser.acts().getAt(0);
			}

			
			if (positions.length > 0 && app.currentUser.acts().getCount () > 0) {
				var item = app.currentUser.acts().getAt (0);
				var timeOffset = item.data.date - timeAtFirstOfMonth;
				//alert (item.data.score);
    			var perc = timeOffset / totalDurationOfSeconds;
    			var posOfItem = leftPos + Math.round(totalWidth * perc);
    			
				var h = this.ctx.createLinearGradient(posOfItem, getY(item.data.score), positions[positions.length-1].x, positions[positions.length-1].y);
//				var h = (direction == 1) ? this.ctx.createLinearGradient(p, 180, 280, 0) : this.ctx.createLinearGradient(260, 0, 280, 180);
           		 addColorStops(h, Math.abs (positions[positions.length-1].x - posOfItem));
            	this.ctx.beginPath();
				this.ctx.strokeStyle = h;

				this.ctx.moveTo (positions[positions.length-1].x, positions[positions.length-1].y);
				this.ctx.lineTo (posOfItem, getY (item.data.score));
				this.ctx.stroke ();
			}
			
			// lastly, the case where there are no positions, but one position before and after…
			if (positions.length == 0 && firstPrevious && lastPrevious) {
				this.ctx.beginPath();

            	this.ctx.strokeStyle = "rgba(51,67,152,0.4)";
            	
            	var timeOffset1 = firstPrevious.data.date - timeAtFirstOfMonth;
				var perc1 = timeOffset1 / totalDurationOfSeconds;
    			var posOfItem1 = leftPos + Math.round(totalWidth * perc1);
				
				var timeOffset2 = lastPrevious.data.date - timeAtFirstOfMonth;
				var perc2 = timeOffset2 / totalDurationOfSeconds;
    			var posOfItem2 = leftPos + Math.round(totalWidth * perc2);
       			this.ctx.moveTo (posOfItem1 - 20,getY(firstPrevious.data.score));
				this.ctx.lineTo (posOfItem2 + 20,getY(lastPrevious.data.score));
				this.ctx.stroke ();
			}
			
  			
       
       
    	
    	//alert (app.currentUser.acts().getCount ());
/*
    	
    	var maxday = maxdays[this.currentMonth];
    	var isLeap = new Date(this.currentYear,1,29).getDate() == 29;
    	if (isLeap && this.currentMonth == 1) {
    		maxday ++;
    	}
    	var today = new Date ();
    	
    	
    	
    	
    	
    	var startoffset = new Date(this.currentYear,this.currentMonth,1).getDay () - 1;
		if (startoffset< 0) {
			startoffset = 6;
		}
		var mc = Ext.getCmp ("actChart");
		var days = "<div class='days'>";
		for (var i=0;i<6;i++) {
			for (var j=0;j<7;j++) {
				var dayNo = 1 + (i*7) + j;
				if (dayNo > startoffset && dayNo <=(maxday+startoffset)) {
					var isData = app.currentUser.moods().find("datestr",this.currentYear + "-" + (this.currentMonth) + "-" + (dayNo-startoffset));		
					var cls = "";
					if (isData >=0) {
						var data = app.currentUser.moods().getAt (isData).data.result;
						cls = " result" + data;
					}
					days += "<span class='row" + (i+1) + " col" + (j+1) + cls + "'>" + (dayNo-startoffset) + "</span>";
				}
			}
		}
		days += "</div>";
		var months = "<div class='months'>" + "<span class='col1'>" + getString ("Chart_Day1") + "</span>" + "<span class='col2'>" + getString ("Chart_Day2") + "</span>" + "<span class='col3'>" + getString ("Chart_Day3") + "</span>" + "<span class='col4'>" + getString ("Chart_Day4") + "</span>" + "<span class='col5'>" + getString ("Chart_Day5") + "</span>" + "<span class='col6'>" + getString ("Chart_Day6") + "</span>" + "<span class='col7'>" + getString ("Chart_Day7") + "</span></div>";
		var currentMonth = "<div class='current_month'><span class='prev'></span><strong></strong><span class='next'></div>";
		if (mc) {
			mc.el.dom.childNodes[0].innerHTML = days + months;
//						console.log (mc.el.dom.childNodes[0].childNodes[0]);
		}
		
		var cont = Ext.getCmp ("monthController");
		if (cont) {
		//	cont.el.dom.childNodes[0].innerHTML = currentMonth;
		}
		*/

    },
    previousMonth: function () {
        this.currentMonth--;
        if (this.currentMonth < 0) {
            this.currentMonth = 11;
            this.currentYear--;
        }
        this.renderMonth();
    },
    nextMonth: function () {
        this.currentMonth++;
        if (this.currentMonth > 11) {
            this.currentMonth = 0;
            this.currentYear++;
        }
        this.renderMonth();
    },
    initComponent: function () {
        var me = this;
		app.views.actChart = this;
        //put instances of cards into viewport
        Ext.apply(this, {
            scroll: "vertical",

            defaults: {
                align: "center"
            },
            dockedItems: [new app.views.Title({
                items: [

                {
                    id: 'back',
                    text: getString("Generic_Button_Back"),
                    ui: 'back',
                    listeners: {
                        'tap': function () {
                        
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'backToActIntro',
                                
                                animation:false                            });
                        }
                    }
                }

                ]
            }), new app.views.Subtitle({
                label: getString("AsthmaChart_Subtitle")
            })],

            xtype: "panel",

            items: [{
            	xtype:"box",
            	height:isHCP ? 10 : "30"
            },
            {
                margin:"0 10 0 10",
                id : "monthChartDemo",
                html:"<img src='resources/images/chart-demo.png'/>",
				width:290,
				hidden: !isHCP,
				height:252,
            }
			,{
                cls: "act_chart",
                margin: "0 10 0 10",
                id: "actChart",
                hidden: isHCP,
				
                width: 284,
                height: 202,
                component: "panel"
            }, {
                cls: "asthma_month_controller",
                margin: "10 10 0 10",
                id: "chartController",
                hidden: isHCP,
				
                width: 284,
                height: 25,
                html: "<div class='act_current_month'><span class='prev'></span><strong></strong><span class='next'></div>",
                component: "panel"

            } ,
            {
            	xtype:"spacer",
            	flex:1
            }
			,
			{
                cls: "act_footer",
                margin:"0 20 20 20",
                 xtype:"panel",
               
                html: getString("ActIntro_Disclaimer")
            }
            ]

        }



        );

		


        //  Ext.Msg.confirm ("Hello","Really?",Ext.emptyFn);
        app.views.AsthmaMonth.superclass.initComponent.apply(this, arguments);
		
        this.on({
            afterrender: function () {
           	
            },


            activate: function () {
            
            setTimeout ( function () {
                //console.log (Ext.query (".prev"));
                Ext.query(".act_current_month .prev")[0].addEventListener("click", function () {
                    me.previousMonth()
                });
                Ext.query(".act_current_month .next")[0].addEventListener("click", function () {
                    me.nextMonth()
                });
                }, 250);
                
                
          //  alert ("ACTIVATE");
                var d = new Date();
                this.currentYear = d.getFullYear();
                this.currentMonth = d.getMonth();
                this.renderMonth();


            }		



        });
    }
});