app.views.ActIntro = Ext.extend(Ext.Panel, {
    cls: 'act_intro',
fullscreen:true,
       

    layout: {
        type: "vbox",
        align: "center",

    },
    width: "100%",
    id : "actIntro",
    defaults: {

    },
    
    updateDueBox : function () {
    	app.currentUser.acts().clearFilter ();
    	var today = new Date ();
    	var monthAgo = new Date (today.getFullYear(), today.getMonth (), today.getDate () - 28);
    	var timeOneMonthAgo = Math.round (monthAgo.getTime () / 1000);
    	app.currentUser.acts ().filter (
    		[
    			{filterFn: function(item) { return item.get("date") >=timeOneMonthAgo; }}
			]
    	)
    	if (app.currentUser.acts().getCount () == 0) {
    		Ext.getCmp ("dueStatus").update ("<h1 class='due'>" + getString ("ActIntro_Status_Due") + "</h1>");
    	} else {
    		Ext.getCmp ("dueStatus").update ("<h1 class='completed'>" + getString ("ActIntro_Status_Completed") + "</h1>");
    	}
    	app.currentUser.acts().clearFilter ();
    	
    },
    forceActivate  : function () {
					if (registered || isHCP) {
						Ext.getCmp ("viewChartButton").show ();
					} else {
						Ext.getCmp ("viewChartButton").hide ();
					}
				},
    initComponent: function () {
        var me = this;
this.title = getString ("Nav_ACT");


        //put instances of cards into viewport
        Ext.apply(this, {
            scroll: "vertical",

            defaults: {
                align: "center"
            },
            dockedItems: [
             new app.views.Title ({label:"MyAsthma"}),
             new app.views.Subtitle({
                label: getString("ActIntro_Subtitle")
            }),

            ],

            xtype: "panel",

            items: [

            {
                cls: "act_intro_panel",
                margin:"14 10 14 10",
                xtype:"panel",
                html: getString("ActIntro_Intro")

            },

            {

                xtype: "panel",
                cls: "act_intro_panels",
                width: 303,
                height: 160,
                margin: "0 auto 0 auto",
                items: [{
                	padding:"0 0 0 0",
                	 xtype:"box",
               		id:"dueStatus",
                    html: "<h1 class='due'>" + getString ("ActIntro_Status_Due") + "</h1>"
                }, 
                
                	{
                    ui: 'button-light-pink generic-button',
                    margin: '2 15 0 15',
                    cls: 'asthma-button',
                    xtype: "button",
                    flex: 1,
                    text: getString("ActIntro_Button_CompleteACT"),
                    listeners: {
                        'tap': function () {
                        var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                        	Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'doACT',
                                previousScreen: app.views.main,
                                animation:false
                            });
                        }
                    }
                    },
                    {
                    ui: 'button-light-blue generic-button',
                    margin: '24 15 0 15',
                    cls: 'asthma-button',
                    id:"viewChartButton",
                    xtype: "button",
                    flex: 1,
                    text: getString("ActIntro_Button_ViewChart"),
                    listeners: {
                        'tap': function () {
                     var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                       // app.views.actWrapper.setActiveItem (1);
                       	Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'newActChart',
                                animation:false
                            });                           
                          
                        }
                    }
                    }
                ]

            }
            ,
            {
            	xtype:"spacer",
            	flex:1,
            	minHeight:50,
            	minheight:50,
            }
			,
			{
                cls: "act_footer",
                margin:"0 10 20 10",
                 xtype:"panel",
               
                html: getString("ActIntro_Disclaimer")
            }

            ]

        }



        );

		
		



        //  Ext.Msg.confirm ("Hello","Really?",Ext.emptyFn);
        app.views.ActIntro.superclass.initComponent.apply(this, arguments);
    }
});