app.views.EmailReport = Ext.extend(Ext.Panel, {
    cls: 'email_report',
    scroll: "vertical",
    layout: "fit",
    iconCls:"report",
    initComponent: function () {
    	this.title = getString ("Nav_Report");
    	
        var me = this;
        Ext.apply(this, {
            scroll: "vertical",
			layout: "fit",
            dockedItems: [



            new app.views.Title({
                label: "MyAsthma"
                            }),


            new app.views.Subtitle({
                label: getString ("EmailReport_Subtitle"),
            })

            ],
            items: [

           

            {
                xtype: 'form',
               
                id: 'reportform',
                items: [
                 {
                html: "<p class='center'>" + getString ("EmailReport_Intro") + "</p>",
          		cls : "nopad",
          		margin: "0 10 20 10"
            }
            
            ,
            {
                    xtype: 'fieldset',
                    defaults: {
                        // labelAlign: 'right'
                        labelWidth: '0'
                    },
                    items: [{
                        xtype: 'emailfield',
                        name: 'email',
                        id : "reportEmail",
                        label: false,
                        placeHolder: getString ("EmailReport_FormPlaceholder_Email"),
                        autoCapitalize: false,
                        useClearIcon: true
                    }


                    ]
                }

                , {
                    ui: 'button-light-blue generic-button',
                    margin: '18 5 0 5',
                    cls: 'asthma-button',
                    xtype: "button",
                   
                    text: getString ("EmailReport_Button_Send"),
                    listeners: {
                        'tap': function () {
                        if (isHCP) {
                        	return;
                        }
                        
                        var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                        
                        
                        
                        
                        Ext.Ajax.request({
			                                url: apiURL,
			                                method: "POST",
			                                params: {
			                                    action: "export_to_email",
			
			                                    user_id: app.currentUser.data.web_id,
												token: app.currentUser.data.token,
															email : Ext.getCmp ("reportEmail").getValue ()
			                                },
			                                success: function (result) {
			                               // alert (result.responseText);
			                               		 Ext.Msg.show({
											  	   title: '',
												   msg: getString ("EmailReport_Popup_EmailSent"),
												   height: 160,
												   buttons:  [{text : getString ("EmailReport_Popup_Close"), buttonId : "yes", cls:"okBtn"}],
												   
												});
			                                    
			                                },
			                                  
			                                   failure : function () {
			                                   	Ext.Msg.show({
			                                        title: '',
			                                        msg: getString("GenericError_Popup_ConnectionFail"),
			                                        buttons: [{
			                                            text: getString("GenericError_Popup__Close"),
			                                            id: "notnow",
			                                            itemId: "notnow",
			                                            cls: "okBtn wide"
			                                        }]
			                                    });
			                                    }
			                                   });
                        
                        
                        
                        
                        
                        
                        
                        	
							
                        }
                    }
                }


                ]
            }

            ]

        });
        app.views.EmailReport.superclass.initComponent.call(me);
        
        this.on (
			{
			
				beforeactivate : function (a) {
					if (!registered && !isHCP) {
						Ext.Msg.show({
						  	   title: '',
							   msg: getString ("Unregistered_AccessDenied_Popup_EmailReport"),
							   height: 160,
							   buttons:  [{text : getString ("Unregistered_AccessDenied_Popup_Close"), itemId : "no", cls:"cancelBtn"}, {text : getString ("Unregistered_AccessDenied_Popup_Register"), itemId : "yes", cls:"okBtn"}],
							   fn : function (a,b,c) { 
							   var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
							   	if (a == "yes") {
							   		Ext.dispatch({
		                                controller: app.controllers.asthmaController,
		                                action: 'showRegister',
		                                previousScreen: app.views.main,
		                                callback : app.views.home.updateProfileSection,
		                                callbackObj : app.views.home,
		                                animation:false                            });	
							   	}
							   }
							});
						return false;
					} else {
						Ext.getCmp ("reportEmail").setValue (isHCP ? "anon@anon.com" : app.currentUser.data.email);
					}
					//alert ("SHOW");
				}
			}
		);

    }



});