app.views.ForgotPassword = Ext.extend(Ext.Panel, {
    fullscreen: true,
    cls: 'welcome',
    scroll: "vertical",
    layout: "fit",
    initComponent: function () {
        var me = this;
        Ext.apply(this, {
            scroll: "vertical",
            layout: "fit",
            dockedItems: [



            new app.views.Title({
                label: "MyAsthma",
                items: [{
                    id: 'back',
                    text: getString("Generic_Button_Back"),
                    ui: 'back',
                    listeners: {
                        'tap': function () {
                        if (document.activeElement && document.activeElement.blur) {
	    	document.activeElement.blur();
	   }
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'revertTo',
                                item: me.previousScreen,
                                animation: false                            });
                        }
                    }
                }

                ]
            }),


            new app.views.Subtitle({
                label: getString("ForgotPasswordScreen_Subtitle"),
            })

            ],
            items: [



            {
                title: 'ForgotPassword',
                xtype: 'form',

                id: 'passwordform',
                items: [{
                    html: "<p class='center'>" + getString("ForgotPasswordScreen_Instruction") + "</p>",
                    cls: "nopad",
                    margin: "0 10 20 10"
                }

                , {
                    xtype: 'fieldset',
                    defaults: {
                        // labelAlign: 'right'
                        labelWidth: '35%'
                    },
                    items: [{
                        xtype: 'emailfield',
                        name: 'email',
                        id: 'forgotpasswordfield',
                        label: getString("ForgotPasswordScreen_FormLabel_Email"),
                        placeHolder: getString("ForgotPasswordScreen_FormPlaceholder_Email"),
                        autoCapitalize: false,
                        useClearIcon: true
                    }


                    ]
                }

                , {
                    ui: 'button-light-blue generic-button',
                    margin: '18 5 0 5',
                    cls: 'asthma-button',
                    xtype: "button",

                    text: getString("ForgotPasswordScreen_Button_Send"),
                    listeners: {
                        'tap': function () {

if (document.activeElement && document.activeElement.blur) {
	    	document.activeElement.blur();
	   }
                            Ext.Ajax.request({
                                url: apiURL,
                                method: "POST",
                                params: {
                                    action: "forgotten_password",

                                    email: Ext.getCmp("forgotpasswordfield").getValue(),


                                },
                                success: function (result) {
                                    var jsonData = Ext.util.JSON.decode(result.responseText);
                                    if (jsonData.statuscode == 200) {
                                        Ext.Msg.show({
                                            title: '',
                                            msg: getString("ForgotPasswordScreen_Popup_EmailSent"),
                                            height: 160,
                                            buttons: [{
                                                text: getString("ForgotPasswordScreen_Popup_Close"),
                                                buttonId: "yes",
                                                cls: "okBtn"
                                            }],
                                            fn: function () {
                                                Ext.dispatch({
                                                    controller: app.controllers.asthmaController,
                                                    action: 'revertTo',
                                                    item: me.previousScreen,
                                                    animation: false                                                });
                                            }
                                        });

                                    } else {
                                        Ext.Msg.show({
                                            title: '',
                                            msg: getString("ForgotPasswordScreen_ErrorPopup_EmailNotFound"),
                                            height: 160,
                                            buttons: [{
                                                text: getString("ForgotPasswordScreen_Popup_Close"),
                                                buttonId: "yes",
                                                cls: "wide okBtn"
                                            }],

                                        });

                                    }

                                },
                                failure: function (e) {
                                    Ext.Msg.show({
                                        title: '',
                                        msg: getString("GenericError_Popup_ConnectionFail"),
                                        buttons: [{
                                            text: getString("GenericError_Popup__Close"),
                                            id: "notnow",
                                            itemId: "notnow",
                                            cls: "okBtn wide"
                                        }]
                                    });
                                }

                            });







                        }
                    }
                }


                ]
            }

            ]

        });
        app.views.ForgotPassword.superclass.initComponent.call(me);

        this.on({

            deactivate: function (component) {

                component.destroy();
            },

            activate: function (component) {

                if (!window.navigator.onLine) {

                    Ext.Msg.show({
                        title: '',
                        msg: getString("GenericError_Popup_ConnectionFail"),
                        buttons: [{
                            text: getString("GenericError_Popup__Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }],
                        fn: function () {
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'revertTo',
                                item: me.previousScreen,
                                animation:false                            });
                        }
                    });
                }
            }
        });


    }



});