app.views.Home = Ext.extend(Ext.Panel, {
    cardSwitchAnimation: 'flip',
    id:"homePanel",
    cls: 'home',
    scroll: "vertical",
    iconCls: 'home',
    layout: {
        type: "vbox",
        align: "stretch"
    },
    defaults: {
        width: "100%"
    },
    width: "100%",
    updateLocation : function (data) {
    	app.currentUser.data.chosen_town = 1;
    	app.currentUser.data.town = data.cityname;
    	app.currentUser.data.nearest_town = data.cityid;
    	app.currentUser.data.country = "NL";//data.countryname;
    	
    	app.currentUser.save ();
    	
    	if (registered) {
    	
    		 Ext.Ajax.request({
                url: apiURL,
                method: "POST",
                params: {
                    action: "update_town",

                    user_id: app.currentUser.data.web_id,
					token: app.currentUser.data.token,
					nearest_town : data.cityid
                },
                success: function (result) {
              
                },
                  
                   failure : function () {
                                       }
                   });
    	}
    	
    	this.reshowLocation ();
    	this.loadWeather ();
    	//    	alert ("UPDATING TOWN TO" + data.cityname);
    },
    loadWeather : function () {
    	var me = this;
    	this.showWeather ();
    	if (window.navigator.onLine) {
    	
    		Ext.Ajax.request({
				url: apiURL ,
				method: "POST",
				params: {
					action : "get_weather",
					
					town_id : app.currentUser.data.nearest_town,
					
					
				},
				success: function(result){
					var jsonData = Ext.util.JSON.decode(result.responseText);
					//console.log (jsonData.data);
					app.currentUser.data.town = jsonData.data.town;
					app.currentUser.data.w1 = jsonData.data.temperature;
					app.currentUser.data.w2 = jsonData.data.pollution;
					app.currentUser.data.w3 = jsonData.data.pollen;
					app.currentUser.data.w4 = jsonData.data.icon;
					app.currentUser.save ();
					me.showWeather ();
					me.reshowLocation ();
					
				},
				failure: function(e){ 
						
				}
			
			});
    	
    	
    	} else {
	    	this.showWeather ();
	    }
    },
    showWeather : function () {
    	Ext.getCmp ("icon1").updateValues (app.currentUser.data.w1);
    	Ext.getCmp ("icon2").updateValues (app.currentUser.data.w2);
    	Ext.getCmp ("icon3").updateValues (app.currentUser.data.w3);
    	Ext.getCmp ("icon4").updateValues (app.currentUser.data.w4);
    },
    reshowLocation : function () {
    if (Ext.query (".location")[0]) {
    	Ext.query (".location")[0].innerHTML = app.currentUser.data.town + ", " + app.currentUser.data.country;

    } else {
    	setTimeout (function () {
    		Ext.query (".location")[0].innerHTML = app.currentUser.data.town + ", " + app.currentUser.data.country;

    	},1000);
    }
    	
    },
    updateProfileSection : function () {
    	if (Ext.getCmp ('unreadCount')) {
    		Ext.getCmp('unreadCount').hide();
    	
    	}
    	app.views.main.updateMessages (3);
    	if (registered) {
    		//alert (this.subtitle.el);
    		var n = app.currentUser.data.name.split (" ")[0];
    		n = n.charAt(0).toUpperCase() + n.slice(1).toLowerCase();
    		this.subtitle.updateLabel (getString("HomeScreen_Subtitle", n));
			    		Ext.getCmp('profileCompletion').show();
    		Ext.getCmp('registrationPrompt').hide();
    		var questionsComplete = 0;
    		for (var i=1;i<=17;i++) {
    			//console.log (app.currentUser.data["q" + i]);
    			if (Number (app.currentUser.data["q" + i]) >= 0) {
    				questionsComplete ++;
    			}
    		}
    		Ext.getCmp('profileCompletion').update ("<p><strong>" + getString("HomeScreen_Profile_CompletionStatus", "63%") + "</strong><span>" + getString(questionsComplete < 17 ? "HomeScreen_UpdateProfile_Button" : "HomeScreen_AmendProfile_Button") + "</span></p><img src='resources/images/bgtiles/progress-bg.png' class='progress-bg'/><img src='resources/images/bgtiles/progress.png' class='progress' id='homeProgressImg' /><img src='resources/images/bgtiles/progress-overlay.png' class='progress-overlay'/>");

    		var percent = Math.round (10 + (90*((questionsComplete)/17)));
    		if (isHCP) {
    			percent = 50;
    		}
    		if (Ext.query('#profileCompletion strong')[0]) {
    			Ext.query('#profileCompletion strong')[0].innerHTML = getString("HomeScreen_Profile_CompletionStatus", percent + "%");
    			Ext.get('homeProgressImg').setStyle('width', percent + "%");
    		} else {
    			setTimeout (function () {
    				Ext.query('#profileCompletion strong')[0].innerHTML = getString("HomeScreen_Profile_CompletionStatus", percent + "%");
    				Ext.get('homeProgressImg').setStyle('width', percent + "%");
    		
    			}, 1000);
    		}
    		
    	
    	} else {
    		this.subtitle.updateLabel (getString("HomeScreen_Subtitle", " "));

    	

    		Ext.getCmp('profileCompletion').hide ();
    		Ext.getCmp('registrationPrompt').show ();
    	}
    	Ext.getCmp('moodInstruct').update ("<p class='how_is'>" + getString("HomeScreen_Mood_Instruction") + "</p>");
    	
    	if (app.views.moodSelector) {
					app.views.moodSelector.sortToday ();							
				}
				
				
    	//alert (app.stores.messagestore.find ("read",0));
    /*)	if (app.stores.messagestore.find ("read",0) >= 0) {
    		if (Ext.getCmp ('unreadCount')) {
    			Ext.getCmp('unreadCount').show();
    			
    		}
    		//Ext.getCmp('profileCompletion').hide();
    		//	Ext.getCmp('registrationPrompt').hide();
    	}*/
    	this.doLayout ();
    },
    
    initComponent: function () {
    	this.title = getString ("Nav_Home");
    	app.views.home = this;
        var me = this;
        this.subtitle = new app.views.Subtitle({
                label: getString("HomeScreen_Subtitle", " ")
            });
            
        //put instances of cards into viewport
        Ext.apply(this, {
            scroll: "vertical",

            dockedItems: [
             new app.views.Title ({label:"MyAsthma"}),
             
            this.subtitle]
            ,
            items: [

            {
                xtype: "panel",
                cls: "location_panel",
                padding: "0 0 10 0",
                margin: "10 12 0 12",
                layout: {
                    type: "hbox",
                    pack: "center",
                    align: "center",

                },

                items: [{
                	xtype:"box",
                    html: "<p class='location'>" + app.currentUser.data.town  + "</p>",
                    flex: 7
                }, {
                    xtype: "button",
                    ui: "small-grey",
                    text: getString("HomeScreen_ChangeLocation_Button"),
                    listeners: {
                    	
                        'tap': function () {
                        
                        var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                		
                		
//                            app.controllers.asthmaController.workInProgress ();
								Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'chooseTown',
                                previousScreen: app.views.main,
                                callback : me.updateLocation,
                                callbackObj : me,
                                animation: false                            });
                            
                            
                        }
                    }


                }]

            }

            ,


            {
                xtype: "panel",
                cls: "icons",
                margin: "0 0 0 0",
                height: 118,
                layout: {
                    type: "hbox",


                },

                items: [
                new app.views.IconSet({
                    id: "icon1",
                    iconID: "1"
                }), new app.views.IconSet({
                    id: "icon2",
                    iconID: "2"
                }), new app.views.IconSet({
                    id: "icon3",
                    iconID: "3"
                }), new app.views.IconSet({
                    id: "icon4",
                    iconID: "4"
                }),

                ]

            }

            ,
            
            
            {
                xtype: "box",
                cls: "registration_prompt",
                margin: "0 0 0 0",
                height: 48,
				id:"registrationPrompt",
                html: "<p style='font-size:12px;'>" + getString ("HomeScreen_RegisterPrompt") + "</p>",
                
                listeners : {
                el: {
                	tap : function () {
                		var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                		
                		Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'showRegister',
                                previousScreen: app.views.main,
                                callback : me.updateProfileSection,
                                callbackObj : me,
                                animation: false                            });
                	}
                	}
                }

            }


			,

            {
                xtype: "panel",
                cls: "profile_completion",
                margin: "0 0 0 0",
                height: 48,
				id:"profileCompletion",
                html: "<p><strong>" + getString("HomeScreen_Profile_CompletionStatus", "63%") + "</strong><span>" + getString("HomeScreen_UpdateProfile_Button") + "</span></p><img src='resources/images/bgtiles/progress-bg.png' class='progress-bg'/><img src='resources/images/bgtiles/progress.png' class='progress' id='homeProgressImg' /><img src='resources/images/bgtiles/progress-overlay.png' class='progress-overlay'/>",
                
                listeners : {
                el: {
                	tap : function () {
                	if (isHCP) {
                		return;
                	}
                	var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;

                	if (window.navigator.onLine) {
                		Ext.Msg.show({
		  	   title: '',
			   msg: getString ("EditProfile_Popup"),
			   buttons:  [{text : getString ("EditProfile_Popup_Close"), itemId : "close", cls:"cancelBtn "}, {text : getString ("EditProfile_Popup_Continue"), itemId : "continue", cls:"okBtn "}],
			   fn : function (a,b,c) {
			   	var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
			   	if (a == "close") {
			   			
	                
	           
			   	} else {
			   
			   	
			   Ext.dispatch({
                            controller: app.controllers.asthmaController,
                            action: 'updateProfile',
                            animation:false
                        });
			   	}
			   }
			});
			} else {
			
			
				Ext.Msg.show({
                        title: '',
                        msg: getString("GenericError_Popup_ConnectionFail"),
                        buttons: [{
                            text: getString("GenericError_Popup__Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }]
                    });
			} 
			
			
			
                	
                	
                		
                	}
                	}
                }

            }

            ,

            {
                xtype: "panel",
                cls: "mood",
                padding: "5 0 0 0",
                flex: 1,
                layout: {
                    type: "vbox",
                    align: "center",
                    pack: "center",
                },



                items: [{
                	id:"moodInstruct",
                	xtype:"box",
                    html: "<p class='how_is'>" + getString("HomeScreen_Mood_Instruction") + "</p>",
                    height: "32",

                },
                new app.views.MoodSelector(),

                {
                    xtype: "spacer",
                    flex: 1
                }

                ]

            }




            ]
        });



		this.loadWeather ();

        //  Ext.Msg.confirm ("Hello","Really?",Ext.emptyFn);
        app.views.Home.superclass.initComponent.apply(this, arguments);
        
        this.on (
			{
				show : function () {
					this.updateProfileSection ();
					this.reshowLocation ();
				},
				activate : function () {
					// set the profile text etc
					this.updateProfileSection ();
					this.reshowLocation ();
					this.loadWeather ();
				},
				afteractivate : function () {
					this.updateProfileSection ();
					this.reshowLocation ();
				}
			}
		);
		
		
    }
});