app.views.LogIn = Ext.extend(Ext.Panel, {
    fullscreen: true,
    cardSwitchAnimation: 'flip',
    cls: 'welcome',
    scroll: "vertical",
    layout: "fit",
    initComponent: function () {
        var me = this;
        if (app.views.login) {
        	app.views.login.destroy ();
        }
        app.views.login = this;
        Ext.apply(this, {
            scroll: "vertical",

            dockedItems: [



            new app.views.Title({
                items: [{
                    text: getString ("Generic_Button_Cancel"),
                    ui: 'back',
                    listeners: {
                        'tap': function () {
                        	if (document.activeElement && document.activeElement.blur) {
						    	document.activeElement.blur();
						   }
                        	 Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'revertTo',
                                item: me.previousScreen,
                                animation: false                            });
                        }
                    }
                }

                ]
            }),


            new app.views.Subtitle({
                label: getString ("LogInScreen_Subtitle")
            })

            ],
            items: [



            {
                title: 'Basic',
                xtype: 'form',
                id: 'basicform',
                items: [{
                    xtype: 'fieldset',
                    defaults: {
                        // labelAlign: 'right'
                        labelWidth: '35%'
                    },
                    items: [{
                        xtype: 'emailfield',
                        name: 'email',
                        id:"loginemail",
                        label: getString ("LoginScreen_FormLabel_Email"),
                        placeHolder: getString ("LoginScreen_FormPlaceholder_Email"),
                        autoCapitalize: false,
                        useClearIcon: true
                    }


                    ]
                },
                {
                    xtype: 'fieldset',
                    defaults: {
                        // labelAlign: 'right'
                        labelWidth: '35%'
                    },
                    items: [{
                        xtype: 'passwordfield',
                        name: 'password',
                        id:"loginpassword",
                        label: getString ("LoginScreen_FormLabel_Password"),
                        placeHolder: getString ("LoginScreen_FormPlaceholder_Password"),
                        useClearIcon: true
                    }


                    ]
                }

                , {
                    cls: "nopad",
                    layout: "hbox",
                    items: [{
                        xtype: "spacer"
                    }, {
                        cls: "link padright",
                        html: getString ("LogInScreen_Button_ForgotPassword"),
                        afterRender: function() {
					         Ext.Panel.superclass.afterRender.apply(this, arguments);
					         Ext.EventManager.on(this.id, 'click', function() { 
					         	var newclick = new Date().getTime ();
					         	if (document.activeElement && document.activeElement.blur) {
	    	document.activeElement.blur();
	   }
		                		if (this.lastclick && newclick - this.lastclick < 2000) {
		                			this.lastclick = newclick;
		                			return;
		                		}
		                		this.lastclick = newclick;
					         	Ext.dispatch({
					                controller: app.controllers.asthmaController,
					                action: 'forgotPassword',
					                previousScreen : me ,
					                animation: false					            });

					         });
					     }
                    }]

                }, {
                    ui: 'button-light-blue generic-button',
                    margin: '18 5 0 5',
                    cls: 'asthma-button',
                    xtype: "button",
                    flex: 1,
                    text: getString("LogInScreen_Button_LogIn"),
                    listeners: {
                        'tap': function () {
                        if (document.activeElement && document.activeElement.blur) {
	    	document.activeElement.blur();
	   }
                        var newclick = new Date().getTime ();
		                		if (this.lastclick && newclick - this.lastclick < 2000) {
		                			this.lastclick = newclick;
		                			return;
		                		}
		                		this.lastclick = newclick;

                        
                        
                        	Ext.Ajax.request({
                                url: apiURL,
                                method: "POST",
                                params: {
                                    action: "login",

                                    email: Ext.getCmp("loginemail").getValue(),
									password: Ext.getCmp("loginpassword").getValue(),
									platform : platform


                                },
                                success: function (result) {
                                    var jsonData = Ext.util.JSON.decode(result.responseText);
                                    if (jsonData.statuscode == 200) {
                                    	var user_id = jsonData.data.user_id;
                                    	var token = jsonData.data.token;
                                    	
                                    	//alert (user_id + "," + token);
                                    	app.currentUser.data.web_id = user_id;
                                    	app.currentUser.data.token = token;
                                    	
                                    	// now we need to load the user's profile…
                                    	Ext.Ajax.request({
			                                url: apiURL,
			                                method: "POST",
			                                params: {
			                                    action: "getprofile",
			
			                                    user_id: user_id,
												token: token,
															
			                                },
			                                success: function (result) {
			                               // alert (result.responseText);
			                                    var jsonData = Ext.util.JSON.decode(result.responseText);
			                                    if (jsonData.statuscode == 200) {
			                                    	var d = jsonData.data;
			                                    	app.currentUser.data.name = d.name;
			                                    	app.currentUser.data.email = d.email;
			                                    	app.currentUser.data.type = d.user_type;
			                                    	app.currentUser.data.nearest_town = d.nearest_town;
			                                    	app.currentUser.data.town= d.town;
			                                    	app.currentUser.data.type = d.user_type;
			                                    	for (var i=1;i<=20;i++) {
			                                    		app.currentUser.data["q" +i] = d["q" + i];
			                                    	}
			                                    	app.currentUser.save ();
			                                    	isPatient = app.currentUser.data.type != 2;
													isHCP = app.currentUser.data.type == 3;
				                                    	registered = true;
			                                    	
			                                    	app.models.loadActs ();
			                                    	app.models.loadMoods ();
			                                    	
													addDeviceKeyToUser (app.currentUser.data.device_token);
													
			                                    	app.currentUser.acts().filter("submitted", 0);
										            app.currentUser.acts().each (function (record) {
										            	app.models.sendACTToServer (record);
										            });
										            
										            app.currentUser.acts().clearFilter();
										            
										            app.models.loadMessages ();
										             app.currentUser.moods().filter("submitted", 0);
										            app.currentUser.moods().each (function (record) {
										            	app.models.sendMoodToServer (record);
										            });
										            
										            
										            
										            app.currentUser.moods().clearFilter();

			                                    	Ext.dispatch({
						                                controller: app.controllers.asthmaController,
						                                action: 'showMain',
						                                previousScreen: me,
						
						                            });
						                            
													
						                            
						                            
			                                   } else {
			                                   	Ext.Msg.show({
			                                        title: '',
			                                        msg: getString("GenericError_Popup_ConnectionFail"),
			                                        buttons: [{
			                                            text: getString("GenericError_Popup__Close"),
			                                            id: "notnow",
			                                            itemId: "notnow",
			                                            cls: "okBtn wide"
			                                        }]
			                                    });
			                                   }
			                                  },
			                                  
			                                   failure : function () {
			                                   	Ext.Msg.show({
			                                        title: '',
			                                        msg: getString("GenericError_Popup_ConnectionFail"),
			                                        buttons: [{
			                                            text: getString("GenericError_Popup__Close"),
			                                            id: "notnow",
			                                            itemId: "notnow",
			                                            cls: "okBtn wide"
			                                        }]
			                                    });
			                                    }
			                                   });
			                                   
                                    	
                                       /* Ext.Msg.show({
                                            title: '',
                                            msg: getString("ForgotPasswordScreen_Popup_EmailSent"),
                                            height: 160,
                                            buttons: [{
                                                text: getString("ForgotPasswordScreen_Popup_Close"),
                                                buttonId: "yes",
                                                cls: "okBtn"
                                            }],
                                            fn: function () {
                                                Ext.dispatch({
                                                    controller: app.controllers.asthmaController,
                                                    action: 'revertTo',
                                                    item: me.previousScreen,
                                                    animation: {
                                                        type: 'slide',
                                                        direction: 'right'
                                                    }
                                                });
                                            }
                                        });*/

                                    } else {
                                        Ext.Msg.show({
                                            title: '',
                                            msg: getString("LoginScreen_Error_LogInFailed"),
                                            height: 160,
                                            buttons: [{
                                                text: getString("LoginScreen_Error_LogInFailed_Close"),
                                                buttonId: "yes",
                                                cls: "wide okBtn"
                                            }],

                                        });

                                    }

                                },
                                failure: function (e) {
                                    Ext.Msg.show({
                                        title: '',
                                        msg: getString("GenericError_Popup_ConnectionFail"),
                                        buttons: [{
                                            text: getString("GenericError_Popup__Close"),
                                            id: "notnow",
                                            itemId: "notnow",
                                            cls: "okBtn wide"
                                        }]
                                    });
                                }

                            });





                        	/*registered =true;
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'showMain',
                                animation:false
                            });*/
                        }
                    }
                }


                ]
            }

            ]

        });
        app.views.LogIn.superclass.initComponent.call(me);
        
          this.on({

            activate: function (component) {
            	
                if (!window.navigator.onLine) {

                    Ext.Msg.show({
                        title: '',
                        msg: getString("GenericError_Popup_ConnectionFail"),
                        buttons: [{
                            text: getString("GenericError_Popup__Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }],
                        fn: function () {
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'revertTo',
                                item: me.previousScreen,
                                animation: false                            });
                        }
                    });
                }
            }
        });
    }



});