app.views.ProfileScreen = Ext.extend(Ext.Panel, {
    fullscreen: true,
    cls: 'profile',
    scroll: "vertical",
    layout: {
        type: "vbox",
    },
    defaults: {
        width: "100%"
    },
    renderQuestion: function (q) {

        //console.log (this.subtitle.el);
        //this.subtitle.label = "Hello";
        //if (q>1) {
        this.subtitle.updateLabel(getString("ProfileScreen_Subtitle", q,null,17));
        // }
        try {
            Ext.getCmp("questionText").update({html:getString("ProfileQuestion_Q" + q)});
        } catch (e) {
            console.log("An error was recorded setting question text: " + e.message);
        }
        var options = [];
        for (var i = 0; i < 9; i++) {
            var str = getString("ProfileQuestion_Q" + q + "_A" + i, null, true);
            if (str != "") {
                options.push({
                    id: i,
                    text: str
                });
            }
        }
        
        var naoptions = [{id:0,text:getString ("ProfileQuestion_NotApplicable")}];
        
        Ext.getCmp("questionText").doLayout ();

        var percent = 10 + (90 * ((this.questionsComplete) / 17));
        try {
            Ext.get('progressImg').setStyle('width', percent + "%");
        } catch (e) {
            console.log("An error was recorded setting progress image width: " + e.message);
        }
        try {
        	this.na.renderQuestions (naoptions);
            this.bg.renderQuestions(options);
        } catch (e) {
            console.log("An error was recorded rendering questions: " + e.message);
        }
        if (app.currentUser.data["q" + this.questionIndex] >= 0) {

            try {
          //  e ( app.currentUser.data["q" + this.questionIndex]);
            	if (app.currentUser.data["q" + this.questionIndex]  == 0) {
            		this.na.setAnswer("opt-" + app.currentUser.data["q" + this.questionIndex]);
            	} else {
            		this.bg.setAnswer("opt-" + app.currentUser.data["q" + this.questionIndex]);
            	}
                
                
            } catch (e) {
                console.log("An error was recorded setting an answer: " + e.message);
            }
            try {
                Ext.getCmp('submit').show();
            } catch (e) {
                console.log("An error was recorded showing the submit button: " + e.message);
            }
        } else {
            try {
                Ext.getCmp('submit').hide();
            } catch (e) {
                console.log("An error was recorded hiding the submit button: " + e.message);
            }

        }
        Ext.getCmp("questionText").doLayout ();
        this.na.doLayout ();
        this.bg.doLayout ();
        this.doLayout();
var m = this;
		setTimeout (function () {try {Ext.getCmp("questionText").doLayout ();} catch (e) {}; try {m.doLayout ()} catch (e) {}}, 100);
    },

    initComponent: function () {
        var me = this;
        var tot = 0;
        this.questionIndex = 1;
        
        for (var i = 1; i <= 17; i++) {
            if (app.currentUser.data["q" + i] >= 0) {
            	this.questionIndex = i + 1;
                tot++;
            } else {
            //	alert (i + "," + app.currentUser.data["q" + i]);
            }
        }
        
        me.questionsComplete = tot;
    //   this.questionIndex = 1;
		if (me.questionsComplete >= 17) {
			this.questionIndex = 1;
		}
        this.subtitle = new app.views.Subtitle({
            label: getString("ProfileScreen_Subtitle", 1)
        });

        this.bg = new app.views.ButtonGroup({
            options: [], extraMargin: "20 20 0 20"
        });
        this.na = new app.views.ButtonGroup ( {
        	 options: [], extraMargin: "20 20 0 20"
        });
        this.bg.on('item_selected', function () {
			me.na.clearAll ();
            try {
                Ext.getCmp('submit').show();
                Ext.getCmp('submit').doLayout();
                try {
                setTimeout (function () {Ext.getCmp('submit').doLayout();},100);
                } catch (e) {}
                
            } catch (e) {
                	console.log ("An error was recorded adding listeners to the submit button: " + e.message);
            }


        });
        this.na.on('item_selected', function () {
			me.bg.clearAll ();
            try {
                Ext.getCmp('submit').show();
                Ext.getCmp('submit').doLayout();
                try {
                setTimeout (function () {Ext.getCmp('submit').doLayout();},100);
                } catch (e) {}
                
            } catch (e) {
                	console.log ("An error was recorded adding listeners to the submit button: " + e.message);
            }


        });


        //put instances of cards into viewport
        Ext.apply(this, {
            scroll: "vertical",
            dockedItems: [
            new app.views.Title({

                items: [{
                    xtype: 'spacer'
                }, {
                    id: 'save',
                    text: getString("ProfileScreen_Button_Save"),
                    ui: 'action',
                    listeners: {
                        'tap': function () {
							
							
							
							if (me.questionsComplete < me.questionIndex) {
                                me.questionsComplete = me.questionIndex;
                            }
                            if (Ext.getCmp("homePanel")) {
                                Ext.getCmp("homePanel").updateProfileSection();
                            }
                            if (me.bg.answer != -1 && me.na.answer != -1) {
                            app.currentUser.data["q" + me.questionIndex] = (me.bg.answer == -1 ? 0 : me.bg.answer);
                            app.currentUser.save();

                            if (window.navigator.onLine) {
                                var params = {
                                    action: "update_profile",
                                    token: app.currentUser.data.token,
                                    user_id: app.currentUser.data.web_id
                                }
                                params["q" + me.questionIndex] = (me.bg.answer == -1 ? 0 : me.bg.answer);
                                Ext.Ajax.request({
                                    url: apiURL,
                                    method: "POST",
                                    params: params,
                                    success: function (result) {
                                        var jsonData = Ext.util.JSON.decode(result.responseText);
                                        if (jsonData.statuscode == 200) {
                                            //	console.log ("SAVED PROFILE");
                                        } else {
                                            //	console.log ("PROFILE SAVE ERROR " + jsonData.statusmessage);
                                        }
                                    },
                                    failure: function (e) {
                                        console.log("PROFILE WAS NOT SAVED");
                                    }

                                });
                            }
							}
							
							
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'showHome',
                                animation: false
                            });

                        }
                    }
                }]





            }),

            this.subtitle

            ,
            {
                dock: "bottom",
                xtype: "panel",
                cls: "profile_update_progress",
                padding: "6 10 0 10",
                layout: {
                    type: "hbox"
                },
                items: [{
                    html: "<p>" + getString("ProfileScreen_Label_Progress") + "</p>",
                    margin: "0 10 0 0"
                }, {
                    flex: 10,
                    margin: "10 0 0 0",
                    html: "<div class='img_container'><img src='resources/images/bgtiles/progress-bg.png' class='progress-bg'/><img src='resources/images/bgtiles/progress.png' id='progressImg' class='progress'/><img src='resources/images/bgtiles/progress-overlay.png' class='progress-overlay'/></div>"
                }],
                height: 37,



            }

            ],

            items: [

            {
                cls: "question",
                padding: "0 0 0 0",
                margin: '20 20 0 20',
                id: "questionText",
                height:"auto",
            },
            this.bg,
            this.na,
            
            {
                cls: "buttonGroup",
                margin: "14 20 0 20",
                id: "submit",
                items: [{
                    xtype: "button",
                    text: getString("ProfileScreen_Button_Submit"),
                    cls: "groupbutton pinkSubmit",
                    listeners: {

                        'tap': function () {
                            if (me.questionsComplete < me.questionIndex) {
                                me.questionsComplete = me.questionIndex;
                            }
                            if (Ext.getCmp("homePanel")) {
                                Ext.getCmp("homePanel").updateProfileSection();
                            }
                            
                            var answer = me.bg.answer;
                            if (answer == -1) {
                            	answer = me.na.answer;
                            }
                            if (answer == -1) {
                            	
                            }
                           
                            app.currentUser.data["q" + me.questionIndex] = answer;
                            app.currentUser.save();

                            if (window.navigator.onLine) {
                                var params = {
                                    action: "update_profile",
                                    token: app.currentUser.data.token,
                                    user_id: app.currentUser.data.web_id
                                }
                                params["q" + me.questionIndex] = (me.bg.answer == -1 ? 0 : me.bg.answer);
                                Ext.Ajax.request({
                                    url: apiURL,
                                    method: "POST",
                                    params: params,
                                    success: function (result) {
                                        var jsonData = Ext.util.JSON.decode(result.responseText);
                                        if (jsonData.statuscode == 200) {
                                            //	console.log ("SAVED PROFILE");
                                        } else {
                                            //	console.log ("PROFILE SAVE ERROR " + jsonData.statusmessage);
                                        }
                                    },
                                    failure: function (e) {
                                        console.log("PROFILE WAS NOT SAVED");
                                    }

                                });
                            }

                            me.questionIndex++;
                            if (me.questionIndex <= 17) {
                                me.renderQuestion(me.questionIndex);
                            } else {
                                Ext.dispatch({
                                    controller: app.controllers.asthmaController,
                                    action: 'showHome',
                                    animation: false
                                });
                            }
                        }
                    }
                }]

            }





            ]
        });



        app.views.ProfileScreen.superclass.initComponent.apply(this, arguments);

        this.on({

            hide: function (component) {
                component.destroy();
            },
            activate: function () {
            
            	if (!window.navigator.onLine) {

                    Ext.Msg.show({
                        title: '',
                        msg: getString("GenericError_Popup_ConnectionFail"),
                        buttons: [{
                            text: getString("GenericError_Popup__Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }],
                        fn: function () {
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'showHome',
                                animation:false
                            });
                        }
                    });
                    
                }
                
                
                try {
                    this.renderQuestion(this.questionIndex);
                } catch (e) {
                    console.log("An error was recorded rendering question within the activate handler: " + e.message);
                }
                //console.log ("SHOW");
            }
        });


    }
});