app.views.Register = Ext.extend(Ext.Panel, {
    fullscreen: true,
    cardSwitchAnimation: 'flip',
    cls: 'register',
    scroll: "vertical",
    agree: function () {
        //    	alert ("AGREE YEAH!");
        Ext.getCmp("acceptTermsCheckbox").check();
    },

    initComponent: function () {
        var me = this;
        if (app.views.register) {
            app.views.register.destroy();
            app.views.register = null;
        }
        app.views.register = this;
        this.ran = Math.random();
        this.townid = app.currentUser.data.chosen_town == 1 ? app.currentUser.data.nearest_town : -1;
        me.townname = app.currentUser.data.town;
        
        var updateLocation = function (data) {
                me.townid = data.cityid;
                me.townname = data.cityname;
                Ext.getCmp("townField").setValue(data.cityname);
            }
        var doneRegister = function () {
                app.controllers.asthmaController.resetMain();
                registered = true;
                
                app.currentUser.acts().filter("submitted", 0);
	            app.currentUser.acts().each (function (record) {
	            	app.models.sendACTToServer (record);
	            });
	            
	            app.currentUser.acts().clearFilter();
	            
	            
	             app.currentUser.moods().filter("submitted", 0);
	            app.currentUser.moods().each (function (record) {
	           		// alert ("SENDING MOOD TO SERVER");
	            	app.models.sendMoodToServer (record);
	            });
	            
	            
	            
	            app.currentUser.moods().clearFilter();
	            
	            addDeviceKeyToUser (app.currentUser.data.device_token);
				if (app.views.moodSelector) {
					app.views.moodSelector.sortToday ();							
				}            
                if (me.callback && me.callback.call) {
                    me.callback.call(me.callbackObj);
                }
                app.models.loadMessages ();
                
                if (isHCP) {
                	 Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'showMain',
                                previousScreen: me,

                            });
                            return;
                }
                Ext.Msg.show({
                    title: '',
                    msg: getString("PostRegister_Popup"),
                    buttons: [{
                        text: getString("PostRegister_Popup_NotNow"),
                        id: "notnow",
                        itemId: "notnow",
                        cls: "cancelBtn "
                    }, {
                        text: getString("PostRegister_Popup_AddProfile"),
                        id: "addprofile",
                        itemId: "addprofile",
                        cls: "okBtn "
                    }],
                    fn: function (a, b, c) {
						var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                        if (a == "addprofile") {
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'updateProfile',
                                previousScreen: me,
                                animation: false

                            });
                        } else {
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'showMain',
                                previousScreen: me,

                            });
                        }
                    }
                });
            }
        var tryToRegister = function () {
                var name = Ext.getCmp("namefield").getValue();
                var age = Ext.getCmp("agefield").getValue();
                var status = Ext.getCmp ("statusfield").getValue ();
                var townname = Ext.getCmp("townField").getValue();
                var town_id = me.townid;
                var email = Ext.getCmp("emailfield").getValue();
                var retypeemail = Ext.getCmp("retypeemailfield").getValue();
                var password = Ext.getCmp("passwordfield").getValue();
                var retypepassword = Ext.getCmp("retypepasswordfield").getValue();
                var via = Ext.getCmp("viaselect").getValue();


                if ((app.currentUser.data.type == 1 && age == "") || (app.currentUser.data.type == 3 && status == "") || name == "" || town_id == -1 || email == "" || retypeemail == "" || password == "" || retypepassword == "" || via == -1) {
                    // error, must complete all fields...
                    Ext.Msg.show({
                        title: '',
                        msg: getString("RegisterScreen_ErrorPopup_CompleteFields"),
                        buttons: [{
                            text: getString("RegisterScreen_ErrorPopup_Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }]

                    });
                    return;
                }
                if (email.lastIndexOf("@") > email.length - 4 || email.lastIndexOf("@") < 1 || email.indexOf(".") < 0) {
                    // error, invalid email
                    Ext.Msg.show({
                        title: '',
                        msg: getString("RegisterScreen_ErrorPopup_InvalidEmail"),
                        buttons: [{
                            text: getString("RegisterScreen_ErrorPopup_Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }]

                    });
                    return;
                }
                if (email != retypeemail) {
                    // error, emails dont match
                    Ext.Msg.show({
                        title: '',
                        msg: getString("RegisterScreen_ErrorPopup_EmailsDontMatch"),
                        buttons: [{
                            text: getString("RegisterScreen_ErrorPopup_Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }]

                    });
                    return;
                }
                if (password.length < 6) {
                    // error, password too short
                    Ext.Msg.show({
                        title: '',
                        msg: getString("RegisterScreen_ErrorPopup_InvalidPassword"),
                        buttons: [{
                            text: getString("RegisterScreen_ErrorPopup_Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }]

                    });
                    return;
                }

                if (password != retypepassword) {
                    // error, passwords dont match
                    Ext.Msg.show({
                        title: '',
                        msg: getString("RegisterScreen_ErrorPopup_PasswordsDontMatch"),
                        buttons: [{
                            text: getString("RegisterScreen_ErrorPopup_Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }]

                    });
                    return;
                }
                if (!Ext.getCmp("acceptTermsCheckbox").isChecked()) {
                    Ext.Msg.show({
                        title: '',
                        msg: getString("RegisterScreen_ErrorPopup_AcceptTerms"),
                        buttons: [{
                            text: getString("RegisterScreen_ErrorPopup_Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }]

                    });
                    return;
                }

                Ext.Ajax.request({
                    url: apiURL,
                    method: "POST",
                    params: {
                        action: "register",
                        name: name,
                        country: app.currentUser.data.country_id,
                        nearest_town: town_id,
                        email: email,
                        retype_email: retypeemail,
                        password: password,
                        retype_password: retypepassword,
                        platform: 2,
                        how_found_my_asthma: via,
                        age: isHCP ? status : age,
                        user_type: app.currentUser.data.type,
                        language:app.currentUser.data.language
                    },
                    success: function (result) {
                        var jsonData = Ext.util.JSON.decode(result.responseText);
                        if (jsonData.statuscode == 200) {
                            // all good
                            registered = true;
                            app.currentUser.data.name = name;
                            app.currentUser.data.nearest_town = town_id;
                            app.currentUser.data.town = me.townname;
                            app.currentUser.data.email = email;
                            app.currentUser.data.age = age;
                            app.currentUser.data.how_found_my_asthma = via;
                            app.currentUser.data.token = jsonData.data.token;
                            app.currentUser.data.web_id = jsonData.data.user_id;
                            app.currentUser.save();

                            doneRegister();
                        } else {

                            var msg = getString("RegisterScreen_ErrorPopup_GenericError")
                            switch (jsonData.statuscode) {
                            case -5:
                                msg = getString("RegisterScreen_ErrorPopup_AlreadyRegistered");

                                break;
                            }
                            Ext.Msg.show({
                                title: '',
                                msg: msg,
                                buttons: [{
                                    text: getString("RegisterScreen_ErrorPopup_Close"),
                                    id: "notnow",
                                    itemId: "notnow",
                                    cls: "okBtn wide"
                                }]

                            });

                        }
                    },
                    failure: function (e) {
                        Ext.Msg.show({
                            title: '',
                            msg: getString("GenericError_Popup_ConnectionFail"),
                            buttons: [{
                                text: getString("GenericError_Popup__Close"),
                                id: "notnow",
                                itemId: "notnow",
                                cls: "okBtn wide"
                            }]

                        });
                    }

                });



            }


        Ext.apply(this, {
            scroll: "vertical",

            dockedItems: [



            new app.views.Title({
                items: [{
                    id: 'cancel',
                    text: getString("Generic_Button_Back"),
                    ui: 'back',
                    listeners: {
                        'tap': function () {
                        	if (document.activeElement && document.activeElement.blur) {
							    	document.activeElement.blur();
							   }
                            //console.log (me.previousScreen);
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'revertTo',
                                item: me.previousScreen,
                                animation:false                            });
                        }
                    }
                }

                ]
            }),


            new app.views.Subtitle({
                label: getString("RegisterScreen_Subtitle")
            })

            ],
            items: [




            {
                title: 'Basic',
                xtype: 'form',
                id: 'basicform',
                items: [{
                    cls: "register_text",
                    margin:"0 0 0 0",
                    id: "registerIntro",
                    html: getString("RegisterScreen_Intro")

                }, {
                    xtype: 'fieldset',
                    defaults: {
                        // labelAlign: 'right'
                        labelWidth: '35%'

                    },
                    items: [{
                        xtype: 'textfield',
                        name: 'name',
                        id: 'namefield',
                        label: getString("RegisterScreen_FormLabel_Name"),
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Name"),
                        autoCapitalize: false,
                        useClearIcon: true
                    }, {
                        xtype: 'listselectfield',
                        hidden: app.currentUser.data.type !=1,
                        name: 'age',
                        id: 'agefield',
                        label: getString("RegisterScreen_FormLabel_Age"),
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Generic"),
                        autoCapitalize: false,
                        value: '-1',
                        autoSelectDefault: false,
                        listeners: {
                            change: function () {
                                if (this.value == 1) {
                                    Ext.Msg.show({
                                        title: '',
                                        msg: getString("RegisterScreen_Under12Popup"),
                                        buttons: [{
                                            text: getString("RegisterScreen_Under12Popup_Cancel"),
                                            id: "close",
                                            itemId: "close",
                                            cls: "cancelBtn "
                                        }, {
                                            text: getString("RegisterScreen_Under12Popup_Continue"),
                                            id: "continue",
                                            itemId: "continue",
                                            cls: "okBtn "
                                        }],
                                        fn: function (a, b, c) {

                                            if (a == "continue") {
                                                window.open(getString("RegisterScreen_Under12_ExternalLink"));
                                            }
                                        }
                                    });
                                }

                            }

                        },
                        index: -1,
                        options: [{
                            value: 1,
                            text: getString("RegisterScreen_Values_Age1")
                        }, {
                            value: 2,
                            text: getString("RegisterScreen_Values_Age2")
                        }, {
                            value: 3,
                            text: getString("RegisterScreen_Values_Age3")
                        }, {
                            value: 4,
                            text: getString("RegisterScreen_Values_Age4")
                        }, {
                            value: 5,
                            text: getString("RegisterScreen_Values_Age5")
                        }

                        ]
                    }, {
                        xtype: 'listselectfield',
                        hidden: app.currentUser.data.type !=3,
                        name: 'professional_status',
                       
                         id: 'statusfield',
                        label: getString("RegisterScreen_FormLabel_ProfessionalStatus"),
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Generic"),
                        autoCapitalize: false,
                        value: '-1',
                        autoSelectDefault: false,
                         index: -1,
                        options: [{
                            value: 1,
                            text: getString("RegisterScreen_Values_ProfessionalStatus1")
                        }, {
                            value: 2,
                            text: getString("RegisterScreen_Values_ProfessionalStatus2")
                        }, {
                            value: 3,
                            text: getString("RegisterScreen_Values_ProfessionalStatus3")
                        }, {
                            value: 4,
                            text: getString("RegisterScreen_Values_ProfessionalStatus4")
                        }

                        ]
                    }, {
                        xtype: 'textfield',
                        name: 'town',
                        id: 'townField',
                        disabled: true,
                        value: app.currentUser.data.chosen_town == 1 ? app.currentUser.data.town : "",
                        label: getString("RegisterScreen_FormLabel_Town"),
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Generic"),
                        autoCapitalize: false,
                        useClearIcon: true,
                        listeners: {
                            el: {
                                'tap': function (a, b, c, d) {

                                    //alert ("TOWN TOWN "  + me.ran);
                                    //	console.log ('tap',a,b,c,d);
                                    document.activeElement.blur();
                                    Ext.dispatch({
                                        controller: app.controllers.asthmaController,
                                        action: 'chooseTown',
                                        previousScreen: me,
                                        callback: updateLocation,
                                        callbackObj: me,
                                        animation: false                                    });
                                }
                            }

                        }
                    }


                    ]
                },

                {
                    xtype: 'fieldset',
                    defaults: {
                        // labelAlign: 'right'
                        labelWidth: '35%'
                    },
                    items: [{
                        xtype: 'emailfield',
                        name: 'email',
                        id: 'emailfield',
                               cls: 'tall',
                        label: getString("RegisterScreen_FormLabel_Email"),
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Email"),
                        autoCapitalize: false,
                        useClearIcon: true
                    }, {
                        xtype: 'emailfield',
                        name: 'retype_email',
                        id: 'retypeemailfield',
                        cls: 'taller',
                        label: getString("RegisterScreen_FormLabel_RetypeEmail"),
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Email"),
                        autoCapitalize: false,
                        useClearIcon: true
                    }, {
                        xtype: 'passwordfield',
                        name: 'passwordfield',
                        id: 'passwordfield',
                        label: getString("RegisterScreen_FormLabel_Password"),
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Generic"),
                        autoCapitalize: false,
                        useClearIcon: true
                    }, {
                        xtype: 'passwordfield',
                        name: 'password_field',
                        id: 'retypepasswordfield',
                        cls: 'taller',
                        label: getString("RegisterScreen_FormLabel_RetypePassword"),
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Generic"),
                        autoCapitalize: false,
                        useClearIcon: true
                    }]

                },

                {
                    cls: "register_text",
                    html: getString("RegisterScreen_WhereInstruct")
                }

                , {
                    xtype: 'fieldset',
                    defaults: {
                        // labelAlign: 'right'
                        labelWidth: '0%'
                    },
                    items: [{
                        xtype: 'listselectfield',
                        name: 'via',
                        id: 'viaselect',
                        label: false,
                        placeHolder: getString("RegisterScreen_FormPlaceholder_Generic"),
                        autoCapitalize: false,
                        value: '-1',
                        autoSelectDefault: false,
                        index: -1,
                        options: isHCP ?  [{
                            value: 1,
                            text: getString("RegisterScreen_Values_Via1_HCP")
                        }, {
                            value: 2,
                            text: getString("RegisterScreen_Values_Via2_HCP")
                        }, {
                            value: 3,
                            text: getString("RegisterScreen_Values_Via3_HCP")
                        }, {
                            value: 4,
                            text: getString("RegisterScreen_Values_Via4_HCP")
                        }, {
                            value: 5,
                            text: getString("RegisterScreen_Values_Via5_HCP")
                        }

                        ] :  [{
                            value: 1,
                            text: getString("RegisterScreen_Values_Via1")
                        }, {
                            value: 2,
                            text: getString("RegisterScreen_Values_Via2")
                        }, {
                            value: 3,
                            text: getString("RegisterScreen_Values_Via3")
                        }, {
                            value: 4,
                            text: getString("RegisterScreen_Values_Via4")
                        }

                        ]
                    }]

                }, {
                    cls: "register_text",
                    html: "<b>" + getString("RegisterScreen_TermsInstruct") + "</b>",
                    listeners: {
                        el: {
                            tap: function () {

                                Ext.dispatch({
                                    controller: app.controllers.asthmaController,
                                    action: 'showRegTerms',
                                    previousScreen: me,
                                    animation:false                                });
                            }
                        }
                    }
                }

                , {
                    xtype: 'fieldset',

                    defaults: {
                        // labelAlign: 'right'
                        labelWidth: '55%'
                    },
                    items: [{
                        xtype: 'checkboxfield',
                        name: 'accept',
                            cls: 'tall',
                            label: getString("RegisterScreen_FormLabel_Terms"),
                        id: "acceptTermsCheckbox",
                         listeners:{
					        labelEl:{
					           tap:function(){
					           
					              var obj = Ext.getCmp('acceptTermsCheckbox');
					             if(obj.isChecked()){
					                    obj.uncheck();
					              }else{
					                    obj.check();
					              }
					           }
					        }
					    }
                    }]

                }

                , {
                    ui: 'button-light-blue generic-button',
                    margin: '18 5 0 5',
                    cls: 'asthma-button',
                    xtype: "button",
                    flex: 1,
                    text: getString("RegisterScreen_Button_Register"),
                    listeners: {
                        'tap': function () {

                            tryToRegister()
                        }
                    }
                },

                ]
            },
            new app.views.AlreadyRegistered({
                parentPanel: me
            }),

            ]

        });
        app.views.Register.superclass.initComponent.call(me);
		this.on ({
			
		});
        if (false) {
            Ext.getCmp("agefield").hide();
        } else {
            Ext.getCmp("registerIntro").hide();
        }
    }



});