app.views.Settings = Ext.extend(Ext.Panel, {
    fullscreen: true,
    cardSwitchAnimation: 'flip',
    cls: 'settings',
    scroll: "vertical",
    layout: {
        type: "vbox",
        align: "stretch",
    },
    initComponent: function () {
        var me = this;

        this.freq = new app.views.ButtonGroup({
            extraID: "freq",
            extraMargin: "0 30 0 30"
        });

        if (app.views.login) {
            app.views.login.destroy();
        }
        app.views.login = this;
        Ext.apply(this, {
            scroll: "vertical",

            dockedItems: [


            new app.views.Title({

                items: [{
                    xtype: 'spacer'
                }, {
                
                    id: 'save',
                    text: getString("SettingsScreen_Button_Save"),
                    ui: 'action2',
                    listeners: {
                        'tap': function () {
                        var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 1000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
							var newAnswer = (me.freq.answer);
							if (newAnswer != app.currentUser.data.frequency) {
								app.stores.updateUserPrefs (newAnswer);
							}
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'showHome',
                                animation: false
                            });

                        }
                    }
                }]





            }),

            new app.views.Subtitle({
                label: getString("SettingsScreen_Subtitle")
            })

            ,

            ],


        });
        app.views.Settings.superclass.initComponent.call(me);
        setTimeout(function () {
            me.beginComponent.apply(me, arguments);
        }, 10);

        this.on({

            hide: function (component) {
                component.destroy();

            },

            activate: function () {

                if (!window.navigator.onLine) {

                    Ext.Msg.show({
                        title: '',
                        msg: getString("GenericError_Popup_ConnectionFail"),
                        buttons: [{
                            text: getString("GenericError_Popup__Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }],
                        fn: function () {
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'showHome',

                                animation: false
                            });
                        }
                    });
                }
            }
        });
    },
    beginComponent: function () {
        var me = this;
        var items = [{
            html: getString("SettingsScreen_FrequencyOfMessages"),
            margin: '20 20 10 20',
        },
        this.freq,


        {
            ui: 'button-light-blue generic-button',
            margin: '15 30 0 30',
            cls: 'asthma-button',
            xtype: "button",
            height: 58,
            text: getString("SettingsScreen_Button_Terms"),
            listeners: {
                'tap': function () {
                var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                    Ext.dispatch({
                        controller: app.controllers.asthmaController,
                        action: 'showEula',
                        previousScreen: me,
                        animation: false                    });
                }
            }
        }, {
            ui: 'button-red generic-button',
            margin: '10 30 18 30',
            cls: 'asthma-button',
            xtype: "button",
            height: 58,
            text: getString("SettingsScreen_Button_DeleteAccount"),
            listeners: {
                'tap': function () {
                var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                    if (!window.navigator.onLine) {

                        Ext.Msg.show({
                            title: '',
                            msg: getString("GenericError_Popup_ConnectionFail"),
                            buttons: [{
                                text: getString("GenericError_Popup__Close"),
                                id: "notnow",
                                itemId: "notnow",
                                cls: "okBtn wide"
                            }],
                            fn: function () {
                                Ext.dispatch({
                                    controller: app.controllers.asthmaController,
                                    action: 'showHome',

                                    animation: false
                                });
                            }
                        });
                        return;
                    }

                    Ext.Msg.show({
                        title: '',
                        msg: "<b>" + getString("DeleteTerms_Popup_Title") + "</b><br/>" + getString("DeleteTerms_Popup_Text"),
                        height: 160,
                        buttons: [{
                            text: getString("DeleteTerms_Popup_Cancel"),
                            itemId: "no",
                            cls: "cancelBtn"
                        }, {
                            text: getString("DeleteTerms_Popup_Delete"),
                            itemId: "yes",
                            cls: "okBtn redbg"
                        }],
                        fn: function (a, b, c) {
                        var newclick = new Date().getTime ();
                		if (this.lastclick && newclick - this.lastclick < 2000) {
                			this.lastclick = newclick;
                			return;
                		}
                		this.lastclick = newclick;
                            if (a == "yes") {
                            if (registered) {
								 Ext.Ajax.request({
						            url: apiURL,
						            method: "POST",
						            params: {
						                action: "delete_account",
						                token: app.currentUser.data.token,
						                user_id: app.currentUser.data.web_id,
						                
						            },
						            success: function (result) {
						            	
						                
						               
						            },
						            failure: function (e) {
										
						            }
						
						        });
                                app.stores.resetUser();
                                setTimeout (function () { app.stores.beginEverything();}, 300);
                            }
                            else {
                            	app.stores.resetUser();
                                setTimeout (function () { app.stores.beginEverything();}, 300);
                            }
                            
                            }
                        }
                    });





                }
            }
        }


        ];

        var options = [];
        options.push({
            id: 1,
            text: getString("SettingsScreen_Frequency_Option1")
        });
        options.push({
            id: 2,
            text: getString("SettingsScreen_Frequency_Option2")
        });
        options.push({
            id: 3,
            text: getString("SettingsScreen_Frequency_Option3")
        });
        options.push({
            id: 4,
            text: getString("SettingsScreen_Frequency_Option4")
        });

        this.freq.renderQuestions(options);
        for (var i = 0; i < items.length; i++) {
            this.add(items[i]);
        }
        //alert (app.currentUser.data.frequency);
        this.freq.setAnswer("freq-opt-" + app.currentUser.data.frequency);

        this.doLayout();


    }



});