app.views.TownChoice = Ext.extend(Ext.Panel, {
    cls: 'library_screen',

    id: "townChoice",

    layout: {
        type: "vbox",
        align: "center",

    },
    width: "100%",
    defaults: {

    },
    getItemTemplate: function () {
        return '<div class="library_item">{cityname}</div>';
    },


    scroll: false,
    initComponent: function () {
        var me = this;

		if (app.views.townChoice) {
			app.views.townChoice.destroy ();
			app.views.townChoice = null;
		}
		app.views.townChoice = this;
        Ext.regModel('Town', {
            fields: ['id', 'cityname'],
        });

        this.subtitle = new app.views.SearchSubtitle({
            label: getString("TownChoice_Subtitle")
        });

        this.subtitle.on({
            'search_changed': function () {

                doFilter(me.subtitle.getSearch());
            }

        })

        if (!window.navigator.onLine) {

            //put instances of cards into viewport
            Ext.apply(this, {
                               defaults: {
                    align: "center"
                },
                dockedItems: [
                new app.views.Title({
                    items: [{
                        text: getString("Generic_Button_Cancel"),
                        ui: 'back',
                        listeners: {
                            'tap': function () {
                                Ext.dispatch({
                                    controller: app.controllers.asthmaController,
                                    action: 'revertTo',
                                    item: me.previousScreen,
                                    animation:false                                });
                            }
                        }
                    }]
                }), me.subtitle



                ],
                items: []

            }



            );






        } else {
            var ListStore = new Ext.data.Store({
                id: 'ListStore',
                autoLoad: false,
                fields: ['id', 'cityname', 'countryname', 'cityid'],
                proxy: {
                    limitParam: null,
                    abort:function () {try {Ext.Ajax.abort(this.lastRequest);} catch (e) {}},
                    doRequest:function(operation, callback, scope) {
    
        var writer  = this.getWriter(),
            request = this.buildRequest(operation, callback, scope);
            
        if (operation.allowWrite()) {
            request = writer.write(request);
        }
        
        Ext.apply(request, {
            headers       : this.headers,
            timeout       : this.timeout,
            scope         : this,
            callback      : this.createRequestCallback(request, operation, callback, scope),
            method        : this.getMethod(request),
            disableCaching: false // explicitly set it to false, ServerProxy handles caching
        });
       
        this.lastRequest =Ext.Ajax.request(request);
        
        return request;
    },

                    extraParams: {
                        limit: 10,
                        country: 484,
                        action: "get_cities"
                    },

                    type: 'ajax',
                    url: apiURL,
                    reader: {
                        type: 'json'
                    }
                },
                listeners: {
                    load: function () {

                    }



                }

            });




            this.listpanel = new Ext.List({
                flex: 1,
                id: 'townlist',
                store: ListStore,
                displayField: "title",
                loadingText: null,
                width: "100%",
                itemTpl: me.getItemTemplate(),
                listeners: {
                    itemtap: function (obj, index) {
                        me.subtitle.loseFocus();
                        
                        if (me.callback) {
                            me.callback.call(me.callbackObj, obj.store.getAt(index).data);
                        }
                        Ext.dispatch({
                            controller: app.controllers.asthmaController,
                            action: 'revertTo',
                            item: me.previousScreen,
                            animation: false
                        });

                    },
                }



            });




            var doFilter = function (str) {
					if (!ListStore){
						return;
					}
					
					if (ListStore.loading) {
						ListStore.getProxy().abort();
							
					}	
                    ListStore.proxy.url = apiURL + "?filter=" + str;
                    if (str != "") {
	                    ListStore.read();
	                   } else {
	                   	ListStore.removeAll ();
	                   }
                    me.listpanel.scroller.scrollTo({
                        x: 0,
                        y: 0
                    });
                    return;

                    clearFilter();
                    ListStore.filter(function (object) {
                        return (object.data.title.toLowerCase().indexOf(str.toLowerCase()) >= 0);
                    });
                }

            var clearFilter = function () {
                    ListStore.clearFilter(false);
                }



                //put instances of cards into viewport
                Ext.apply(this, {
                                        defaults: {
                        align: "center"
                    },
                    dockedItems: [
                    new app.views.Title({
                        items: [{
                            text: getString("Generic_Button_Cancel"),
                            ui: 'back',
                            listeners: {
                                'tap': function () {
                                    Ext.dispatch({
                                        controller: app.controllers.asthmaController,
                                        action: 'revertTo',
                                        item: me.previousScreen,
                                        animation: false                                    });
                                }
                            }
                        }]
                    }), me.subtitle



                    ],

                    xtype: "panel",

                    items: [



                    me.listpanel


                    ]

                }



                );




        }

        this.on({

            deactivate: function (component) {
                //alert ("DEACT");
                if (this.subtitle) {
                //	this.subtitle.cleanUp ();
                }
                if (app.views.townChoice) {
					//app.views.townChoice.destroy ();
					app.views.townChoice = null;
				}
                component.destroy();
            },

            activate: function (component) {
            	
                if (!window.navigator.onLine) {

                    Ext.Msg.show({
                        title: '',
                        msg: getString("GenericError_Popup_ConnectionFail"),
                        buttons: [{
                            text: getString("GenericError_Popup__Close"),
                            id: "notnow",
                            itemId: "notnow",
                            cls: "okBtn wide"
                        }],
                        fn: function () {
                            Ext.dispatch({
                                controller: app.controllers.asthmaController,
                                action: 'revertTo',
                                item: me.previousScreen,
                                animation:false                            });
                        }
                    });
                }
            }
        });


        //  Ext.Msg.confirm ("Hello","Really?",Ext.emptyFn);
        app.views.TownChoice.superclass.initComponent.apply(this, arguments);
    }
});