function CSVToArray( strData, strDelimiter ){
		// Check to see if the delimiter is defined. If not,
		// then default to comma.
		strDelimiter = (strDelimiter || ",");
 
		// Create a regular expression to parse the CSV values.
		var objPattern = new RegExp(
			(
				// Delimiters.
				"(\\" + strDelimiter + "|\\r?\\n|\\r|^)" +
 
				// Quoted fields.
				"(?:\"([^\"]*(?:\"\"[^\"]*)*)\"|" +
 
				// Standard fields.
				"([^\"\\" + strDelimiter + "\\r\\n]*))"
			),
			"gi"
			);
 
 
		// Create an array to hold our data. Give the array
		// a default empty first row.
		var arrData = [[]];
 
		// Create an array to hold our individual pattern
		// matching groups.
		var arrMatches = null;
 
 
		// Keep looping over the regular expression matches
		// until we can no longer find a match.
		while (arrMatches = objPattern.exec( strData )){
 
			// Get the delimiter that was found.
			var strMatchedDelimiter = arrMatches[ 1 ];
 
			// Check to see if the given delimiter has a length
			// (is not the start of string) and if it matches
			// field delimiter. If id does not, then we know
			// that this delimiter is a row delimiter.
			if (
				strMatchedDelimiter.length &&
				(strMatchedDelimiter != strDelimiter)
				){
 
				// Since we have reached a new row of data,
				// add an empty row to our data array.
				arrData.push( [] );
 
			}
 
 
			// Now that we have our delimiter out of the way,
			// let's check to see which kind of value we
			// captured (quoted or unquoted).
			if (arrMatches[ 2 ]){
 
				// We found a quoted value. When we capture
				// this value, unescape any double quotes.
				var strMatchedValue = arrMatches[ 2 ].replace(
					new RegExp( "\"\"", "g" ),
					"\""
					);
 
			} else {
 
				// We found a non-quoted value.
				var strMatchedValue = arrMatches[ 3 ];
 
			}
 
 
			// Now that we have our value string, let's add
			// it to the data array.
			arrData[ arrData.length - 1 ].push( strMatchedValue );
		}
 
		// Return the parsed data.
		return( arrData );
	}
	
	
var getString = function (id,replace,suppress,replace2) {
	if (isHCP) {
		if (strings[id+"_HCP"]) {
			var val = strings[id+"_HCP"];
			if (replace) {
				val = val.split ("%%").join (replace);
				val = val.split ("@@").join (replace2);

			}
			return val;
		}
	}
	if (strings[id]) {
		var val = strings[id];
		if (replace) {
			val = val.split ("%%").join (replace);
			val = val.split ("@@").join (replace2);

		}
		return val;
	}
	
	if (!isPatient) {
		if (strings[id + "Carer"]) {
			var val = strings[id + "Carer"];
			if (replace) {
				val = val.split ("%%").join (replace);
				val = val.split ("@@").join (replace2);
			}
			return val;
		}
		if (strings[id + "_Carer"]) {
			var val = strings[id + "_Carer"];
			if (replace) {
				val = val.split ("%%").join (replace);
				val = val.split ("@@").join (replace2);
			}
			return val;
		}
	} else {
		if (strings[id + "Patient"]) {
			var val = strings[id + "Patient"];
			if (replace) {
				val = val.split ("%%").join (replace);
				val = val.split ("@@").join (replace2);
			}
			return val;
		}
		if (strings[id + "_Patient"]) {
			var val = strings[id + "_Patient"];
			if (replace) {
				val = val.split ("%%").join (replace);
				val = val.split ("@@").join (replace2);
			}
			return val;
		}
	}
	if (!suppress) {
		return "Err: " + id;
		console.log ("String [" + id + "] not found");
	}
	return "";
}

function createXMLHttpRequest() {
   try { return new XMLHttpRequest(); } catch(e) {}
   try { return new ActiveXObject("Msxml2.XMLHTTP"); } catch (e) {}
   alert("XMLHttpRequest not supported");
   return null;
 }

function onSumResponse() {
   if (xhReq.readyState != 4)  { return; }
   var serverResponse = xhReq.responseText;
   //console.log (serverResponse);
   var strings = CSVToArray (serverResponse);
   var output = "";
   output += ('var strings = {\n');
   for (var i=0;i<strings.length;i++) {
   		output += ('\t"' + strings[i][0] + '" : "' + strings[i][1].split("\"").join("\\\"").split ("\r").join ("<br/>").split ("’").join ("'") + '",\n');   }
   output += ('}');
   console.log (output);
 }




 var xhReq = createXMLHttpRequest();
 xhReq.open("GET", "bin/english_strings.csv", true);
 xhReq.onreadystatechange = onSumResponse;
 xhReq.send(null);
 