Ext.regModel ("app.models.Content", {
              fields: [
                       // this field SHOULD be your reference/primary key for the piece of content
                       // we'll be using it in the notifications, so you can direct the user to a particular piece of content in the library
                       {name : 'id', 		type : 'int'},
                       
                       // the title of the piece of content, shown in the library
                       {name : 'title',	type : 'string'},
                       
                       
                       // the body of the piece of content - just raw HTML
                       // todo - how will we handle images referenced in the HTML. These will need to be available offline...
                       {name : 'bodytext',		type : 'string'},
                       
                       // foreign key to your table of languages, so i can only show content in the current language
                       {name : 'language',	type : 'int'},
                       
                       {name : 'imagelist', type : 'array'},
                       
                       {name : 'registered_only', type: 'int'}
                       ]
              });

app.stores.content = new Ext.data.Store({
                                        model: "app.models.Content",
                                        proxy: new Ext.data.LocalStorageProxy({
                                                                              id: 'content-items'
                                                                              }),
                                        sorters: 'title'
                                        });

app.stores.syncContent = function () {
	var params = {
    action: "get_content",
    language_id: app.currentUser.data.language,
    user_id: app.currentUser.data.web_id
        
        
    };
    
    if (app.currentUser.data.last_content_sync) {
        // alert (app.currentUser.data.last_content_sync.getTime ());
     	params["since_date"] = Math.round (app.currentUser.data.last_content_sync.getTime () / 1000);
     	
    }
    Ext.Ajax.request({
                     url: apiURL,
                     method: "POST",
                     params: params,
                     success: function (result) {
                     var jsonData = Ext.util.JSON.decode(result.responseText);
                     console.log (jsonData);
                     if (jsonData.statuscode == 200) {
                     
                     app.currentUser.data.last_content_sync = new Date ();
                     app.currentUser.save ();
                     
                     for (var i=0;i<jsonData.data.length;i++) {
                     if (app.stores.content.find("id", jsonData.data[i].content_id) <0) {
                     app.stores.content.add({
                                            id: jsonData.data[i].content_id,
                                            title: jsonData.data[i].title,
                                            bodytext: unescape (jsonData.data[i].bodytext.split ("+").join (" ")),
                                            registered_only: Number(jsonData.data[i].registered_only),
                                            imagelist : jsonData.data[i].imagelist
                                            
                                            });
                     }
                     
                     }
                     
                     if (jsonData.data.length > 0) {
                     app.stores.content.sync ();
                     
                     }
                     
                     app.stores.content.sort('title', 'ASC');
                     
                     
                     }
                     },
                     failure: function (e) {
                     
                     }
                     
                     });
    
    
}



app.stores.content.load ();

var setupInitialContent = function () {
    
	var jsonc = '[{"content_id":"229","title":"Asma y embarazo","bodytext":"%3Ch1%3EAsma+y+embarazo%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEl+embarazo+ha+demostrado+tener+diferentes+efectos+sobre+el+asma.+Durante+el+embarazo%2C+alrededor+de+un+tercio+de+las+mujeres+encuentran+que+su+asma+mejora%2C+mientras+que+otro+tercio+experimenta+el+empeoramiento+de+los+s%C3%ADntomas+y+el+%C3%BAltimo+tercio+se+mantiene+sin+cambio.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESe+han+realizado+muchas+investigaciones+sobre+los+efectos+del+asma+y+los+medicamentos+contra+el+asma+durante+el+embarazo+y+en+beb%C3%A9s+nonatos.+La+salud+de+los+beb%C3%A9s+nacidos+de+madres+con+asma+bien+controlada+es+similar+a+la+de+los+nacidos+de+madres+sin+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EDurante+el+embarazo%2C+los+riesgos+principales+para+un+beb%C3%A9+nonato+provienen+de+una+madre+sin+control+de+su+asma%2C+o+con+ataques+severos+de+asma.+Si+usted+est%C3%A1+embarazada%2C+o+piensa+embarazarse%2C+es+muy+importante+hablar+con+el+profesional+de+la+salud+que+la+atiende%2C+quien+puede+recomendarle+los+pasos+a+seguir+para+controlar+su+asma.+%3Cu%3ENo+suspenda+su+medicaci%C3%B3n+regular+contra+el+asma+hasta+que+haya+consultado+al+doctor+o+enfermera+que+normalmente+vigila+su+asma.%3C%2Fu%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EUsted+deber%C3%A1+continuar+tomando+sus+medicamentos+para+el+asma+durante+el+embarazo%2C+de+acuerdo+con+las+recomendaciones+del+profesional+de+la+salud+que+la+atiende.+Es+natural+tener+dudas+e+inquietudes%2C+as%C3%AD+que+no+tema+preguntar.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EAlgunas+mujeres+se+preocupan+de+que+sus+s%C3%ADntomas+empeoren+durante+el+trabajo+de+parto%3B+sin+embargo%2C+es+raro+y+est%C3%A1+bien+usar+su+inhalador+de+alivio%2C+de+manera+normal%2C+si+lo+necesita.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EReducci%C3%B3n+de+riesgos+durante+el+embarazo%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EAqu%C3%AD+se+presentan+algunos+pasos+que+puede+tomar+para+reducir+los+riesgos+hacia+usted+y+hacia+su+beb%C3%A9+durante+el+embarazo%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EAseg%C3%BArese+de+que+su+asma+est%C3%A9+bien+controlada%2C+revis%C3%A1ndose+peri%C3%B3dicamente+con+el+profesional+de+la+salud+que+la+atiende++y+teniendo+un+plan+de+acci%C3%B3n+personal+contra+el+asma.%3C%2Fli%3E%0D%0A%3Cli%3ERevise+con+regularidad+el+control+de+su+asma%2C+realiz%C3%A1ndose+la+prueba+de+control+de+asma+o+Asthma+Control+Test+%28ACT%29.+Si+le+han+solicitado+que+realice+el+monitoreo+de+su+flujo+m%C3%A1ximo+en+casa%2C+h%C3%A1galo+tambi%C3%A9n.%3C%2Fli%3E%0D%0A%3Cli%3ESiga+tomando+sus+medicamentos+para+el+asma+como+le+indic%C3%B3+el+profesional+de+la+salud+que+la+atiende+y+su+plan+de+acci%C3%B3n+personal+contra+el+asma.%3C%2Fli%3E%0D%0A%3Cli%3EPrepare+un+plan+de+nacimiento+con+el+profesional+al+cuidado+de+la+salud+que+la+atiende+en+el+cual+se+tome+en+cuenta+su+asma%3C%2Fli%3E%0D%0A%3Cli%3ENo+fume.+Durante+el+embarazo%2C+se+sabe+que+el+fumar+tiene+efectos+da%C3%B1inos+en+el+beb%C3%A9+y+puede+incrementar+el+riesgo+de+un+beb%C3%A9+con+dificultades+para+respirar%2C+incluyendo+asma.+El+fumar+tambi%C3%A9n+es+un+detonador+de+los+ataques+de+asma+%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"230","title":"Consejos pr\u00e1cticos para tomar su medicina","bodytext":"%3Ch1%3EConsejos+pr%C3%A1cticos+para+tomar+su+medicina+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ECuando+est%C3%A1+bajo+control%2C+el+asma+no+deber%C3%ADa+afectar+su+vida+o+impedirle+hacer+cosas.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELe+deber%C3%A1n+prescribir+medicamentos+para+controlar+su+asma+y+estos+son+muy+efectivos+si+se+toman+como+se+recomienda.+Los+profesionales+de+la+salud+siguen+una+serie+de+pasos+para+encontrar+el+nivel+correcto+de+tratamiento+para+usted.+Si+sus+s%C3%ADntomas+empeoran+su+tratamiento+puede+%E2%80%98intensificarse%E2%80%99.+Pero+si+mejora%2C+usted+y+su+m%C3%A9dico+en+conjunto+pueden+considerar+bajar+el+nivel+del+tratamiento%2C+siendo+el+objetivo+tenerlo+con+la+dosis+m%C3%A1s+baja+de+medicamento+para+controlar+su+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EPor+lo+que+para+ayudar+a+que+sus+medicamentos+sean+m%C3%A1s+efectivos%2C+hay+algunos+puntos+que+usted+debe+considerar%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EConocer+las+medicinas+que+usted+est%C3%A1+tomando%2C+qu%C3%A9+hacen+y+c%C3%B3mo+tomarlas+%3C%2Fli%3E%0D%0A%3Cli%3ESi+usted+tiene+dudas+sobre+sus+medicamentos+para+el+asma%2C+no+s%C3%B3lo+deje+de+tomarlos+%E2%80%93+hable+con+su+profesional+de+la+salud+%3C%2Fli%3E%0D%0A%3Cli%3EEst%C3%A9+enterado+de+los+detonadores+de+su+asma+y+piense+sobre+usar+su+medicamento+de+manera+apropiada+para+evitar+los+s%C3%ADntomas+%3C%2Fli%3E%0D%0A%3Cli%3ENo+deje+de+tomar+su+medicamento+o+ajustar+la+dosis+sin+consultar+a+su+m%C3%A9dico+%3C%2Fli%3E%0D%0A%3Cli%3EPregunte+por+un+plan+de+acci%C3%B3n+personal+de+tratamiento+del+asma+a+su+profesional+de+la+salud.+Esto+incluye+recordatorios+de+su+medicamento+y+otros+consejos+%C3%BAtiles+sobre+c%C3%B3mo+mantener+el+asma+bajo+control.+Para+descargar+un+ejemplo+que+pueda+mostrar+a+su+profesional+de+la+salud%2C+%3Ca+href%3D%22%3Ca+href%3D%22http%3A%2F%2Fwww.asthma.org.uk%2Fall_about_asthma%2Fcontrolling_your_asthma%2Fresources_to_help_you%2Fpersonal_asthma_acti.html%22%3Epulse+aqu%C3%AD%3C%2Fa%3E%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"231","title":"Viaje y vacaciones","bodytext":"%3Ch1%3EViaje+y+vacaciones+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ECon+una+buena+preparaci%C3%B3n+y+asegurando+que+su+asma+est%C3%A1+bien+controlada%2C+no+existen+realmente+razones+para+que+el+asma+le+impida+viajar+o+programar+sus+vacaciones.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EA+continuaci%C3%B3n+algunos+consejos+pr%C3%A1cticos+que+le+podr%C3%ADan+ayudar+a+evitar+problemas.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3E%C2%BFA+d%C3%B3nde+ir%3F%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESi+su+asma+est%C3%A1+bien+controlada%2C+no+deber%C3%ADa+haber+alguna+restricci%C3%B3n+importante+sobre+su+lugar+de+destino.+No+obstante%2C+puede+desear+tomar+en+cuenta+ciertos+detonadores+que+puede+haber+tales+como+temperatura+%28ya+sea+clima+caliente+o+fr%C3%ADo%29%2C+humedad%2C+altitud+o+contaminaci%C3%B3n.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEl+clima+fr%C3%ADo+y+el+ejercicio+involucrados+en+la+pr%C3%A1ctica+del+esqu%C3%AD+pueden+desencadenar+el+asma+por+lo+que+aseg%C3%BArese+que+su+asma+est%C3%A9+bien+controlada+antes+de+ir+y+llevar+su+medicamento+de+alivio+consigo+todo+el+tiempo+en+las+pendientes.+El+mismo+consejo+aplica+para+excursionismo+de+altura.+Discuta+con+su+profesional+de+la+salud+c%C3%B3mo+se+puede+preparar+de+manera+particular+si+est%C3%A1+visitando+%C3%A1reas+remotas+o+en+d%C3%B3nde+la+provisi%C3%B3n+de+cuidados+de+la+salud+es+limitada.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEl+buceo+puede+hacer+que+el+asma+empeore+considerablemente.+No+debe+planear+bucear+en+vacaciones+sin+haberlo+discutido+con+su+doctor+primero.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EAntes+de+salir+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELa+preparaci%C3%B3n+es+clave+para+ayudarle+a+que+su+viaje+no+tenga+complicaciones.%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EEl+seguro+m%C3%A9dico+es+esencial%2C+pero+puede+ser+costoso.+Compare+para+conseguir+el+mejor+precio%2C+de+a+conocer+todos+los+hechos+relevantes+respecto+a+su+enfermedad+y+aseg%C3%BArese+de+que+su+asma+est%C3%A9+cubierta%3C%2Fli%3E%0D%0A%3Cli%3EElabore+un+plan+de+acci%C3%B3n+de+asma+personal+con+su+profesional+de+la+salud+y+piense+sobre+c%C3%B3mo+obtener+medicamentos+en+el+extranjero+si+los+necesita%3C%2Fli%3E%0D%0A%3Cli%3ETenga+un+documento+impreso+de+los+medicamentos+regulares+que+tiene+prescritos+en+caso+de+que+necesite+asistencia+m%C3%A9dica+o+pierda+su+medicamento+%3C%2Fli%3E%0D%0A%3Cli%3ELleve+suficientes+inhaladores+%28de+prevenci%C3%B3n+y+alivio%29+y+medicamento+consigo+que+dure+las+vacaciones+mas+bastante+suministro+extra+%E2%80%93+no+dependa+de+obtener+su+medicamento+en+el+lugar+de+destino%3C%2Fli%3E%0D%0A%3Cli%3EEmpaque+medicamento+de+reserva+por+separado+tanto+para+cuando+viaje+como+para+su+lugar+de+destino+%3C%2Fli%3E%0D%0A%3Cli%3EHable+con+su+profesional+de+la+salud+sobre+inmunizaciones+cuando+viaje+al+extranjero+al+menos+dos+meses+antes+de+su+viaje+%3C%2Fli%3E%0D%0A%3Cli%3ESi+viaja+dentro+de+Europa%2C+obtenga+una+Tarjeta+de+Seguro+de+Salud+Europea+%28EHIC+por+sus+siglas+en+ingl%C3%A9s%29%2C+la+cual+le+permitir%C3%A1+obtener+tratamiento+de+emergencia+aunque+puede+no+cubrir+todos+los+costos+de+tratamiento+o+repatriaci%C3%B3n+%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Ch1%3EViaje+en+avi%C3%B3n%3C%2Fh1%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3ESi+es+posible%2C+el+medicamento+se+debe+llevar+en+su+equipaje+de+mano%2C+pero+ciertas+restricciones+recientes+pueden+implicar+que+tenga+que+conseguir+un+acuerdo+previo+con+la+l%C3%ADnea+a%C3%A9rea+y+tambi%C3%A9n+obtener+una++carta+de+su+m%C3%A9dico+%3C%2Fli%3E%0D%0A%3Cli%3ESiempre+tenga+su+inhalador+de+alivio+cerca+a+la+mano.+El+viaje+en+avi%C3%B3n+no+afectar%C3%A1+de+manera+adversa+a+su+inhalador+y+los+inhaladores+son+seguros+de+usar+en+el+avi%C3%B3n%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3EUna+de+las+mejores+preparaciones+para+ir+de+vacaciones+es+tener+un+buen+control+de+su+asma+antes%2C+durante+y+despu%C3%A9s+de+su+viaje.+Hable+con+su+profesional+de+la+salud+sobre+esto+y+%C2%A1disfrute+enormemente+cuando+salga+de+viaje%21%0D%0A%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"232","title":"Detonadores del Asma","bodytext":"%3Ch1%3EDetonadores+del+Asma+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EUn+detonador+es+algo+que+causa+irritaci%C3%B3n+a+las+v%C3%ADas+respiratorias+lo+cual+en+su+momento+puede+llevar+al+asma.+Generalmente%2C+los+detonadores+no+causan+el+asma+en+s%C3%AD%2C+pero+pueden+provocar+los+s%C3%ADntomas+asociados+con+el+asma+y+pueden+causar+ataques+de+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EExisten+muchos+detonadores+diferentes+del+asma+y+la+gente+puede+ser+afectada+por+diferentes+detonadores+y+a+diferentes+grados.+Algunos+detonadores+comunes+incluyen%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EMascotas+%E2%80%93+usualmente+peludas+o+emplumadas%3C%2Fli%3E%0D%0A%3Cli%3EPolen%3C%2Fli%3E%0D%0A%3Cli%3EPolvo+y+%C3%A1caros+%3C%2Fli%3E%0D%0A%3Cli%3EInfecciones+virales+%3C%2Fli%3E%0D%0A%3Cli%3EEjercicio+%3C%2Fli%3E%0D%0A%3Cli%3EFumar+%E2%80%93+incluyendo+fumadores+pasivos+%3C%2Fli%3E%0D%0A%3Cli%3EClima+y+condiciones+atmosf%C3%A9ricas%3C%2Fli%3E%0D%0A%3Cli%3EMateriales+de+limpieza+dom%C3%A9stica+y+tareas+dom%C3%A9sticas+%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3EPara+ayudar+con+su+control+del+asma+es+importante+que+identifique+sus+detonadores+y+trate+de+evitarlos+en+la+medida+de+lo+posible.+Esto+puede+no+ser+pr%C3%A1ctico+todo+el+tiempo%2C+pero+al+menos+si+usted+sabe+qu%C3%A9+buscar%2C+puede+tener+conocimiento+de+que+sus+s%C3%ADntomas+pueden+necesitar+un+tratamiento+m%C3%A1s+cercano+en+ciertos+momentos.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EPara+algunas+personas%2C+algunos+detonadores+causan+una+reacci%C3%B3n+inmediata%2C+mientras+que+para+otros+el+detonador+puede+no+ser+instant%C3%A1neamente+aparente.+Puede+ser+una+idea+%C3%BAtil+mantener+un+diario+de+sus+s%C3%ADntomas+de+asma%2C+y+hablar+con+su+profesional+de+la+salud+sobre+c%C3%B3mo+reconocer+sus+detonadores+y+c%C3%B3mo+controlar+sus+s%C3%ADntomas.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"0"},{"content_id":"233","title":"Reconociendo los signos del asma no controlado","bodytext":"%3Ch1%3EReconociendo+los+signos+del+asma+no+controlado+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESi+su+asma+est%C3%A1+teniendo+un+impacto+en+su+estilo+de+vida%2C+restringe+sus+actividades+normales%2C+o+est%C3%A1+usando+su+inhalador+de+alivio+m%C3%A1s+de+dos+veces+a+la+semana%2C+es+muy+probable+que+su+control+del+asma+pudiera+ser+mejor.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EPonga+atenci%C3%B3n+a+sus+s%C3%ADntomas+tales+como+sibilancia%2C+dificultad+al+respirar%2C+opresi%C3%B3n+del+pecho+y+tos.+Puede+tambi%C3%A9n+experimentar+s%C3%ADntomas+en+ciertos+momentos+del+a%C3%B1o%2C+en+circunstancias+particulares+tales+como+cuando+se+hace+ejercicio+o+se+topa+con+mascotas+o+en+la+noche.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELos+s%C3%ADntomas+del+asma+nocturnos+son+un+indicador+de+un+mal+control.+La+raz%C3%B3n+por+la+que+el+asma+puede+ser+peor+en+las+noches+est%C3%A1+relacionada+con+los+cambios+en+la+actividad+de+ciertas+hormonas+en+el+cuerpo+en+la+noche+y+tambi%C3%A9n+algunas+veces+a+la+exposici%C3%B3n+a+ciertos+detonadores+%28ver+a+continuaci%C3%B3n%29.+Si+usted+tiene+s%C3%ADntomas+en+la+noche+puede+no+dormir+bien%2C+lo+cual+por+supuesto+puede+subsecuentemente+afectar+su+estado+de+%C3%A1nimo+y+niveles+de+energ%C3%ADa.+Hay+otros+factores+que+pueden+jugar+un+papel+en+el+asma+nocturno+y+que+usted+puede+tomar+medidas+que+pudieran+reducir+el+riesgo+de+s%C3%ADntomas.%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3ELos+%C3%A1caros+son+un+detonador+para+algunas+personas%2C+por+lo+que+vale+la+pena+hablar+con+su+profesional+de+la+salud+sobre+las+medidas+que+pudieran+reducir+su+exposici%C3%B3n+aunque+estas+no+siempre+funcionan%3C%2Fli%3E%0D%0A%3Cli%3ENo+permita+mascotas+en+su+rec%C3%A1mara+ya+que+su+caspa+puede+desencadenar+s%C3%ADntomas+para+algunas+personas+%3C%2Fli%3E%0D%0A%3Cli%3ESi+est%C3%A1+tomando+un+medicamento+preventivo+aseg%C3%BArese+de+que+lo+est%C3%A9+tomando+regularmente+como+fue+recomendado+por+su+profesional+de+la+salud+%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3EEs+una+buena+idea+%3Ca+href%3D%22act%22%3Eefectuar+la+Prueba+de+Control+del+Asma+%28Asthma+Control+Test%E2%84%A2%29%3C%2Fa%3E+para+averiguar+qu%C3%A9+tan+bien+est%C3%A1+siendo+controlada+su+asma+actualmente.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"0"},{"content_id":"234","title":"Clima y presi\u00f3n atmosf\u00e9rica","bodytext":"%3Ch1%3EClima+y+presi%C3%B3n+atmosf%C3%A9rica+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESe+sabe+que+diferentes+climas+y+condiciones+atmosf%C3%A9ricas+pueden+desencadenar+el+asma.+En+algunas+personas+las+temperaturas+calientes+y+fr%C3%ADas+y+los+cambios+en+presi%C3%B3n+barom%C3%A9trica+pueden+afectar+el+asma.+Las+tormentas+y+condiciones+de+viento+durante+las+cuales+el+polen%2C+polvo+y+otros+irritantes+son+dispersados+en+el+aire%2C+est%C3%A1n+tambi%C3%A9n+fuertemente+vinculados+con+el+asma+y+pueden+incluso+causar+ataques+de+asma+totales.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELa+contaminaci%C3%B3n+y+la+pobre+calidad+del+aire+pueden+tambi%C3%A9n+impactar+en+el+asma.+Por+ejemplo%2C+el+ozono+es+un+gas+creado+por+una+reacci%C3%B3n+entre+los+contaminantes%2C+tales+como++gases+de+combusti%C3%B3n+y+la+luz+solar.+Este+ozono+a+nivel+de+la+calle+se+aprecia+frecuentemente+como+%E2%80%98humo+y+neblina%E2%80%99+y+est%C3%A1+asociado+con+la+funci%C3%B3n+pulmonar+reducida+y+los+s%C3%ADntomas+del+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESi+las+condiciones+clim%C3%A1ticas+tienen+una+influencia+en+sus+s%C3%ADntomas+del+asma%2C+a+continuaci%C3%B3n+se+enlistan+algunas+ideas+que+pueden+ayudar%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EEn+temperaturas+fr%C3%ADas%2C+cubra+su+cara+con+una+bufanda+para+calentar+el+aire+alrededor+de+su+boca%3C%2Fli%3E%0D%0A%3Cli%3ESi+es+caliente+y+h%C3%BAmedo%2C+trate+de+evitar+salir+en+la+parte+m%C3%A1s+caliente+del+d%C3%ADa+%3C%2Fli%3E%0D%0A%3Cli%3ECuando+hay+tormentas%2C+mantener+las+ventanas+y+puertas+cerradas+%3C%2Fli%3E%0D%0A%3Cli%3EEn+condiciones+de+mucho+viento%2C+el+cubrir+su+boca+y+nariz+con+una+bufanda+puede+ayudar+a+reducir+el+efecto+de+los+irritantes+%3C%2Fli%3E%0D%0A%3Cli%3EPuede+ayudar+el+verificar+el+pron%C3%B3stico+del+clima+y+otras+fuentes+de+informaci%C3%B3n+sobre+la+temperatura%2C+cantidad+de+polen+y+calidad+del+aire%3C%2Fli%3E%0D%0A%3C%2Ful%3E","imagelist":[],"registered_only":"0"},{"content_id":"235","title":"Peso y asma","bodytext":"%3Ch1%3EPeso+y+asma+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESu+peso+puede+tener+un+efecto+directo+en+su+asma.+De+hecho%2C+en+pocas+palabras%2C+el+tener+sobrepeso+puede+hacer+que+sus+s%C3%ADntomas+de+asma+empeoren.+En+todas+las+personas+el+tener+sobrepeso+puede+ser+una+carga+para+los+pulmones+y+hacer+m%C3%A1s+dif%C3%ADcil+respirar+particularmente+en+el+ejercicio.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EUn+alto+%C3%ADndice+de+masa+corporal+%28IMC%29%2C+el+cual+es+un+indicador+de+obesidad%2C+est%C3%A1+asociado+con+una+frecuencia+y+severidad+incrementadas+de+los+s%C3%ADntomas+del+asma.+La+gente+que+tiene+sobrepeso+frecuentemente+tiene+menos+control+de+su+asma+y+pueden+tambi%C3%A9n+tener+una+funci%C3%B3n+pulmonar+reducida+comparada+con+aquella+con+asma+de+peso+normal.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EHay+muchas+buenas+razones+para+intentar+bajar+de+peso%2C+tanto+en+t%C3%A9rminos+de+su+bienestar+general+y+tambi%C3%A9n+para+su+asma.+Est%C3%A1+probado+que+el+perder+peso+para+la+gente+obesa+con+asma+puede+de+hecho+mejorar+su+funci%C3%B3n+pulmonar%2C+s%C3%ADntomas+y+salud+general.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EComer+sanamente+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EIntente+comer+una+dieta+balanceada+ya+que+puede+ayudar+a+controlar+su+peso.+Una+dieta+rica+en+vitaminas+y+antioxidantes+con+abundante+fruta+fresca+y+vegetales+puede+ayudar+a+mejorar+el+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EEjercicio+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EPuede+estar+preocupado+sobre+c%C3%B3mo+su+asma+pudiera+restringir+cualquier+ejercicio+o+actividad+que+quiera+realizar.+Si+su+asma+est%C3%A1+bien+controlada%2C+no+ser%C3%A1+una+barrera+para+que+realice+la+cantidad+de+ejercicio+que+sea+apropiada+para+usted.+Entonces++%C2%BFpor+qu%C3%A9+no+hablar+con+su+m%C3%A9dico+sobre+introducir+algunas+actividades+y+ejercicio+en+su+rutina+diaria%3F%0D%0A%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"236","title":"Cuando sucede un ataque","bodytext":"%3Ch1%3ECuando+sucede+un+ataque+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EUn+ataque+de+asma+usualmente+ocurre+despu%C3%A9s+de+que+los+s%C3%ADntomas+han+empeorado+durante+un+per%C3%ADodo+de+algunos+d%C3%ADas+aunque+puede+ocurrir+repentinamente+y+sin+alguna+advertencia+en+algunos+casos.+Por+supuesto+en+primer+lugar+es+siempre+mejor+tratar+de+prevenir+que+un+ataque+suceda.+Puede+ayudar+a+esto+no+ignorando+sus+s%C3%ADntomas%2C+usando+su+tratamiento+preventivo+regularmente+y+evitando+los+detonadores+potenciales.+Debe+tener+un+plan+de+acci%C3%B3n+de+asma+personal+acordado+con+su+m%C3%A9dico+que+le+dir%C3%A1+qu%C3%A9+hacer+si+sus+s%C3%ADntomas+de+asma+est%C3%A1n+empeorando.+Visite+a+su+m%C3%A9dico+tan+pronto+como+sea+posible+si+sus+s%C3%ADntomas+empeoran+y+no+tienen+un+claro+plan+acordado+con+su+m%C3%A9dico+de+c%C3%B3mo+tener+su+asma+bajo+control.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ENo+obstante%2C+a+pesar+de+tomar+precauciones%2C+puede+ocasionalmente+a%C3%BAn+experimentar+un+ataque.+Es+por+lo+tanto+importante+ser+capaz+de+reconocer+cuando+est%C3%A9+teniendo+un+ataque+y+saber+qu%C3%A9+hacer.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3ESignos+de+un+ataque+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEs+muy+probable+que+tenga+un+ataque+de+asma+si%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3ESus+s%C3%ADntomas+tales+como+sibilancia%2C+dificultad+al+respirar%2C+opresi%C3%B3n+de+pecho%2C+o+tos++est%C3%A1n+empeorando%3C%2Fli%3E%0D%0A%3Cli%3ESu+inhalador+de+alivio+no+ayuda+a+sus+s%C3%ADntomas+o+parece+que+desaparece+muy+r%C3%A1pido+de+tal+forma+que+tiene+que+tomar+mas%3C%2Fli%3E%0D%0A%3Cli%3ENo+es+capaz+de+completar+oraciones+o+hablar+apropiadamente+%3C%2Fli%3E%0D%0A%3Cli%3ENo+es+capaz+de+comer+o+dormir+debido+a+los+s%C3%ADntomas++%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Ch1%3EQu%C3%A9+hacer+en+un+ataque+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESi+su+asma+es+tratada+apropiadamente+es+poco+probable+que+tenga+un+ataque+pero+si+tiene+un+ataque+cuando+est%C3%A9+fuera%2C+siga+estos+pasos+recomendados%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E1.%09Tomar+dos+inhalaciones+de+su+inhalador+de+alivio+inmediatamente+%0D%0A%3Cbr%2F%3E2.%09Sentarse%2C+aflojar+cualquier+ropa+ajustada%2C+e+intentar+tomar+respiraciones+lentas+y+continuas+%0D%0A%3Cbr%2F%3E3.%09Si+no+comienza+a+sentirse+mejor%2C+tome+dos+inhalaciones+m%C3%A1s+de+su+inhalador+%E2%80%93+una+a+la+vez+%E2%80%93+cada+dos+minutos%2C+hasta+10+inhalaciones%2C+o+hasta+que+sus+s%C3%ADntomas+mejoren.+%0D%0A%3Cbr%2F%3E4.%09Si+no+se+siente+mejor+despu%C3%A9s+de+tomar+su+inhalador+como+se+mencion%C3%B3+anteriormente+o+si+est%C3%A1+preocupado+en+cualquier+momento+llamar+a+una+ambulancia%0D%0A%3Cbr%2F%3E5.%09Si+una+ambulancia+no+llega+en+un+plazo+de+10+minutos+y+sus+s%C3%ADntomas+no+han+mejorado%2C+repetir+el+paso+3+hasta+que+llegue+la+ayuda+%3C%2Fp%3E","imagelist":[],"registered_only":"0"},{"content_id":"237","title":"\u00bfQu\u00e9 es el asma?","bodytext":"%3Ch1%3E%C2%BFQu%C3%A9+es+el+asma%3F%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEl+asma+es+una+enfermedad+en+la+cual+las+v%C3%ADas+respiratorias+que+llevan+el+aire+dentro+y+fuera+de+los+pulmones+se+inflaman+en+respuesta+a+una+variedad+de+factores+detonadores.+Esta+inflamaci%C3%B3n+causa+un+estrechamiento+y+reducci%C3%B3n+%28constricci%C3%B3n%29+de+las+v%C3%ADas+respiratorias%2C+junto+con+una+acumulaci%C3%B3n+de+moco.+Esto+en+su+momento+conduce+a+los+s%C3%ADntomas+de+asma+tales+como+sibilancia%2C+dificultad+al+respirar%2C+opresi%C3%B3n+de+pecho%2C+y+tos.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELos+tratamientos+de+alivio+pueden+ayudar+a+hacer+m%C3%A1s+llevadera+la+constricci%C3%B3n%2C+pero+el+tratamiento+de+la+inflamaci%C3%B3n+subyacente+requiere+que+tome+su+medicamento+preventivo+regularmente+si+su+m%C3%A9dico+se+lo+ha+recetado.+Es+importante+que+hable+con+su+m%C3%A9dico+sobre+esto+si+a%C3%BAn+no+lo+ha+hecho.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELos+s%C3%ADntomas+y+severidad+del+asma+pueden+variar+de+persona+a+persona.+Aunque+no+hay+cura+para+el+asma%2C+para+la+mayor%C3%ADa+de+la+gente+con+un+tratamiento+y+control+apropiado%2C+el+asma+puede+controlarse+y+no+deber%C3%ADa+tener+un+mayor+impacto+en+sus+vidas.%3C%2Fp%3E","imagelist":[],"registered_only":"0"},{"content_id":"238","title":"Sobre MyAsthma","bodytext":"%3Cp%3EMyAsthma+es+un+programa+que+proporciona+servicios%2C+informaci%C3%B3n+y+soporte+que+pueden+ayudar+a+las+personas+con+asma+a+tomar+control+de+su+condici%C3%B3n.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EDesarrollado+por+GSK%2C+con+la+asesor%C3%ADa+de+expertos+en+asma+del+Reino+Unido%2C+MyAsthma+proporciona+informaci%C3%B3n+%C3%BAtil%2C+asesor%C3%ADa+pr%C3%A1ctica+y+herramientas+de+monitoreo+especiales+para+ayudarle+a+controlar+y+manejar+su+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ECuando+se+registre%2C+usted+deber%C3%A1+contestar+algunas+preguntas+para+conformar+su+perfil%2C+de+manera+que+MyAsthma+pueda+ayudarle+a+controlar+su+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EMyAsthma+es+una+compa%C3%B1%C3%ADa+constante+para+personas+que+deseen+entender+su+asma+y+mantenerla+bien+controlada.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EReg%C3%ADstrese+hoy+y+podr%C3%A1+comenzar+a+beneficiarse+con+las+muchas+utilidades+de+MyAsthma+incluyendo%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EInformaci%C3%B3n+actualizada+del+clima%2C+temperatura%2C+polen+y+contaminaci%C3%B3n+de+su+%C3%A1rea+local%3C%2Fli%3E%0D%0A%3Cli%3ERecordatorios+personalizados+%C3%BAtiles+y+tips+enviados+directamente+a+su+dispositivo+m%C3%B3vil%3C%2Fli%3E%0D%0A%3Cli%3EThe+Asthma+Control+Test%E2%84%A2+o+Prueba+de+Control+del+Asma%2C+y+reportes+regulares+para+ayudarle+a+monitorear+el+control+de+su+asma%3C%2Fli%3E%0D%0A%3Cli%3EInformaci%C3%B3n+personalizada+de+c%C3%B3mo+identificar+y+manejar+sus+disparadores+de+asma%3C%2Fli%3E%0D%0A%3Cli%3ETips+para+viajar+con+asma%3C%2Fli%3E%0D%0A%3Cli%3ETips+personalizados+de+estilo+de+vida+e+informaci%C3%B3n+sobre+tratamientos%3C%2Fli%3E%0D%0A%3Cli%3EComo+obtener+el+mayor+provecho+al+trabajar+junto+con+el+profesional+del+cuidado+de+la+salud+que+le+atiende%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3E%3Ca+href%3D%22register%22%3EReg%C3%ADstrese+ahora%3C%2Fa%3E%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"0"},{"content_id":"239","title":"Enlaces \u00datiles","bodytext":"%3Cp%3EGlaxoSmithKline+ha+integrado+la+informaci%C3%B3n+en+la+biblioteca+de+MyAsthma+de+una+variedad+de+fuentes+incluyendo+aquellas+enlistadas+abajo+y+con+la+gu%C3%ADa+y+asesor%C3%ADa+de+expertos+en+asma.+Encontrar%C3%A1+algunos+de+estos+enlaces+%C3%BAtiles+para+localizar+m%C3%A1s+informaci%C3%B3n+sobre+el+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EAsthma+UK%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3E%3Ca+href%3D%22http%3A%2F%2Fwww.asthma.org.uk%2Fall_about_asthma%2Findex.html%22%3Ehttp%3A%2F%2Fwww.asthma.org.uk%2Fall_about_asthma%2Findex.html%3C%2Fa%3E%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3ENHS%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3E%3Ca+href%3D%22http%3A%2F%2Fwww.nhs.uk%2Fconditions%2FAsthma%2FPages%2FIntroduction.aspx%22%3Ehttp%3A%2F%2Fwww.nhs.uk%2Fconditions%2FAsthma%2FPages%2FIntroduction.aspx%3C%2Fa%3E%3C%2Fp%3E","imagelist":[],"registered_only":"1"},{"content_id":"240","title":"Asma en el trabajo ","bodytext":"%3Ch1%3EAsma+en+el+trabajo+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEl+asma+puede+manifestarse+por+substancias+a+las+que+usted+est%C3%A1+expuesto+en+el+trabajo+usualmente+cuando+son+inhaladas+en+los+pulmones.+Existen+esencialmente+dos+tipos+de+asma+en+el+trabajo.+Son+el+asma+ocupacional+y+el+asma+agravada+por+el+trabajo.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EAsma+ocupacional+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESe+define+como+el+asma+causada+directamente+por+la+exposici%C3%B3n+a+substancias+particulares+en+el+ambiente+de+trabajo.+La+reacci%C3%B3n+a+dichos+detonadores+puede+aparecer+casi+inmediatamente+o+puede+tomar+meses+o+incluso+a%C3%B1os+para+desarrollarse.+Muchas+personas+con+asma+ocupacional+no+ten%C3%ADan+asma+antes.+Es+una+causa+com%C3%BAn+de+asma+que+inicia+en+adultos+en+edad+de+trabajar+y+que+debe+considerarse+siempre.+El+asma+ocupacional+es+importante+que+se+reconozca+ya+que+si+el+detonador+es+eliminado+a+tiempo+el+asma+desaparecer%C3%A1+pero+si+la+exposici%C3%B3n+contin%C3%BAa+mas+all%C3%A1+de+un+cierto+punto+el+asma+se+vuelve+permanente.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cstrong%3EReconociendo+el+asma+ocupacional%3C%2Fstrong%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEl+diagnosticar+el+asma+ocupacional+con+suficiente+antelaci%C3%B3n+y+eliminado+el+detonador+podr%C3%ADa+prevenir+que+se+desarrollara.+Los+s%C3%ADntomas+son+los+mismos+del+asma+regular%2C+pero+puede+tener+asma+ocupacional+si+advierte+que+sus+s%C3%ADntomas%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EComienzan+en+un+lapso+de+un+a%C3%B1o+o+dos+al+iniciar+un+nuevo+trabajo%2C+al+cambiar+de+puesto+o+al+moverse+a+una+parte+diferente+del+lugar+de+trabajo+%3C%2Fli%3E%0D%0A%3Cli%3EInician+despu%C3%A9s+de+trabajar+con+nuevas+substancias+o+procedimientos+%3C%2Fli%3E%0D%0A%3Cli%3EMejora+en+los+fines+de+semana+o+cuando+ha+estado+alejado+de+dicha+%C3%A1rea+como+en+vacaciones+%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3ESi+sospecha+de+asma+ocupacional%2C+hable+con+su+m%C3%A9dico+tan+pronto+como+sea+posible.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cstrong%3ESubstancias+que+causan+el+asma+ocupacional%3C%2Fstrong%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EHay+m%C3%A1s+de+300+substancias+que+han+sido+identificadas+como+una+causa+del+asma+ocupacional+tales+como+el+polvo%2C+substancias+qu%C3%ADmicas+usadas+en+la+fabricaci%C3%B3n%2C+procesos+de+pintura+y+limpieza%2C+metales+y+adhesivos.+Las+ocupaciones+con+un+riesgo+mayor+del+normal+de+causar+asma+ocupacional+incluyen+rociadores+de+pintura%2C+limpiadores%2C+panaderos%2C+trabajadores+de+laboratorio%2C+electricistas+que+trabajan+con+soldadura+y+trabajadores+de+la+salud+que+usan+desinfectantes.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cstrong%3EPreviniendo+el+asma+ocupacional%3C%2Fstrong%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELa+%C3%BAnica+forma+efectiva+de+prevenir+el+asma+ocupacional+es+no+estar+expuesto+al+detonador.+Los+empleadores+tienen+una+obligaci%C3%B3n+legal+de+evaluar+y+controlar+los+detonadores+en+el+lugar+de+trabajo.+Si+usted+cree+que+ellos+podr%C3%ADan+hacer+m%C3%A1s%2C+contacte+al+ministerio+de+salud+ambiental+local+o+al++Director+de+Salud+y+Seguridad+para+obtener+asesor%C3%ADa.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EAsma+agravada+en+el+trabajo+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEsto+es+cuando+alguien+ya+tiene+asma+pero+peri%C3%B3dicamente+empeora+experimentando+ciertos+detonadores+en+el+trabajo.+Estos+pueden+ser+cosas+tales+como+polvo%2C+humo+del+cigarro%2C+estr%C3%A9s%2C+perfumes%2C+substancias+qu%C3%ADmicas+o+productos+de+limpieza.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EEligiendo+una+profesi%C3%B3n+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ECon+pocas+excepciones%2C+no+existe+una+raz%C3%B3n+por+la+cual+no+deber%C3%ADa+ser+capaz+de+tener+el+trabajo+de+su+elecci%C3%B3n.+Sin+embargo%2C+cuando+se+piensa+sobre+un+nuevo+trabajo%2C+es+sensato+considerar+los+posibles+riesgos.+Si+tiene+dudas+sobre+su+elecci%C3%B3n+de+profesi%C3%B3n%2C+hable+con+su+m%C3%A9dico.+%3C%2Fp%3E","imagelist":[],"registered_only":"1"},{"content_id":"241","title":"Estr\u00e9s y Ansiedad","bodytext":"%3Ch1%3EEstr%C3%A9s+y+Ansiedad%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELas+emociones+tales+como+el+estr%C3%A9s%2C+ansiedad%2C+o+depresi%C3%B3n+pueden+ser+detonadores+de+s%C3%ADntomas+y+ataques+de+asma%2C+2%2F3+de+las+personas+con+asma+encuentran+que+sus+s%C3%ADntomas+y+ataques+de+asma+son+desencadenados+por+el+estr%C3%A9s.+El+tener+asma+puede+ser+una+fuente+de+estr%C3%A9s+en+s%C3%AD+misma%2C+particularmente+si+no+est%C3%A1+bien+controlada.+Los+episodios+recurrentes+de+tener+que+pelear+para+respirar+son+atemorizantes+y+angustiantes.+La+investigaci%C3%B3n+demuestra+que+la+ansiedad%2C+depresi%C3%B3n+y+el+p%C3%A1nico+son+m%C3%A1s+comunes+en+gente+con+asma+que+en+la+poblaci%C3%B3n+en+general+y+est%C3%A1n+asociados+con+m%C3%A1s+s%C3%ADntomas%2C+m%C3%A1s+ataques+y+una+mayor+probabilidad+de+terminar+en+el+hospital.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ETales+emociones+puede+ser+el+resultado+de+un+problema+o+situaci%C3%B3n+particular%2C+tales+como+preocupaciones+financieras%2C+duelo+o+dificultades+en+una+relaci%C3%B3n%2C+pero+pueden+ser+causadas+por+un+control+inadecuado+del+asma.+Cualquiera+que+sea+la+raz%C3%B3n%2C+es+importante+recordar+que+hay+mucha+gente+en+una+situaci%C3%B3n+similar+y+que+se+cuenta+con+ayuda.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EHay+un+estrecho+v%C3%ADnculo+entre+el+estr%C3%A9s+y+el+asma%2C+algunas+veces+los+s%C3%ADntomas+de+un+ataque+de+asma+y+estr%C3%A9s+severo+o+un+ataque+de+p%C3%A1nico+pueden+ser+muy+similares.+Algunas+personas+piensan+que+sus+ataques+de+asma+son+ataques+de+p%C3%A1nico%2C+por+lo+que+no+controlan+su+asma+con+la+seriedad+que+deber%C3%ADan.+Asimismo%2C+las+medidas+para+controlar+el+p%C3%A1nico%2C+como+el+respirar+lenta%2C+profunda+y+regularmente%2C+pueden+algunas+veces%2C+ser+de+m%C3%A1s+ayuda+que+usar+grandes+cantidades+del+inhalador+de+rescate.+Por+lo+tanto%2C+es+importante+que+usted+sea+capaz+de+distinguir+la+diferencia+y+vale+la+pena+comentarlo+con+su+m%C3%A9dico.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EAsma+y+ansiedad+pueden+estar+interrelacionadas+y+pueden+crear+un+c%C3%ADrculo+vicioso.+Los+s%C3%ADntomas+del+asma%2C+tales+como+el+acortamiento+de+la+respiraci%C3%B3n%2C+pueden+causar+estr%C3%A9s+y+los+s%C3%ADntomas+del+estr%C3%A9s%2C+tales+como+la+hiperventilaci%C3%B3n%2C+pueden+desencadenar+un+ataque+de+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EQu%C3%A9+puede+hacer%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEn+primera+instancia%2C+aseg%C3%BArese+de+que+su+control+regular+del+asma+sea+lo+mejor+que+puede+ser+y+de+que+est%C3%A9+tomando+consistentemente+su+medicamento+para+el+asma.+%3Ca+href%3D%22act%22%3EH%C3%A1gase+la+Prueba+de+Control+del+Asma+para+revisar+su+nivel+de+control%3C%2Fa%3E.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESi+el+estr%C3%A9s+o+la+ansiedad+es+in+detonador+de+su+asma%2C+aqu%C3%AD+hay+algunos+pasos+que+puede+tomar+para+ayudarle+a+reducir+el+riesgo%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3ETrate+de+relajarse.+Ejercicios+de+respiraci%C3%B3n%2C+meditaci%C3%B3n%2C+yoga+o+ejercicio+f%C3%ADsico+adecuado+pueden+ayudarlo+a+bajar+sus+niveles+de+estr%C3%A9s.+Los+fisioterapeutas+pueden+ense%C3%B1arle+ejercicios+de+respiraci%C3%B3n+que+pueden+mejorar+el+control+del+asma%3C%2Fli%3E%0D%0A%3Cli%3ETerapia+o+asesor%C3%ADa.+Siempre+es+bueno+hablar+de+c%C3%B3mo+se+siente.+Hay+muchos+tipos+de+apoyo+disponibles.+Van+desde+la+terapia%2C+como+la+terapia+cognitiva+del+comportamiento+que+le+ayuda+a+ver+su+estado+emocional+y+sus+reacciones%2C+hasta+asesor%C3%ADas+pr%C3%A1cticas+sobre+situaciones+tales+como+el+manejo+de+deudas+o+asesor%C3%ADa+vocacional.+Consulte+a+su+m%C3%A9dico+respecto+a+los+servicios+que+le+podr%C3%ADa+recomendar.%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3ESi+est%C3%A1+preocupado+por+los+efectos+del+estr%C3%A9s+o+ansiedad+sobre+su+asma%2C+busque+activamente+apoyo+y+consejo.+Se+sorprender%C3%ADa%2C+con+agrado%2C+de+lo+que+una+sencilla++charla+con+el+profesional+de+la+salud+que+le+atiende+o+con+un+amigo+confiable+sobre+c%C3%B3mo+se+siente%2C+puede+ayudar.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"242","title":"Asthma Control Test","bodytext":"%3Ch1%3EAsthma+Control+Test%E2%84%A2%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EThe+Asthma+Control+Test%E2%84%A2+o+Prueba+de+Control+del+Asma+es+un+cuestionario+corto+para+pacientes+con+asma+desarrollado+por+expertos.+Esta+prueba+le+ayuda+a+usted+y+a+su+m%C3%A9dico++o+enfermera+a+mostrar+qu%C3%A9+tan+bien+su+asma+ha+estado+controlada+durante+las+%C3%BAltimas+cuatro+semanas.+Esto+ayudar%C3%A1+a+decidir+si+necesita+o+no+un+cambio+de+tratamiento.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEs+com%C3%BAn+que+la+gente+sobrestime+qu%C3%A9+tan+bien+est%C3%A1+controlada+su+asma%2C+ya+que+han+llegado+a+aceptar+que+los+s%C3%ADntomas+y+las+limitaciones+de+estilo+de+vida+son+normales+en+tal+condici%C3%B3n.+Este+no+deber%C3%ADa+ser+el+caso%2C+porque%2C+con+el+tratamiento+correcto%2C+el+buen+control+es+posible+para+la+mayor%C3%ADa+de+la+gente.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EDebido+a+que+los+s%C3%ADntomas+del+asma+var%C3%ADan+con+el+tiempo%2C+usted+debe+realizarse+la+prueba+de+control+del+asma+o+Asthma+Control+Test%E2%84%A2+cuando+menos+una+vez+al+mes+para+monitorear+qu%C3%A9+tan+bien+se+encuentra.+Usted+puede+realiz%C3%A1rselo+con+mayor+frecuencia+si+siente+que+su+asma+est%C3%A1+empeorando%2C+y+la+prueba+puede+ayudarle+a+determinar+si+es+as%C3%AD.+La+prueba+toma+menos+de+un+minuto%2C+ya+que+s%C3%B3lo+hay+que+contestar+cinco+preguntas+y+recibir%C3%A1+una+calificaci%C3%B3n+de+25+posibilidades.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EUna+calificaci%C3%B3n+de+20+o+m%C3%A1s+significa+que+el+control+de+su+asma+es+probablemente+bueno+por+el+momento%2C+pero+cualquier+calificaci%C3%B3n+menor+significa+que+el+control+puede+estar+por+debajo+del+ideal%2C+y+el+asma+est%C3%A1+afectando+su+calidad+de+vida+m%C3%A1s+de+lo+debido.+Una+calificaci%C3%B3n+de+15+o+menos+indica+que+usted+puede+estar+en+riesgo+de+un+ataque+de+asma%2C+y+debe+consultar+a+su+m%C3%A9dico+o+enfermera+cuanto+antes.+Una+ca%C3%ADda+en+su+calificaci%C3%B3n+significa+que+posiblemente+su+control+ha+empeorado+y+puede+ser+necesario+un+cambio+de+tratamiento.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EAunque+la+prueba+es+r%C3%A1pida+y+f%C3%A1cil%2C+la+prueba+de+control+del+asma+o+Asthma+Control+Test%E2%84%A2+ha+demostrado+ser+una+herramienta+%C3%BAtil+para+identificar+un+control+inadecuado+del+asma.+Es+una+buena+idea+hacerse+la+prueba+a+intervalos+regulares+para+ver+si+su+calificaci%C3%B3n+cambia%2C+y+tambi%C3%A9n+usted+puede+compartir+sus+resultados+con+el+profesional+del+cuidado+de+la+salud+que+lo+atiende%2C+de+manera+que+se+puedan+hacer+los+ajustes+necesarios+a+su+plan+de+acci%C3%B3n+personal+contra+el+asma.+Encuentre+m%C3%A1s+informaci%C3%B3n+sobre+los+planes+de+acci%C3%B3n+personales+contra+el+asma+%3Clink%3E.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EPor+qu%C3%A9+no+hacerse+la+Prueba+de+Control+del+Asma+o+The+Asthma+Control+Test%E2%84%A2+ahora+%E2%80%93+%3Ca+href%3D%22act%22%3Es%C3%B3lo+seleccione+el+v%C3%ADnculo+siguiente%3C%2Fa%3E.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"0"},{"content_id":"243","title":"Planes de Acci\u00f3n Personales contra el Asma","bodytext":"%3Ch1%3EPlanes+de+Acci%C3%B3n+Personales+contra+el+Asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EToda+persona+con+asma+necesita+tener+un+buen+entendimiento+de+su+condici%C3%B3n%2C+y+saber+qu%C3%A9+hacer+si+las+cosas+comienzan+a+empeorar.+Una+de+las+maneras+m%C3%A1s+efectivas+de+ayudar+a+manejar+o+de+tener+mayor+control+de+su+asma+es+tener+su+propio+plan+de+acci%C3%B3n+personal+contra+el+asma.+Se+ha+demostrado+que+las+personas+que+usan+un+plan+de+acci%C3%B3n+personal%2C+junto+con+revisiones+regulares%2C+han+mejorado+el+control+de+su+asma%2C+y+tienen+una+mejor+calidad+de+vida.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EUn+plan+de+acci%C3%B3n+personal+es%2C+por+lo+general%2C+un+documento+escrito+que+ha+sido+preparado+junto+con+su+doctor+o+enfermera.+Un+ejemplo+t%C3%ADpico+incluye%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EDetalles+de+su+medicamento+para+el+asma+y+cuando+tomarlo%3C%2Fli%3E%0D%0A%3Cli%3EC%C3%B3mo+reconocer+cuando+sus+s%C3%ADntomas+est%C3%A1n+empeorando%2C+de+ser+as%C3%AD+qu%C3%A9+hacer%2C+y+cu%C3%A1ndo+contactar+al+profesional+al+cuidado+de+la+salud+que+lo+atiende%3C%2Fli%3E%0D%0A%3Cli%3EIdentificaci%C3%B3n+de+los+disparadores+y+c%C3%B3mo+evitarlos%3C%2Fli%3E%0D%0A%3Cli%3ETips+de+qu%C3%A9+hacer+en+una+emergencia%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Ch1%3EPor+qu%C3%A9+un+plan+de+acci%C3%B3n+personal+ayuda%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEl+plan+de+acci%C3%B3n+personal+no+solamente+le+proporciona+informaci%C3%B3n+%C3%BAtil+al+alcance+de+sus+dedos%2C+sino+que+tambi%C3%A9n+le+permite+variar+su+medicaci%C3%B3n+para+el+asma+%28dentro+de+l%C3%ADmites+acordados%29%2C+de+modo+que+pueda+responder+de+acuerdo+con+la+manera+como+se+sienta+y+tenga+mejor+control+de+su+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEs+importante+que+su+plan+sea+revisado+cuando+menos+una+vez+al+a%C3%B1o+para+asegurar+que+corresponda+a+sus+necesidades.+El+plan+siempre+deber%C3%A1+ser+revisado+despu%C3%A9s+de+un+ataque+de+asma+para+ver+si+necesita+cambios.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESi+usted+no+cuenta+con+un+plan+de+acci%C3%B3n+personal+contra+el+asma%2C+en+su+pr%C3%B3xima+visita+al+profesional+al+cuidado+de+la+salud+que+lo+atiende%2C+pregunte+si+puede+preparar+uno+con+usted.+Para+ver+un+ejemplo+de+un+plan+de+acci%C3%B3n+personal+contra+el+asma%2C+%3Ca+href%3D%22http%3A%2F%2Fwww.asthma.org.uk%2Fall_about_asthma%2Fcontrolling_your_asthma%2Fresources_to_help_you%2Fpersonal_asthma_acti.html%22%3Eseleccione+el+v%C3%ADnculo+siguiente%3C%2Fa%3E.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"244","title":"El Asma conforme avanza la edad","bodytext":"%3Ch1%3EEl+Asma+conforme+avanza+la+edad%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EPara+mucha+gente%2C+el+asma+comienza+durante+la+ni%C3%B1ez.+En+el+pasado%2C+era+com%C3%BAn+pensar+que+los+s%C3%ADntomas+desaparec%C3%ADan+gradualmente+conforme+se+entraba+a+la+edad+adulta%3B+sin+embargo%2C+no+siempre+es+el+caso.+Alrededor+de+un+tercio+de+las+personas+%E2%80%9Cpierden%E2%80%9D+su+asma+completamente%2C+pero+para+otros%2C+el+asma+contin%C3%BAa%2C+aunque+la+severidad+de+los+s%C3%ADntomas+puede+cambiar%2C+as%C3%AD+como+los+factores+que+disparan+su+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ETambi%C3%A9n+hay+personas+a+las+que+se+diagnostica+asma+por+primera+vez+en+la+edad+adulta+%E2%80%93+esta+se+conoce+como+inicio+del+asma+del+adulto.+En+las+personas+mayores+su+asma+puede+ser+desencadenada+por+factores+diferentes+a+los+que+la+causaban+cuando+eran+m%C3%A1s+j%C3%B3venes.+Si+el+asma+comienza+en+un+adulto+que+trabaja%2C+es+importante+considerar+si+hay+algo+en+el+lugar+de+trabajo+que+pudiera+haberla+desencadenado.+Esta+se+llama+asma+ocupacional%2C+y+si+el+detonador+es+eliminado+lo+suficientemente+r%C3%A1pido%2C+el+asma+puede+desaparecer+completamente.+%3Ca+href%3D%22content_240%22%3EPara+m%C3%A1s+informaci%C3%B3n+sobre+el+asma+relacionada+con+el+trabajo%3C%2Fa%3E.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ERecuerde+que+el+asma+no+es+la+%C3%BAnica+causa+de+acortamiento+de+la+respiraci%C3%B3n.+Otras+condiciones+que+afectan+a+los+pulmones+y+al+coraz%C3%B3n+tambi%C3%A9n+pueden+ser+una+causa.+Si+usted+experimenta+un+evento+nuevo+o+empeoramiento+por+dificultad+respiratoria%2C+particularmente+conforme+avanza+la+edad%2C+consulte+al+profesional+del+cuidado+de+la+salud+que+lo+atiende.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EAsimismo%2C+conforme+la+edad+avanza%2C+otras+condiciones+que+pudieran+presentarse%2C+%3Ca+href%3D%22content_235%22%3Etales+como+el+sobrepeso%3C%2Fa%3E%2C+pueden+empeorar+el+control+de+su+asma.+De+manera+similar%2C+%3Ca+href%3D%22content_253%22%3Ela+alergia+estacional+o+s%C3%ADntomas+de+alergia+pueden+alterar+el+control%3C%2Fa%3E+y+%3Ca+href%3D%22content_260%22%3Ecomenzar+a+fumar+puede+tener+un+efecto+muy+malo%3C%2Fa%3E.+%3Ca+href%3D%22content_241%22%3ELa+ansiedad+y+la+depresi%C3%B3n+tambi%C3%A9n+est%C3%A1n+ligadas+al+control+inadecuado+del+asma%3C%2Fa%3E.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEstos+son+unos+pasos+simples+que+le+pueden+ayudar+a+prevenir+el+empeoramiento+de+su+asma+con+la+edad%2C+incluyendo%3A+%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EMantenga+su+asma+bien+controlada+y+revise+su+plan+de+acci%C3%B3n+personal+regularmente.+%3Ca+href%3D%22content_243%22%3EVer+un+plan+de+acci%C3%B3n+personal+contra+el+asma%3C%2Fa%3E%3C%2Fli%3E%0D%0A%3Cli%3ETome+su+medicamento+preventivo+regularmente+y%2C+s%C3%AD+sus+s%C3%ADntomas+de+asma+empeoran%2C+ati%C3%A9ndalos+cuanto+antes.%3C%2Fli%3E%0D%0A%3Cli%3EAseg%C3%BArese+de+usar+su+inhalador+como+le+indic%C3%B3+el+profesional+de+la+salud+tratante.+Si+no+est%C3%A1+seguro%2C+hable+con+su+m%C3%A9dico%2C+enfermera+cl%C3%ADnica+o+farmac%C3%A9utico+local.%3C%2Fli%3E%0D%0A%3Cli%3ENo+fume.+Si+usted+fuma+y+le+cuesta+trabajo+dejarlo%2C+hable+con+su+m%C3%A9dico+sobre+las+estrategias+que+podr%C3%ADan+ayudarle.%3C%2Fli%3E%0D%0A%3Cli%3ETrate+de+mantenerse+en+forma+y+tan+saludable+como+sea+posible%2C+coma+una+dieta+sana+y+mantenga+su+peso+bajo.%3C%2Fli%3E%0D%0A%3Cli%3ESi+padece+alguna+otra+condici%C3%B3n+de+salud%2C+tal+como+fiebre%2C+indigesti%C3%B3n+o+depresi%C3%B3n%2C+requiere+de+un+tratamiento+adecuado+para+%C3%A9stas%2C+ya+que+pueden+empeorar+su+asma.%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"245","title":"Alcohol y asma","bodytext":"%3Ch1%3EAlcohol+y+asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEn+general%2C+no+existe+problema+s%C3%AD+usted+ingiere+alcohol+y+toma+su+medicaci%C3%B3n+para+el+asma%2C+ya+que+estas+no+interact%C3%BAan+entre+s%C3%AD.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EAdem%C3%A1s%2C+no+es+com%C3%BAn+que+las+bebidas+alcoh%C3%B3licas+desencadenen+el+asma.+Si+esto+ocurriera%2C+el+detonador+real+del+asma%2C+posiblemente%2C+sea+un+ingrediente+o+aditivo+de+la+bebida%2C+m%C3%A1s+que+el+mismo+alcohol%3B+por+lo+que+usted+podr%C3%ADa+encontrar+que+algunas+bebidas+alcoh%C3%B3licas+desencadenan+su+asma%2C+mientras+que+otras+no.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESi+usted+considera+que+su+asma+pudiera+ser+afectada+por+bebidas+alcoh%C3%B3licas%2C+hable+con+el+profesional+de+la+salud+tratante+para+acordar+el+control+de+su+asma.+Tambi%C3%A9n+podr%C3%ADa+usted+llevar+un+diario+que+le+ayude+a+identificar%2C+s%C3%AD+realmente+las+bebidas+alcoh%C3%B3licas+desencadenan+su+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%28Nota%3B+algunos+inhaladores+para+el+asma+contienen+peque%C3%B1as+cantidades+de+alcohol.+Si+esto+le+preocupa%2C+por+favor%2C+conf%C3%ADrmelo+con+el+profesional+de+la+salud+tratante.%29%3C%2Fp%3E","imagelist":[],"registered_only":"1"},{"content_id":"246","title":"Detalles sobre el asma","bodytext":"%3Ch1%3E%C2%BFSab%C3%ADa+que%3F%0D%0ADetalles+sobre+el+asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESi+usted+tiene+asma%2C+usted+no+est%C3%A1+solo%2C+ya+que+es+una+condici%C3%B3n+relativamente+com%C3%BAn+que+afecta+a+aproximadamente+300+millones+de+personas+en+todo+el+mundo.+Particularmente+en+M%C3%A9xico+aproximadamente+el+10%25+de+la+poblaci%C3%B3n+padece+esta+enfermedad.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EAunque+no+hay+cura+para+el+asma%2C+hay+tratamientos+efectivos+y+la+mayor%C3%ADa+de+las+personas+deber%C3%ADan+poder+alcanzar+un+control+muy+bueno+con+m%C3%ADnima+alteraci%C3%B3n+en+su+vida.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EDesafortunadamente%2C+m%C3%A1s+de+la+mitad+de+las+personas+con+asma+no+tienen+un+buen+control+y+esto+puede+tener+un+gran+impacto+en+su+vida.+La+gente+con+un+control+inadecuado+del+asma+toman+el+doble+de+d%C3%ADas+sin+trabajar+en+comparaci%C3%B3n+con+las+personas+con+un+buen+control+del+asma%2C+y+son+m%C3%A1s+propensos+a+sufrir+ataques+de+asma+y+a+requerir+tratamiento+hospitalario.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EHay+aproximadamente+250%2C000+muertes+relacionados+con+el+asma+en+todo+el+mundo.+La+mayor%C3%ADa+de+estas+muertes+podr%C3%ADan+prevenirse+con+medidas+tales+como+tomar+regularmente+el+tratamiento+preventivo+prescrito%2C+dejando+de+fumar%2C+%3Ca+href%3D%22content_236%22%3Eas%C3%AD+como+reconociendo+y+tratando+los+signos+de+un+ataque+de+asma+con+prontitud%3C%2Fa%3E.%3C%2Fp%3E","imagelist":[],"registered_only":"0"},{"content_id":"247","title":"Dispositivos para el Asma","bodytext":"%3Ch1%3EDispositivos+para+el+Asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EAlgunos+medicamentos+para+el+asma+est%C3%A1n+disponibles+como+tabletas%2C+jarabes%2C+nebulizadores+o+inyectables%2C+pero+la+mayor%C3%ADa+son+aerosoles+o+polvos+dise%C3%B1ados+para+ser+usados+como+dispositivos+para+inhalaci%C3%B3n.+De+esta+manera%2C+el+medicamento+puede+ser+suministrado+directamente+a+sus+pulmones+que+es+donde+se+necesita.+Esto+tambi%C3%A9n+significa+que+el+medicamento+tiene+menos+efectos+secundarios+que+si+se+tomara+por+la+boca.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EExisten+muchos+tipos+diferentes+de+inhaladores%2C+pero+con+cualquier+tipo+de+dispositivo+que+le+hayan+prescrito%2C+es+esencial+que+sepa+usarlo+adecuadamente%2C+de+manera+que+usted+reciba+la+dosis+correcta+del+medicamento.+El+profesional+de+la+salud+que+lo+trata+le+aconsejar%C3%A1+sobre+el+dispositivo+m%C3%A1s+conveniente+para+usted+y+le+explicar%C3%A1+c%C3%B3mo+funciona.+Adem%C3%A1s%2C+su+m%C3%A9dico%2C+enfermera+o+farmac%C3%A9utico+verificar%C3%A1%2C+ocasionalmente%2C+que+usted+lo+use+correctamente+%E2%80%93+no+se+ofenda%2C+es+muy+importante+hacerlo+bien+y+mucha+gente+lo+hace+mal.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EInhaladores+presurizados+de+dosis+medida+%28MDI%29%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEste+tipo+de+inhaladores+suministran+el+medicamento+como+un+roc%C3%ADo+fino+%28aerosol%29+presionando+la+parte+superior+del+dispositivo.+Usted+debe+inhalar+lentamente+por+aproximadamente+cinco+segundos%2C+al+mismo+tiempo+que+presiona+la+lata+para+liberar+el+medicamento%2C+de+manera+que+su+coordinaci%C3%B3n+y+el+tiempo+son+importantes.+Es+necesario+que+un+profesional+de+la+salud+como+su+m%C3%A9dico%2C+enfermera+o+farmac%C3%A9utico+le+ense%C3%B1en+a+hacerlo+y+usted+deber%C3%A1+esperar+que%2C+al+menos+una+vez+al+a%C3%B1o%2C+lo+verifiquen.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EInhaladores+presurizados+activados+con+la+respiraci%C3%B3n%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEstos+son+similares+a+los+inhaladores+de+dosis+medida%2C+pero+el+medicamento+es+liberado+autom%C3%A1ticamente+como+un+roc%C3%ADo+cuando+usted+respire+en+%C3%A9l%2C+de+manera+que+no+tiene+que+coordinar+las+acciones+de+presionar+el+inhalador+e+inhalar+y%2C+por+lo+tanto%2C+son+un+poco+m%C3%A1s+f%C3%A1ciles+de+usar.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EInhaladores+de+polvo+seco%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ECon+estos+dispositivos%2C+el+medicamento+viene+en+forma+de+polvo%2C+el+cual+usted+succiona+hacia+sus+pulmones%2C+inhalando+profundamente+a+trav%C3%A9s+del+inhalador.+Usted+necesita+inhalar+tan+fuerte+y+r%C3%A1pido+como+pueda%2C+para+obtener+el+mayor+beneficio+de+este+tipo+de+inhalador.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EDispositivos+Espaciadores%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELos+espaciadores+son+c%C3%A1maras+para+inhalaci%C3%B3n+grandes%2C+generalmente+hechas+de+pl%C3%A1stico%2C+los+cuales+son+usados+con+inhaladores+presurizados+de+dosis+medida.+El+inhalador+es+insertado+en+un+extremo+del+espaciador+y+usted+respira+lentamente+en+el+otro+extremo+por+aproximadamente+cinco+segundos.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESi+usted+usa+un+inhalador+presurizado+de+dosis+medida+sin+espaciador%2C+una+gran+parte+del+aerosol+pega+en+la+parte+posterior+de+la+boca+y+la+garganta%2C+de+manea+que+el+medicamento+no+llega+a+los+pulmones+donde+puede+ayudarlo+con+su+asma.+Los+espaciadores+facilitan+la+coordinaci%C3%B3n+de+inhalar+a+la+vez+que+se+presiona+el+inhalador%2C+y+debido+a+que+ayudan+a+que+el+medicamento+llegue+al+lugar+indicado%2C+pueden+reducir+los+efectos+secundarios+del+tratamiento%2C+particularmente+de+dosis+m%C3%A1s+altas+de+medicamentos+preventivos.+%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3ENebulizadores%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEstos+son+m%C3%A1quinas+que+crean+una+nube+del+medicamento%2C+la+cual+es+inhalada+a+trav%C3%A9s+de+una+boquilla+o+mascarilla.+Estos+son+ocasionalmente+usados+en+un+ambiente+cl%C3%ADnico+u+hospitalario+en+casos+de+emergencia%2C+pero+m%C3%BAltiples+inhalaciones+de+un+medicamento+de+alivio%2C+a+trav%C3%A9s+de+un+espaciador+son+igualmente+buenas+durante+una+crisis.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESi+usted+tiene+algunas+dudas+sobre+el+dispositivo+que+est%C3%A1+usando+o+de+su+t%C3%A9cnica+de+inhalaci%C3%B3n%2C+consulte+al+profesional+de+la+salud+tratante.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"248","title":"Ejercicio","bodytext":"%3Ch1%3EEjercicio+y+actividades%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EHacer+ejercicio+y+mantenerse+activo+es+magn%C3%ADfico+para+nuestro+bienestar.+El+tener+asma+ciertamente+no+significa+que+no+pueda+hacer+ejercicio.+Siempre+y+cuando+su+asma+est%C3%A9+bien+controlada%2C+%C3%A9sta+no+deber%C3%ADa+ser+un+obst%C3%A1culo+para+que+usted+est%C3%A9+en+forma+o+se+involucre+en+sus+actividades+favoritas%2C+incluyendo+el+deporte+%E2%80%93+muchos+hombres+y+mujeres+deportistas+sobresalientes+incluyendo+a+David+Beckham%2C+Haile+Gabrselassie%2C+y+Paula+Radcliffe+tienen+asma%2C+la+cual+no+les+impide+competir+al+m%C3%A1s+alto+nivel.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EAlgunas+personas+con+asma%2C+sin+embargo%2C+encuentran+que+el+ejercicio+puede+ser+un+detonante.+Si+este+es+su+caso%2C+este+puede+ser+un+signo+de+que+su+asma+no+est%C3%A1+bien+controlada%2C+como+deber%C3%ADa+ser%2C+y+hay+muchas+estrategias+y+tratamientos+que+podr%C3%ADan+ayudar%2C++por+lo+que+deber%C3%ADa+comentarlo+con+el+profesional+de+la+salud+tratante.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EDesde+luego%2C+algunos+s%C3%ADntomas+del+asma%2C+tales+como%2C+dificultad+para+respirar%2C+son+similares+a+lo+que+sucede+cuando+hacemos+ejercicio%2C+particularmente+si+no+se+est%C3%A1+en+forma.+Aunque+%C3%A9sta+es+una+reacci%C3%B3n+natural+al+ejercicio%2C+usted+deber%C3%A1+conocer+cu%C3%A1les+son+sus+l%C3%ADmites+para+el+mismo%2C+e+incremente+sus+niveles+de+ejercicio+gradualmente+a+trav%C3%A9s+de+un+programa+para+ponerse+en+forma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESu+objetivo+deber%C3%A1+ser+ejercitarse+libremente%2C+a+su+nivel+%C3%B3ptimo%2C+sin+experimentar+s%C3%ADntomas+de+asma.+Si+el+ejercicio+est%C3%A1+desencadenando+su+asma%2C+com%C3%A9ntelo+con+el+profesional+de+la+salud+tratante%2C+ya+que+un+cambio+en+el+tratamiento+podr%C3%ADa+detener+los+s%C3%ADntomas+asm%C3%A1ticos+que+se+presentan.+Existen+varias+estrategias+que+podr%C3%ADan+ayudar%2C+incluyendo%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EUso+ocasional+de+su+inhalador+de+alivio+unos+minutos+antes+de+su+calentamiento+para+ejercitarse.+Si+usted+requiere+hacer+esto+m%C3%A1s+que+ocasionalmente%2C+entonces+su+terapia+de+asma+debe+ser+revisada+por+el+profesional+de+la+salud+tratante.%3C%2Fli%3E%0D%0A%3Cli%3EEleve+sus+niveles+de+entrenamiento+gradualmente%3C%2Fli%3E%0D%0A%3Cli%3ESiempre+tenga+su+inhalador+de+alivio+con+usted+cuando+haga+ejercicio%3C%2Fli%3E%0D%0A%3Cli%3ESi+lo+considera+adecuado%2C+avise+a+los+que+se+ejercitan+con+usted+que+tiene+asma%3C%2Fli%3E%0D%0A%3Cli%3EEst%C3%A9+al+pendiente+de+otros+detonadores+posibles+del+asma%2C+tales+como+la+alergia+estacional+y+ev%C3%ADtelas+mientras+este+ejercit%C3%A1ndose%3C%2Fli%3E%0D%0A%3Cli%3ESi+experimenta+s%C3%ADntomas+al+hacer+ejercicio%3B+det%C3%A9ngase%2C+use+su+inhalador%2C+y+espere+hasta+que+se+sienta+mejor%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3ELas+personas+con+asma+inducida+por+el+ejercicio+responden+de+manera+diferente+a+diferentes+situaciones%2C+por+lo+que+usted+deber%C3%A1+tratar+de+encontrar+las+que+son+espec%C3%ADficas+para+usted+y+tome+las+precauciones+adecuadas.+De+esta+manera+usted+puede+mantenerse+en+forma+y+saludable%2C+haciendo+las+actividades+que+le+gusten.+Y%2C+desde+luego%2C+si+usted+tiene+alguna+pregunta+acerca+del+ejercicio%2C+siempre+puede+consultar+al+profesional+de+la+salud+que+lo+trata.+%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"249","title":"Gripe y otras infecciones respiratorias","bodytext":"%3Ch1%3EGripe+y+otras+infecciones+respiratorias%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELos+virus+frecuentemente+juegan+un+papel+en+la+detonaci%C3%B3n+del+inicio+de+los+s%C3%ADntomas+del+asma.+Los+virus+son+g%C3%A9rmenes+que+pueden+causar+resfriados%2C+influenza+e+infecciones+de+v%C3%ADas+respiratorias%2C+las+cuales+a+su+vez+pueden+desencadenar+s%C3%ADntomas+de+asma+o%2C+incluso%2C+conducir+a+ataques+de+asma+extensos.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELos+detonadores+frecuentes+del+asma+incluyen+el+resfriado+com%C3%BAn+%28una+infecci%C3%B3n+del+tracto+respiratorio+alto%29%2C+e+influenza+%28flu%29.+Si+usted+sufre+de+asma+de+moderada+a+severa%2C+se+recomienda+que+se+aplique+la+vacuna+contra+la+influenza+una+vez+al+a%C3%B1o+para+ayudar+a+prevenir+la+enfermedad.+Su+cl%C3%ADnica+puede+contactarlo+para+recordarle+la+fecha+en+que+deber%C3%A1+aplicarse+la+vacuna+contra+la+influenza.+Hay+algunos+efectos+secundarios+asociados+con+la+vacuna%2C+por+lo+que+se+recomienda+consultar+al+profesional+de+la+salud+que+lo+trata+sobre+si+es+adecuada+para+usted+o+no.%3C%2Fp%3E","imagelist":[],"registered_only":"1"},{"content_id":"250","title":"Alimentos y asma","bodytext":"%3Ch1%3EAlimentos+y+asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELos+alimentos+no+son+frecuentemente+detonadores+del+asma%2C+aunque+puede+ser+en+algunas+personas+con+alergias+a+alimentos%2C+por+ejemplo+a+las+nueces.+Las+personas+con+asma%2C+por+lo+general%2C+no+siguen+una+dieta+especial.+Comer+una+dieta+sana+con+bastante+fruta+y+vegetales+y+pocos+condimentos+puede+ayudarle+con+su+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EOcasionalmente%2C+para+algunas+personas+puede+haber+ciertos+alimentos+que+pueden+empeorar+los+s%C3%ADntomas%2C+pero%2C+por+lo+general%2C+usted+sabr%C3%A1+si+esto+le+aplica.+Para+algunos%2C+es+una+alergia+a+un+alimento+lo+que+puede+detonar+su+asma%2C+aunque+es+raro.+Muy+ocasionalmente+las+bebidas+alcoh%C3%B3licas+pueden+actuar+como+detonadores+en+algunas+personas.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EUna+alergia+a+alg%C3%BAn+alimento+es+cuando+el+sistema+inmunol%C3%B3gico+del+cuerpo+reacciona+ante+la+presencia+de+ciertas+sustancias.+Los+s%C3%ADntomas+de+%C3%A9sta+pueden+variar+ampliamente+de+persona+a+persona+y%2C+as%C3%AD+como+la+sibilancia%2C+la+alergia+a+los+alimentos+puede+causar+salpullido%2C+hinchaz%C3%B3n+de+la+boca+y+s%C3%ADntomas+intestinales.+El+alimento+da%C3%B1ino+var%C3%ADa+y+puede+incluir%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EPescados+y+mariscos%3C%2Fli%3E%0D%0A%3Cli%3EAlimentos+que+contengan+levaduras+y+nueces%3C%2Fli%3E%0D%0A%3Cli%3ECiertos+aditivos+y+colorantes+de+alimentos%2C+tales+como+metabisulfito+de+sodio%2C+sulfitos%2C+%C3%A1cido+benzoico%2C+y+tartrazina%3C%2Fli%3E%0D%0A%3Cli%3EProductos+hechos+con+Jalea+Real%3C%2Fli%3E%0D%0A%3Cli%3EMuy+ocasionalmente%2C+productos+l%C3%A1cteos+tales+como+leche+y+queso%2C+y+huevos.%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3ESi+usted+considera+que+su+asma+puede+ser+afectada+por+lo+que+come%2C+consulte+al+profesional+de+la+salud+que+lo+atiende.+Puede+requerirse+la+prueba+de+al%C3%A9rgenos.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3E%C2%BFQu%C3%A9+m%C3%A1s+puede+hacer+usted%3F%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EAqu%C3%AD+hay+algunas+otras+cosas+que+usted+podr%C3%ADa+hacer%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EAseg%C3%BArese+de+que+su+asma+est%C3%A9%2C+en+general%2C+bien+controlada%2C+tomando+su+medicaci%C3%B3n+preventiva+de+manera+regular.%3C%2Fli%3E%0D%0A%3Cli%3EComa+una+dieta+saludable%2C+balanceada+y+tome+mucha+agua%3C%2Fli%3E%0D%0A%3Cli%3EUna+dieta+rica+en+fruta+y+vegetales+frescos+puede+ayudarlo+a+protegerse+contra+el+agravamiento+de+la+inflamaci%C3%B3n+en+el+asma%3C%2Fli%3E%0D%0A%3Cli%3EUna+dieta+sana+tambi%C3%A9n+puede+ayudar+a+estimular+el+sistema+inmunol%C3%B3gico%2C+lo+cual+puede+ayudar+a+prevenir+los+resfriados%2C+la+influenza+y+otras+infecciones+que+pudieran+ser+detonadores+de+su+asma%3C%2Fli%3E%0D%0A%3Cli%3ETrate+de+mantener+un+peso+saludable%3C%2Fli%3E%0D%0A%3C%2Ful%3E","imagelist":[],"registered_only":"1"},{"content_id":"251","title":"Glosario de Asma","bodytext":"%3Ch1%3EGlosario+de+Asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EAqu%C3%AD+se+presenta+una+breve+definici%C3%B3n+de+una+lista+de+palabras+y+t%C3%A9rminos+que+se+puede+encontrar+en+relaci%C3%B3n+al+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cbr%2F%3E%3Cstrong%3EAsma+aguda%3C%2Fstrong%3E+%E2%80%93+Empeoramiento+repentino+de+los+s%C3%ADntomas+del+asma%0D%0A%3Cbr%2F%3E%3Cstrong%3EAl%C3%A9rgeno%3C%2Fstrong%3E+%E2%80%93+Algo+que+entra+en+contacto+con+el+cuerpo+%28ya+sea+al+ser+inhalado%2C+o+ingerido%2C+o+en+contacto+con+la+piel%29+y+que+produce+una+respuesta+al%C3%A9rgica.%0D%0A%3Cbr%2F%3E%3Cstrong%3ERinitis+al%C3%A9rgica%3C%2Fstrong%3E+%E2%80%93+Inflamaci%C3%B3n+dentro+de+la+nariz+causando+congesti%C3%B3n%2C+estornudos%2C+flujo+nasal+y+comez%C3%B3n+en+los+ojos+debido+a+una+respuesta+al%C3%A9rgica+a+al%C3%A9rgenos+del+ambiente.+Esta+puede+ser+causada+por+al%C3%A9rgenos+que+solo+se+presentan+en+ciertas+ocasiones+del+a%C3%B1o%2C+tales+como+el+polen+%28alergia+estacional%29+o+debido+a+al%C3%A9rgenos+que+est%C3%A1n+presentes+a+lo+largo+de+todo+el+a%C3%B1o%2C+tales+como+el+polvo+de+la+casa.+Es+m%C3%A1s+com%C3%BAn+en+gente+con+asma+y+puede+desencadenar+el+asma.%0D%0A%3Cbr%2F%3E%3Cstrong%3EAnafilaxis+%28ataque+anafil%C3%A1ctico%29%3C%2Fstrong%3E+%E2%80%93+Respuesta+al%C3%A9rgica+repentina+y+severa+hacia+un+al%C3%A9rgeno%2C+que+puede+amenazar+la+vida++si+no+se+atiende+de+manera+urgente%0D%0A%3Cbr%2F%3E%3Cstrong%3EPrueba+de+Control+del+Asma+%28ACT%29%3C%2Fstrong%3E+%E2%80%93+Breve+cuestionario+para+ayudar+a+los+pacientes+a+evaluar+el+control+de+su+asma%0D%0A%3Cbr%2F%3E%3Cstrong%3EBroncoconstricci%C3%B3n%2Fbroncoespasmo%3C%2Fstrong%3E+%E2%80%93+La+contracci%C3%B3n+de+los+m%C3%BAsculos+que+rodean+las+v%C3%ADas+a%C3%A9reas+causando+el+adelgazamiento+de+los+tubos+a%C3%A9reos%2C+que+resulta+en+sibilancia%2C+dificultad+respiratoria+y+opresi%C3%B3n+en+el+pecho.%0D%0A%3Cbr%2F%3E%3Cstrong%3EBroncodilatador%3C%2Fstrong%3E+%E2%80%93+Medicamento+que+ayuda+a+abrir+%28dilatar%29+los+tubos+a%C3%A9reos.%0D%0A%3Cbr%2F%3E%3Cstrong%3ECr%C3%B3nico%3C%2Fstrong%3E+%E2%80%93+T%C3%A9rmino+usado+para+describir+una+condici%C3%B3n+o+enfermedad+de+largo+plazo%0D%0A%3Cbr%2F%3E%3Cstrong%3EEnfermedad+Pulmonar+Obstructiva+Cr%C3%B3nica+%28EPOC%29%3C%2Fstrong%3E+%E2%80%93+Enfermedad+de+los+pulmones%2C+generalmente+causada+por+fumar%2C+en+la+que+los+tubos+a%C3%A9reos+est%C3%A1n+permanentemente+constre%C3%B1idos+o+bloqueados.+Tiene+algunos+s%C3%ADntomas+y+tratamientos+en+com%C3%BAn+con+el+asma%2C+pero+en+el+asma+los+efectos+en+los+tubos+a%C3%A9reos+son+reversibles+con+el+tratamiento+correcto.%0D%0A%3Cbr%2F%3E%3Cstrong%3EControl%3C%2Fstrong%3E+%E2%80%93+Buen+control+del+asma+significa+que+no+haya+s%C3%ADntomas+de+sibilancia%2C+dificultad+para+respirar%2C+tos+u+opresi%C3%B3n+del+pecho%2C+que+no+haya+restricci%C3%B3n+de+actividades+o+ataques+de+asma+y+necesidad+de+usar+inhaladores+de+rescate+muy+poco+frecuente.+%0D%0A%3Cbr%2F%3E%3Cstrong%3ECaspa%3C%2Fstrong%3E+%E2%80%93+Pelo+o+escamas+de+piel+animal%2C+que+pueden+causar+reacciones+al%C3%A9rgicas+%0D%0A%3Cbr%2F%3E%3Cstrong%3EDiagn%C3%B3stico%3C%2Fstrong%3E+%E2%80%93+La+identificaci%C3%B3n+de+una+enfermedad+o+problema+de+salud+por+sus+signos%2C+s%C3%ADntomas+y+pruebas+m%C3%A9dicas.%0D%0A%3Cbr%2F%3E%3Cstrong%3EInhalador+de+polvo+seco%3C%2Fstrong%3E+%E2%80%93+Inhalador+que+suministra+medicamento+a+los+pulmones+en+forma+de+polvo%2C+m%C3%A1s+que+como+aerosol.%0D%0A%3Cbr%2F%3E%3Cstrong%3EExacerbaci%C3%B3n%3C%2Fstrong%3E+%E2%80%93+Ataque+de+asma%0D%0A%3Cbr%2F%3E%3Cstrong%3EAsma+inducida+por+el+ejercicio%3C%2Fstrong%3E+%E2%80%93+S%C3%ADntomas+del+asma+acarreados+por+el+ejercicio.%0D%0A%3Cbr%2F%3E%3Cstrong%3EAlergia+estacional%3C%2Fstrong%3E+%E2%80%93+Nombre+de+la+rinitis+al%C3%A9rgica+como+respuesta+al+polen++que%2C+generalmente+se+presenta+en+la+primavera.+Puede+estar+asociada+a+un+control+deficiente+del+asma.%0D%0A%3Cbr%2F%3E%3Cstrong%3EProfesional+de+la+salud%3C%2Fstrong%3E+%E2%80%93+Persona+calificada+en+una+profesi%C3%B3n+de+la+salud%2C+tal+como+m%C3%A9dico%2C+enfermera+o+farmac%C3%A9utico.%0D%0A%3Cbr%2F%3E%3Cstrong%3EInflamaci%C3%B3n%3C%2Fstrong%3E+%E2%80%93+La+inflamaci%C3%B3n+se+presenta+cuando+el+mecanismo+de+defensa+del+cuerpo+reacciona+hacia+una+lesi%C3%B3n%2C+infecci%C3%B3n+o+al%C3%A9rgenos.+Los+tejidos+inflamados+%28por+ejemplo%3A+el+recubrimiento+de+los+tubos+a%C3%A9reos+de+las+personas+con+asma%29+se+pone+rojo+e+hinchado.%0D%0A%3Cbr%2F%3E%3Cstrong%3EInhalador%3C%2Fstrong%3E+%E2%80%93+Dispositivo+que+suministra+medicamentos+contra+el+asma+a+los+pulmones.%0D%0A%3Cbr%2F%3E%3Cstrong%3EAsma+de+inicio+tard%C3%ADo%3C%2Fstrong%3E+%E2%80%93+Asma+que+comienza+en+la+edad+adulta.%0D%0A%3Cbr%2F%3E%3Cstrong%3EAntagonistas+del+receptor+de+leucotrieno+%28LTRA%29%C2%AC%3C%2Fstrong%3E+%E2%80%93+Estos+son+medicamentos+usados+para+tratar+a+algunas+personas+con+asma%2C+y+vienen+en+forma+de+tableta+m%C3%A1s+que+como+inhalador.+Los+medicamentos+de+LTRA+se+toman+regularmente+y+trabajan+bloqueando+uno+de+los+compuestos+qu%C3%ADmicos+involucrados+en+producir+la+inflamaci%C3%B3n+de+los+tubos+a%C3%A9reos.%0D%0A%3Cbr%2F%3E%3Cstrong%3EAgonistas+beta+de+larga+duraci%C3%B3n+%28LABA%29%3C%2Fstrong%3E+%E2%80%93+Un+broncodilatador+que+trabaja+por+un+periodo+de+tiempo+m%C3%A1s+largo+%28aproximadamente+12+horas%29+que+los+agonistas+beta+de+corta+duraci%C3%B3n%2C+son+generalmente+usados+con+%E2%80%9Ccomplementarios%E2%80%9D+al+tratamiento+con+esteroides+inhalados.%0D%0A%3Cbr%2F%3E%3Cstrong%3EPruebas+de+Funci%C3%B3n+Pulmonar%3C%2Fstrong%3E+%E2%80%93+Medici%C3%B3n+del+%E2%80%9Csoplado%E2%80%9D+que+se+realiza+con+dispositivos+m%C3%A9dicos%2C+que+describen+qu%C3%A9+tan+bien+est%C3%A1n+trabajando+los+pulmones+y+si+los+tubos+a%C3%A9reos+est%C3%A1n+constre%C3%B1idos.+La+medici%C3%B3n+de+flujo+m%C3%A1ximo+es+un+ejemplo+de+una+prueba+de+funci%C3%B3n+pulmonar.%0D%0A%3Cbr%2F%3E%3Cstrong%3EInhalador+%28Presurizado%29+de+Dosis+Medida+%28MDI%29%3C%2Fstrong%3E+%E2%80%93+Estos+inhaladores+usan+gas+presurizado+para+suministrar+el+medicamento+contra+el+asma%2C+como+un+roc%C3%ADo+fino+%28aerosol%29+a+los+pulmones.%0D%0A%3Cbr%2F%3E%3Cstrong%3EAsma+Ocupacional%3C%2Fstrong%3E+%E2%80%93+Asma+causada+por+al%C3%A9rgenos+inhalados+en+el+ambiente+de+trabajo%0D%0A%3Cbr%2F%3E%3Cstrong%3EOzono%3C%2Fstrong%3E+%E2%80%93+Es+un+gas+presente+en+la+atm%C3%B3sfera%2C+es+un+contaminante+cuando+est%C3%A1+presente+en+la+atm%C3%B3sfera+inferior+y+que+puede+desencadenar+el+asma.+%5BEn+la+atm%C3%B3sfera+superior+%28la+capa+de+ozono%29+el+ozono+es+ben%C3%A9fico+y+protege+contra+la+radiaci%C3%B3n+da%C3%B1ina+del+sol.%5D%0D%0A%3Cbr%2F%3E%3Cstrong%3ETasa+de+Flujo+M%C3%A1ximo%3C%2Fstrong%3E+%E2%80%93+es+una+medida+de+qu%C3%A9+tan+r%C3%A1pido+puede+una+persona+soplar+aire+de+sus+pulmones%2C+y+es%2C+por+lo+tanto%2C+una+medida+de+qu%C3%A9+tan+constre%C3%B1idos+est%C3%A1n+los+tubos+a%C3%A9reos.+Se+mide+con+un+medidor+de+tasa+de+flujo+m%C3%A1ximo+y+el+registro+regular+de+los+resultados+puede+ser+%C3%BAtil+para+el+monitoreo+del+asma.%0D%0A%3Cbr%2F%3E%3Cstrong%3EPlan+de+Acci%C3%B3n+Personal+contra+el+Asma%3C%2Fstrong%3E+%E2%80%93+Plan+de+qu%C3%A9+hacer+cuando+se+presentan+cambios+en+el+asma%2C+el+cual+contiene+detalles+de+sus+medicamentos%2C+detalles+de+sus+detonadores+del+asma%2C+c%C3%B3mo+notar+si+su+asma+est%C3%A1+empeorando+y+qu%C3%A9+hacer+si+se+tiene+un+ataque+de+asma.+Se+prepara+junto+con+el+profesional+de+la+salud+tratante%2C+es+esencial+para+ayudarle+a+mantener+el+control+de+su+asma.+%0D%0A%3Cbr%2F%3E%3Cstrong%3EPreventivo%3C%2Fstrong%3E+%E2%80%93+Medicamento+que+se+toma+de+forma+regular+para+el+control+del+asma%2C+detiene+la+inflamaci%C3%B3n+de+los+pulmones%2C+previniendo+as%C3%AD+que+los+s%C3%ADntomas+del+asma+se+presenten.+Generalmente+es+administrado+como+un+inhalador+que+se+toma+en+base+regular%2C+los+medicamentos+preventivos+son+los+m%C3%A1s+importantes+para+controlar+el+asma+y+permiti%C3%A9ndole+llevar+una+vida+plena.%0D%0A%3Cbr%2F%3E%3Cstrong%3ECuidado+Primario%3C%2Fstrong%3E+%E2%80%93+Cuidado+que+se+proporciona+por+los+profesionales+de+la+salud+en+la+comunidad%2C+actuando+como+el+primer+punto+de+contacto+para+los+pacientes.+El+Cuidado+Primario+incluye+m%C3%A9dicos+generales%2C+enfermeras+y+farmac%C3%A9uticos.%0D%0A%3Cbr%2F%3E%3Cstrong%3ESoplador%3C%2Fstrong%3E+%E2%80%93+Nombre+com%C3%BAn+para+un+inhalador%2C+en+general+uno+que+suministra+el+medicamento+en+aerosol.%0D%0A%3Cbr%2F%3E%3Cstrong%3EReferido%3C%2Fstrong%3E+%E2%80%93+Que+es+enviado+a+ver+a+un+especialista+para+asistencia+y+tratamiento.%0D%0A%3Cbr%2F%3E%3Cstrong%3EInhalador+de+Alivio%3C%2Fstrong%3E+%E2%80%93+Los+inhaladores+de+alivio%2C+tambi%C3%A9n+conocidos+como+inhaladores+de+rescate%2C+act%C3%BAan+r%C3%A1pidamente+para+relajar+las+v%C3%ADas+a%C3%A9reas%2C+facilitando+la+respiraci%C3%B3n+y+aliviando+los+s%C3%ADntomas%3B+pero+no+tienen+efecto+en+la+inflamaci%C3%B3n+subyacente.+Las+personas+con+un+buen+control+del+asma+deber%C3%A1n+necesitar+rara+vez+un+inhalador+de+alivio.%0D%0A%3Cbr%2F%3E%3Cstrong%3ERevisi%C3%B3n%3C%2Fstrong%3E+%E2%80%93+Una+revisi%C3%B3n+del+asma%2C+en+la+que+los+medicamentos+y+el+plan+de+acci%C3%B3n+personal+contra+el+asma+son+actualizados.+Usted+deber%C3%A1+someterse+a+una+revisi%C3%B3n+del+asma+una+vez+al+a%C3%B1o%2C+y+con+mayor+frecuencia+si+las+cosas+no+est%C3%A1n+bien+controladas.%0D%0A%3Cbr%2F%3E%3Cstrong%3ERinitis%3C%2Fstrong%3E+%E2%80%93+Irritaci%C3%B3n+e+inflamaci%C3%B3n+de+las+%C3%A1reas+internas+de+la+nariz+%28ver+rinitis+al%C3%A9rgica%29.%0D%0A%3Cbr%2F%3E%3Cstrong%3EAgonistas+beta+de+corta+duraci%C3%B3n+%28SABA%29%3C%2Fstrong%3E+%E2%80%93+El+tipo+de+medicamento+usado+en+los+inhaladores+de+alivio%2C+que+act%C3%BAa+como+broncodilatador%2C+abriendo+los+tubos+a%C3%A9reos.+Estos+medicamentos+empiezan+a+trabajar+en+unos+cuantos+minutos%2C+pero+no+afectan+la+inflamaci%C3%B3n+subyacente+en+el+asma%2C+y+deber%C3%ADan+necesitarse+rara+vez+en+el+asma+bien+controlada.%0D%0A%3Cbr%2F%3E%3Cstrong%3EPrueba+de+punci%C3%B3n+de+la+piel%3C%2Fstrong%3E+%E2%80%93+Una+prueba+de+alergias%2C+en+la+que+una+peque%C3%B1a+cantidad+de+al%C3%A9rgeno+es+inoculada+en+la+piel+por+punci%C3%B3n%2C+para+ver+si+se+presenta+una+reacci%C3%B3n.%0D%0A%3Cbr%2F%3E%3Cstrong%3EEspirometr%C3%ADa%3C%2Fstrong%3E+%E2%80%93+Pruebas+detalladas+de+soplado+que+se+llevan+a+cabo+para+determinar+qu%C3%A9+tan+bien+est%C3%A1n+funcionando+los+pulmones.+Estas+dan+m%C3%A1s+informaci%C3%B3n+sobre+el+estado+de+los+pulmones+y+los+tubos+a%C3%A9reos+que+lo+que+hacen+los+medidores+de+flujo+m%C3%A1ximo.%0D%0A%3Cbr%2F%3E%3Cstrong%3EEsteroides%3C%2Fstrong%3E+%E2%80%93+Grupo+de+compuestos+qu%C3%ADmicos+producidos+por+el+cuerpo+y+tambi%C3%A9n+fabricados+por+s%C3%ADntesis+como+medicamentos+ya+sea+en+un+inhalador+o+en+forma+de+tableta.+En+el+asma%2C+son+usados+para+tratar+la+inflamaci%C3%B3n+de+las+v%C3%ADas+a%C3%A9reas%2C+que+es+la+causa+de+los+s%C3%ADntomas.%0D%0A%3Cbr%2F%3E%3Cstrong%3ETeofilina%3C%2Fstrong%3E+%E2%80%93+Medicamento+usado+en+algunos+pacientes%2C+el+cual+trabaja+relajando+los+m%C3%BAsculos+que+rodean+los+tubos+a%C3%A9reos%2C+y+que+por+lo+general+es+administrado+en+forma+de+tableta.+Es+importante+que+la+dosis+de+teofilina+sea+la+correcta+para+la+persona+que+la+toma%2C+por+lo+que+deber%C3%A1n+hacerse+pruebas+de+sangre+para+revisarla.%0D%0A%3Cbr%2F%3E%3Cstrong%3EDetonadores%3C%2Fstrong%3E+%E2%80%93+Factores+que+pueden+irritar+las+v%C3%ADas+a%C3%A9reas+y+que+acarrean+s%C3%ADntomas+asm%C3%A1ticos+o+ataques+de+asma%0D%0A%3Cbr%2F%3E%3Cstrong%3EControl+inadecuado%2Fdeficiente+del+Asma%3C%2Fstrong%3E+%E2%80%93+Es+cuando+los+s%C3%ADntomas+asm%C3%A1ticos+no+est%C3%A1n+bien+controlados%2C+y+si+no+se+hace+algo+podr%C3%ADa+conducir+a+un+ataque+extenso+de+asma.+Use+la+Prueba+de+Control+del+Asma+para+ayudarse+a+evaluar+qu%C3%A9+tan+bien+est%C3%A1+controlada+su+asma.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"252","title":"De paseo","bodytext":"%3Ch1%3EDe+paseo%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEl+tener+asma+no+debe+restringir+su+vida+social+de+ninguna+manera%2C+ni+poner+l%C3%ADmites+de+d%C3%B3nde+va%2C+sean+bares%2C+clubes+o+visitas+a+amigos+y+familia.+Si+su+asma+est%C3%A1+bien+controlada%2C+usted+deber%C3%A1+poder+llevar+una+vida+plena+y+activa.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEs+importante+conocer+sus+detonadores+y+evitarlos+hasta+donde+sea+posible.+Por+ejemplo%2C+si+el+polen+puede+desencadenar+los+s%C3%ADntomas+de+su+asma%2C+verifique+el+pron%C3%B3stico+de+los+niveles+de+polen+y+tome+las+medidas+necesarias+para+evitarlo+%28esto+deber%C3%A1+estar+en+su+plan+de+acci%C3%B3n+personal+contra+el+asma%29.+Asimismo+verifique+condiciones+como+la+temperatura+de+modo+que+usted+se+pueda+preparar+para+el+clima+fr%C3%ADo+o+caliente.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELas+alergias+a+los+alimentos+no+son+una+causa+com%C3%BAn+de+asma%2C+pero+algunos+alimentos+pueden+actuar+como+detonadores+en+algunas+personas.+Usted+puede+consultar+este+punto+con+el+profesional+de+la+salud+que+lo+atiende%2C+si+considera+que+este+es+un+problema+para+usted%2C+y+%C3%A9l+podr%C3%A1+decidir+si+usted+requiere+de+pruebas+adicionales.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEl+fumar+de+manera+pasiva+puede+ser+un+detonador%2C+por+lo+que+deber%C3%A1+cuidarse+de+las+atm%C3%B3sferas+con+humo+de+cigarro%2C+que+no+son+buenas+para+nadie.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESiempre+tenga+su+inhalador+de+alivio+con+usted+a+donde+quiera+que+vaya%2C+y+si+usted+sale+con+amigos+es+buena+idea+decirles%2C+si+as%C3%AD+lo+desea%2C+lo+que+pueden+hacer+para+ayudarle+en+caso+de+un+ataque+de+asma.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ES%C3%AD+su+asma+es+tratada+de+manera+adecuada%2C+es+poco+probable+que+tenga+un+ataque+de+asma%2C+pero+si+lo+tiene+cuando+salga%2C+siga+estas+recomendaciones%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E1.%09Tome+dos+inhalaciones+de+su+inhalador+de+alivio+inmediatamente%0D%0A%3Cbr%2F%3E2.%09Si%C3%A9ntese%2C+afloje+cualquier+ropa+apretada%2C+y+trate+de+respirar+con+lentitud+y+regularidad%0D%0A%3Cbr%2F%3E3.%09Si+no+se+empieza+a+sentir+mejor%2C+haga+otras+dos+inhalaciones+con+su+inhalador-+una+por+una+%E2%80%93+cada+dos+minutos%2C+hasta+10+inhalaciones%2C+o+hasta+que+sus+s%C3%ADntomas+mejoren.+%0D%0A%3Cbr%2F%3E4.%09Si+no+se+siente+mejor+despu%C3%A9s+de+realizar+las+inhalaciones+como+se+indic%C3%B3+anteriormente+o+si+se+siente+preocupado+en+cualquier+momento%2C+llame+a+una+ambulancia%0D%0A%3Cbr%2F%3E5.%09Si+la+ambulancia+no+llega+en+un+lapso+de+10+minutos%2C+y+sus+s%C3%ADntomas+no+han+mejorado%2C+repita+el+paso+3+hasta+que+llegue+la+ayuda%3C%2Fp%3E%0D%0A%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"253","title":"Rinitis al\u00e9rgica y alergia estacional","bodytext":"%3Ch1%3ERinitis+al%C3%A9rgica+y+alergia+estacional%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELa+rinitis+al%C3%A9rgica+es+una+condici%C3%B3n+causada+por+la+inflamaci%C3%B3n+de+la+nariz+debida+a+una+respuesta+al%C3%A9rgica+a+al%C3%A9rgenos+en+el+aire.+Esta+resulta+en+congesti%C3%B3n%2C+estornudos%2C+flujo+nasal+y+comez%C3%B3n+en+los+ojos.+La+rinitis+al%C3%A9rgica+puede+deberse+a+al%C3%A9rgenos+que+se+presentan+s%C3%B3lo+en+ciertas+%C3%A9pocas+del+a%C3%B1o+%28tales+como+el+polen%29+cuando+se+llama+rinitis+al%C3%A9rgica+intermitente%2C+o+se+debe+a+al%C3%A9rgenos+que+est%C3%A1n+presentes+durante+todo+el+a%C3%B1o+%28tal+como+el+polvo+de+la+casa%29+cuando+se+llama+rinitis+al%C3%A9rgica+persistente.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cu%3ELa+rinitis+al%C3%A9rgica+puede+actuar+como+un+detonador+del+asma+y%2C+por+lo+tanto%2C+es+importante+asegurarse+que+sea+tratada+de+manera+efectiva+s%C3%AD+es+un+problema+para+usted.%3C%2Fu%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cstrong%3EAlergia+estacional%3C%2Fstrong%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELa+rinitis+al%C3%A9rgica+intermitente+causada+por+una+reacci%C3%B3n+al+polen+o+a+las+esporas+en+la+atm%C3%B3sfera+es+com%C3%BAnmente+llamada+alergia+estacional+o+fiebre+del+heno.+Muchos+tipos+de+polen+o+esporas%2C+tales+como+los+de+pasto%2C+%C3%A1rboles+o+ciertas+flores%2C+pueden+desencadenar+una+reacci%C3%B3n%2C+pero+usted+puede+no+ser+al%C3%A9rgico+a+todos+ellos.+Trate+de+identificar+cu%C3%A1les+son+problem%C3%A1ticos+para+usted%2C+anotando+la+%C3%A9poca+del+a%C3%B1o+y+las+ubicaciones+donde+usted+es+m%C3%A1s+afectado.+Tambi%C3%A9n+es+posible+realizar+pruebas+simples%2C+tales+como+la+prueba+de+punci%C3%B3n+de+la+piel+o+la+prueba+sangu%C3%ADnea+de+alergias%2C+las+cuales+pueden+ayudar+a+determinar+a+qu%C3%A9+es+al%C3%A9rgico+usted.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELa+alergia+estacional+es+m%C3%A1s+com%C3%BAn+en+personas+con+asma.+Hasta+un+30%25+de+las+personas+con+rinitis+al%C3%A9rgica+tambi%C3%A9n+tienen+asma+y+la+mayor%C3%ADa+de+las+personas+con+asma+tambi%C3%A9n+tienen+rinitis+al%C3%A9rgica.+%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EQu%C3%A9+puede+hacer%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3E%3Cstrong%3ETratamientos%3C%2Fstrong%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EUsted+puede+tratar+de+aliviar+los+s%C3%ADntomas+de+su+rinitis+al%C3%A9rgica+con+una+variedad+de+tratamientos+disponibles.+Puede+comprar+algunos+tratamientos+%E2%80%9Csin+receta%E2%80%9D+en+una+farmacia+y+otros+requieren+la+prescripci%C3%B3n+de+su+m%C3%A9dico.+Si+usted+ha+probado+medicamentos+que+no+requieren+receta+y+sus+s%C3%ADntomas+aun+siguen+caus%C3%A1ndole+problemas%2C+pregunte+a+su+doctor%2C+enfermera+o+farmac%C3%A9utico%2C+qu%C3%A9+otro+tratamiento+hay+disponible.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cstrong%3EEvite+los+detonadores%3C%2Fstrong%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EPuede+no+ser+posible+evitar+completamente+el+polen+si+usted+tiene+alergia+estacional%2C+pero+hay+cosas+que+puede+hacer+para+reducir+su+exposici%C3%B3n+a+%C3%A9ste%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EVerifique+el+pron%C3%B3stico+de+polen+y+trate+de+permanecer+en+un+local+cerrado+con+puertas+y+ventanas+cerradas+si+la+cantidad+de+polen+es+alta%2C+especialmente+en+la+ma%C3%B1ana+y+por+la+tarde-noche%3C%2Fli%3E%0D%0A%3Cli%3EUse+anteojos+envolventes+que+pueden+ayudarle+a+reducir+la+cantidad+del+polen+que+llegue+a+sus+ojos%3C%2Fli%3E%0D%0A%3Cli%3ENo+seque+la+ropa+a+la+intemperie+cuando+la+cantidad+de+polen+sea+alta+ya+que+el+polen+puede+quedar+atrapado+en+su+ropa%3C%2Fli%3E%0D%0A%3Cli%3ETome+una+ducha+despu%C3%A9s+de+salir+a+la+intemperie+si+la+cantidad+de+polen+es+alta%3C%2Fli%3E%0D%0A%3Cli%3ERociar+agua+sobre+su+cara+lava+el+polen+y+reconforta+los+ojos%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"254","title":"Pruebas de Funci\u00f3n Pulmonar","bodytext":"%3Ch1%3EPruebas+de+Funci%C3%B3n+Pulmonar%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELas+pruebas+de+funci%C3%B3n+pulmonar+son+realizadas+soplando+en+instrumentos+de+medici%C3%B3n+y+son+%C3%BAtiles+tanto+para+diagnosticar+como+para+monitorear+el+asma.+Hay+dos+tipos+principales+de+pruebas+de+funci%C3%B3n+pulmonar%2C+que+usted+puede+solicitar+le+sean+aplicadas.+Un+tipo+de+prueba+es+llamada+espirometr%C3%ADa+%28se+realiza+con+una+m%C3%A1quina+llamada+espir%C3%B3metro%29+y+el+otro+tipo+de+prueba+es+llamado+flujo+espiratorio+m%C3%A1ximo+%28medido+en+medidor+de+flujo+espiratorio+m%C3%A1ximo%29.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cstrong%3EEspirometr%C3%ADa%3C%2Fstrong%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELa+espirometr%C3%ADa+es+usada+por+los+profesionales+de+la+salud+para+evaluar+y+diagnosticar+el+asma+y+otras+enfermedades+pulmonares.+Este+mide+qu%C3%A9+tanto+aire+usted+puede+desplazar+hacia+dentro+y+hacia+afuera+de+sus+pulmones%2C+qu%C3%A9+tan+r%C3%A1pido+los+puede+vaciar%2C+y+qu%C3%A9+tanto+puede+usted+soplar+en+un+segundo.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3E%3Cstrong%3EFlujo+espiratorio+m%C3%A1ximo%3C%2Fstrong%3E%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELa+tasa+de+flujo+espiratorio+m%C3%A1ximo%2C+tambi%C3%A9n+conocida+como+flujo+m%C3%A1ximo%2C+o+PEF%2C+es+una+medida+de+la+m%C3%A1xima+velocidad+de+flujo+de+aire+hacia+fuera+de+los+pulmones%2C+cuando+se+sopla+tan+fuerte+como+sea+posible.+Este+proporciona+una+medida+de+qu%C3%A9+tan+bien+controlada+est%C3%A1+su+asma%2C+as%C3%AD+como+de+la+efectividad+de+su+tratamiento.+Las+lecturas+se+obtienen+soplando+en+un+medidor+de+flujo+m%C3%A1ximo+y+mientras+m%C3%A1s+constre%C3%B1idas+est%C3%A1n+sus+v%C3%ADas+a%C3%A9reas%2C+m%C3%A1s+baja+ser%C3%A1+la+lectura.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EUsted+puede+obtener+un+medidor+de+flujo+m%C3%A1ximo+con+la+prescripci%C3%B3n+del+profesional+de+la+salud+que+lo+atiende%2C+si+concuerda+en+que+ser%C3%ADa+%C3%BAtil+para+usted.+Usted+puede+usarlo+en+casa+para+medir+regularmente+su+propio+flujo+m%C3%A1ximo+y+llevar+un+registro+de+los+resultados.+Tal+registro+puede+proporcionar++una+imagen+%C3%BAtil+de+qu%C3%A9+tan+bien+controlada+est%C3%A1+su+asma%2C+ayudarle+a+optar+por+un+cambio+en+su+tratamiento+seg%C3%BAn+lo+acordado+en+su+plan+de+acci%C3%B3n+personal+contra+el+asma+y+le+puede+proporcionar+informaci%C3%B3n+%C3%BAtil+al++profesional+de+la+salud+que+lo+atiende.+El+monitoreo+del+flujo+m%C3%A1ximo+puede+ser+%C3%BAtil+para+ayudar+a+prevenir+un+ataque+de+asma%2C+especialmente+en+las+personas+que+no+perciben+s%C3%ADntomas+de+su+asma+hasta+que+ya+est%C3%A1+muy+mal.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EUna+ca%C3%ADda+en+la+lectura+del+flujo+m%C3%A1ximo+indica+que+su+asma+est%C3%A1+empeorando+y+podr%C3%ADa+significar+que+se+encuentra+en+riesgo+de+un+ataque+de+asma.+Consulte+al+profesional+de+la+salud+respecto+a+lo+que+debe+hacer+si+esto+pasa.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESi+usted+est%C3%A1+realizando+la+medici%C3%B3n+del+flujo+m%C3%A1ximo%2C+como+parte+de+su+plan+de+acci%C3%B3n+personal+contra+el+asma%2C+mantenga+un+buen+trabajo+y+h%C3%A1galo+regularmente.+Si+usted+no+cuenta+con+un+medidor+de+flujo+m%C3%A1ximo%2C+hable+con+el+profesional+de+la+salud+que+lo+atiende%2C+e+investigue+si+uno+le+podr%C3%ADa+ayudar+en+el+control+de+su+asma.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"255","title":"Medicamentos contra el Asma","bodytext":"%3Ch1%3EMedicamentos+contra+el+Asma+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EHay+muchos+medicamentos+diferentes+para+el+tratamiento+del+asma+y+la+mayor%C3%ADa+son+tomados+como+inhaladores.+El+profesional+de+la+salud+que+lo+atiende+revisar%C3%A1+con+usted+los+tratamientos+posibles%2C+y+juntos+acordar%C3%A1n+los+m%C3%A1s+adecuados+para+usted.+A+continuaci%C3%B3n+se+presenta+una+breve+descripci%C3%B3n+de+algunos+t%C3%A9rminos+que+puede+oir.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EMedicamentos+de+Alivio%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EMedicamento+de+alivio+proporciona+alivio+r%C3%A1pido+pero+de+corta+duraci%C3%B3n+de+la+opresi%C3%B3n+del+pecho++y+sibilancia%2C+relajando+las+v%C3%ADas+a%C3%A9reas+constre%C3%B1idas+%28broncoconstricci%C3%B3n%29+ayudando+a+mejorar+los+s%C3%ADntomas+de+sibilancia+y+dificultad+para+respirar.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELa+mayor%C3%ADa+de+los+medicamentos+de+alivio+recomendados+son+f%C3%A1rmacos+llamados+agonistas+beta-2+de+corta+duraci%C3%B3n.+Estos+trabajan+en+unos+cuantos+minutos+para+facilitarle+la+respiraci%C3%B3n.+Hay+diversos+inhaladores+de+alivio+que+pueden+ser+usados.+El+profesional+al+cuidado+de+la+salud+que+lo+atiende+le+indicar%C3%A1+cu%C3%A1l+es+el+m%C3%A1s+adecuado+para+usted.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELleve+su+medicamento+de+alivio+con+usted%2C+en+caso+de+que+experimente+s%C3%ADntomas%3B+sin+embargo%2C+los+medicamentos+de+alivio+no+deber%C3%ADan+ser+necesarios+con+frecuencia.+Si+usted+los+necesita+la+mayor%C3%ADa+de+los+d%C3%ADas%2C+o+con+frecuencia+se+despierta+en+las+noches+porque+los+necesita%2C+entonces+su+asma+no+est%C3%A1+bien+controlada+y+deber%C3%A1+consultar+a+un+profesional+de+la+salud.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EMedicamentos+Preventivos%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELas+personas+con+asma+tienen+inflamaci%C3%B3n+de+la+mucosa+de+los+tubos+a%C3%A9reos.+Esta+inflamaci%C3%B3n+causa+irritaci%C3%B3n+y+constri%C3%B1e+estos+tubos%2C+lo+que+a+su+vez+causa+los+s%C3%ADntomas+de+sibilancia%2C+opresi%C3%B3n+del+pecho+y+tos.+Los+medicamentos+preventivos+est%C3%A1n+dise%C3%B1ados+para+reducir+esta+inflamaci%C3%B3n+de+los+tubos+a%C3%A9reos%2C+prevenir+los+s%C3%ADntomas+que+se+presentan+y+prevenir+los+ataques+de+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EPara+alcanzar+este+efecto+de+protecci%C3%B3n%2C+debe+tomar+sus+medicamentos+de+manera+regular+%28generalmente+en+la+ma%C3%B1ana+y+por+la+noche%2C+aunque+a+veces+solo+una+vez+al+d%C3%ADa%29%2C+aun+cuando+se+sienta+bien%2C+dado+que+casi+siempre+habr%C3%A1+una+inflamaci%C3%B3n+persistente+en+los+pulmones%2C+que+causar%C3%A1+problemas+m%C3%A1s+tarde+o+m%C3%A1s+temprano%2C+si+se+deja+sin+tratamiento.+A+la+mayor%C3%ADa+de+las+personas+con+asma+se+les+recetar%C3%A1n+medicamentos+preventivos%2C+ya+que+son+la+piedra+angular+del+tratamiento.+%3C%2Fp%3E%0D%0A%3Ch1%3EOtros+medicamentos%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESi+su+asma+no+est%C3%A1+bien+controlada+con+el+medicamento+preventivo+que+toma+de+manera+regular%2C+el+profesional+de+la+salud+que+lo+atiende+le+puede+sugerir+usar+una+terapia+adicional+o+%E2%80%9Ccomplementaria%E2%80%9D%2C+tal+como+un+broncodilatador+de+larga+duraci%C3%B3n+para+ayudarle+a+retomar+el+control.+Tambi%C3%A9n+hay+terapias+que+consisten+de+medicamentos+tanto+preventivos+como+broncodilatadores.+Hay+otros+tipos+y+formatos+de+medicamentos+para+ayudar+al+profesional+de+la+salud++que+lo+atiende+a+darle+el+tratamiento+m%C3%A1s+adecuado+para+sus+necesidades.+%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EEfectos+secundarios%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EMuchas+personas+se+preocupan+por+los+efectos+secundarios+de+los+medicamentos+contra+el+asma%2C+particularmente%2C+s%C3%AD+%C3%A9ste+se+toma+por+un+periodo+de+tiempo+largo.+Se+ha+realizado+mucha+investigaci%C3%B3n+de+los+beneficios+y+de+los+efectos+secundarios+de+los+medicamentos+contra+el+asma%2C+y+en+general%2C+el+beneficio+de+usarlos+ha+demostrado+sobrepasar+los+riesgos+de+usarlos+en+aquellos+que+los+necesitan.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ELos+esteroides+usados+en+muchos+inhaladores+preventivos%2C+a+las+dosis+que+la+mayor%C3%ADa+de+las+personas+usa%2C+no+causan+adicci%C3%B3n%2C+no+pierden+sus+efectos+con+el+tiempo+ni+causan+aumento+de+peso.+La+mayor%C3%ADa+de+las+personas+con+asma+requieren+solo+dosis+bajas+de+esteroides+inhalados%2C+lo+cual+es+poco+probable+que+cause+efectos+secundarios+graves+en+el+cuerpo.+Algunas+veces%2C+los+esteroides+inhalados+de+manera+regular+pueden+tener+efectos+en+la+boca%2C++causando+%C3%BAlceras+o+aftas%2C+pero+esto+puede+ser+evitado%2C+por+lo+general%2C+con+medidas+simples+tales+como+enjuagarse+la+boca+despu%C3%A9s+de+usar+el+inhalador+o+%3Ca+href%3D%22content_247%22%3Eusando+un+dispositivo+espaciador%3C%2Fa%3E.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEn+la+medida+en+que+la+dosis+de+tratamiento+se+incremente%2C+se+incrementa+el+posible+riesgo+de+efectos+secundarios%3B+sin+embargo%2C+las+dosis+altas+solo+se+requieren+rara+vez+y+s%C3%B3lo+son+necesarias+si+su+asma+no+est%C3%A1+bien+controlada.+El+profesional+de+la+salud+que+lo+atiende+trabajar%C3%A1+junto+con+usted+para+mantener+un+buen+control+y+conservar+su+medicamento+en+la+dosis+m%C3%A1s+baja+posible.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEl+instructivo+de+informaci%C3%B3n+para+el+paciente+que+usted+recibe+con+su+tratamiento+para+el+asma+tiene+informaci%C3%B3n+detallada+sobre+los+efectos+secundarios.+Si+est%C3%A1+preocupado+con+respecto+a+efectos+secundarios+particulares%2C+o+considera+que+un+tratamiento+le+est%C3%A1+causando+alg%C3%BAn+efecto+secundario%2C+consulte+al+profesional+de+la+salud+que+le+atiende.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"256","title":"Mascotas","bodytext":"%3Ch1%3EMascotas+y+asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ELos+animales+y+las+mascotas%2C+generalmente+de+los+que+tienen+pelaje+o+plumas%2C+pueden+algunas+veces+actuar+como+detonadores+de+los+s%C3%ADntomas+del+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEsto+puede+ser+particularmente+problem%C3%A1tico+en+el+ambiente+del+hogar+donde+los+al%C3%A9rgenos+que+desencadenan+el+asma+son+aparentemente+perros%2C+gatos%2C+caballos%2C+roedores+o+aves%2C+lo+que+se+convierte+en+un+evento+potencialmente+de+largo+plazo.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EDebido+a+que+los+al%C3%A9rgenos+de+las+mascotas+son+f%C3%A1cilmente+transferidos+a+la+ropa+de+las+personas%2C+tambi%C3%A9n+se+pueden+encontrar+en+lugares+como+las+escuelas+y+otros+edificios+p%C3%BAblicos%2C+y+pueden+llevarse+a+la+casa+de+alguien+que+no+tenga+mascotas.+Estar+en+contacto+cercano+con+una+persona+que+est%C3%A9+regularmente+en+contacto+con+animales+puede+ser+un+detonador+del+asma.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEs+posible+hacerse+una+prueba+de+alergia+a+las+mascotas.+%C3%89sta+es+generalmente+una+prueba+de+punci%C3%B3n+en+la+piel+o+una+simple+prueba+de+sangre%2C+y+puede+valer+la+pena+consultar+a+su+m%C3%A9dico%2C+si+usted+considera+que+tiene+este+tipo+de+alergia.+Si+una+mascota+est%C3%A1+desencadenando+sus+s%C3%ADntomas+de+asma%2C+la+soluci%C3%B3n+m%C3%A1s+efectiva+es+encontrar+una+nueva+casa+que+sea+adecuada+para+su+mascota.+Aun+entonces%2C+el+tener+una+reducci%C3%B3n+significativa+en+los+niveles+del+al%C3%A9rgeno+podr%C3%ADa+tomar+hasta+seis+meses%2C+y+los+s%C3%ADntomas+podr%C3%ADan+no+ceder+completamente.+Otros+m%C3%A9todos%2C+tales+como+el+uso+de+filtros+de+aire+o+ba%C3%B1ar+con+regularidad+a+la+mascota+no+son+efectivos.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESin+embargo%2C+las+mascotas+son+importantes+para+muchos+de+nosotros+y+podemos+estar+muy+ligados+a+ellas.+Por+lo+tanto%2C+usted+necesita+sopesar+el+placer+de+tener+una+mascota+y+el+efecto+que+%C3%A9sta+tiene+en+su+asma%2C++si+es+que+la+mascota+es+un+detonador+del+asma.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EHay+otras+medidas+que+podr%C3%ADan+ayudarle+a+reducir+el+problema.%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3ERestringir+el+acceso+de+su+mascota+ciertas+habitaciones+de+la+casa+y+mantenerla+fuera+de+la+rec%C3%A1mara+%3C%2Fli%3E%0D%0A%3Cli%3ENo+permita+que+su+mascota+se+suba+a+los+muebles%3C%2Fli%3E%0D%0A%3Cli%3EMantenga+las+habitaciones+bien+ventiladas%3C%2Fli%3E%0D%0A%3Cli%3EConsidere+retirar+las+alfombras+y+tener+pisos+duros%3C%2Fli%3E%0D%0A%3Cli%3ETome+precauciones+cuando+visite+una+casa+con+mascotas%2C+y+tambi%C3%A9n+observe+como+maneja+a+las+mascotas+o+a+los+animales%3C%2Fli%3E%0D%0A%3C%2Ful%3E","imagelist":[],"registered_only":"1"},{"content_id":"257","title":"Las Relaciones","bodytext":"%3Ch1%3ELas+Relaciones+y+el+Asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EAlgunas+personas+se+sienten+avergonzadas+de+tener+asma+y+piensan+que+%C3%A9sta+las+segrega+y+est%C3%A1n+preocupadas+respecto+a+c%C3%B3mo+el+asma+podr%C3%ADa+impactar+en+sus+relaciones+con+amigos%2C+familia+y+colegas+del+trabajo+o+escuela.+El+tener+que+usar++un+inhalador+enfrente+de+otras+personas+a+menudo+es+embarazoso+y+tener+un+ataque+de+asma+en+p%C3%BAblico+puede+ser+alarmante+para+todos+los+involucrados.+Esto+no+deber%C3%ADa+pasar+si+su+asma+est%C3%A1+bien+controlada.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESin+embargo%2C+hay+muchas+cosas+que+usted+puede+hacer+para+mantener+su+asma+bajo+control+y+para+evitar+que+usted+sufra+un+ataque+de+asma.+Si+usted+est%C3%A1+tomando+su+medicamento+como+se+acord%C3%B3+con+el+profesional+de+la+salud+que+la+atiende%2C+durante+la+revisi%C3%B3n+de+su+asma%2C+y+seg%C3%BAn+lo+anotado+en+un+plan+de+acci%C3%B3n+personal+contra+el+asma%2C+entonces+sus+s%C3%ADntomas+no+deber%C3%ADan+alterar+demasiado+su+vida.+Explique+a+sus+amigos+respecto+al+asma+y+lo+m%C3%A1s+probable+es+que+no+haya+problemas+al+respecto.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EDel+mismo+modo%2C+usted+podr%C3%ADa+evitar+ciertas+cosas+que+desencadenen+su+asma.+Si+por+ejemplo%2C+algunos+de+sus+amigos+fuman%2C+expl%C3%ADqueles+la+situaci%C3%B3n+y+p%C3%ADdales+abrir+la+ventana+o+que+fumen+cuando+est%C3%A9n+en+una+habitaci%C3%B3n+diferente.+Otros+detonadores%2C+tales+como+un+perfume+fuerte+o+una+loci%C3%B3n+para+despu%C3%A9s+de+afeitarse%2C+podr%C3%ADan+requerir+que+le+solicite+a+su+amigo+%C2%A1bajarle+un+poco%21+%3Ca+href%3D%22content_259%22%3EPara+algunas+personas+el+ejercicio+de+tener+relaciones+sexuales+puede+ser+un+detonador+de+los+s%C3%ADntomas+del+asma%3C%2Fa%3E.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ENo+hay+ninguna+raz%C3%B3n+para+que+el+asma+lo+a%C3%ADsle+de+otras+personas.+Siempre+es+mejor+hablar+de+sus+inquietudes+con+su+familia+o+con+el+profesional+de+la+salud+que+lo+atiende.+%0D%0A%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"258","title":"Estaci\u00f3n del A\u00f1o","bodytext":"%3Ch1%3EEstaci%C3%B3n+del+A%C3%B1o+y+Asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EComo+seguramente+usted+lo+sabe%2C+las+diferentes+personas+tienen+detonadores+diferentes+para+los+s%C3%ADntomas+de+su+asma.+Estos+pueden+estar+presentes+durante+todo+el+a%C3%B1o%2C+tales+como+el+humo+de+tabaco%2C+o+alergia+a+las+mascotas%2C+o+pueden+estar+relacionadas+particularmente+a+las+diferentes+%C3%A9pocas+del+a%C3%B1o.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EPor+lo+que%2C+adem%C3%A1s+de+asegurarse+de+que+su+asma+est%C3%A9+bien+controlada+en+general%2C+aqu%C3%AD+hay+algunas+sugerencias+que+pueden+ayudarle+con+su+asma+durante+todas+las+estaciones+del+a%C3%B1o.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EPrimavera+y+Verano%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3ESe+sabe+que+el+clima+caliente+y+h%C3%BAmedo+es+un+detonador+del+asma%2C+por+lo+que+deber%C3%A1+llevar+su+inhalador+de+alivio+con+usted+en+tales+condiciones.+Asimismo%2C+la+contaminaci%C3%B3n+del+aire+y+el+ozono+pueden+ser+un+detonador+para+algunas+personas%2C+siendo+posiblemente+m%C3%A1s+altos+en+d%C3%ADas+c%C3%A1lidos%2C+por+lo+que+es+recomendable+evitar+el+ejercicio+al+aire+libre.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEl+polen+puede+ser+un+detonante+del+asma+como+puede+ser+la+alergia+estacional%2C+por+lo+que+debe+verificar+el+pron%C3%B3stico+del+polen+y+aprender+a+reducir+su+exposici%C3%B3n+a+estos+al%C3%A9rgenos.+%3Ca+href%3D%22content_253%22%3EPuede+encontrar+m%C3%A1s+informaci%C3%B3n+referente+a+la+alergia+estacional+seleccionando+el+v%C3%ADnculo+siguiente+%3C%2Fa%3E.+Para+algunas+personas+los+s%C3%ADntomas+del+asma+son+puramente+estacionales%2C+present%C3%A1ndose+en+ciertas+%C3%A9pocas+del+a%C3%B1o%2C+tales+como+cuando+la+cantidad+de+polen+es+alta.+Para+estas+personas+es+importante+tomar+medicamentos+preventivos+por+2-3+semanas+antes+y+durante+la+estaci%C3%B3n+de+riesgo.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3EOto%C3%B1o+e+Invierno+%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EEl+aire+fr%C3%ADo+y+los+cambios+repentinos+de+temperatura+son+detonadores+comunes+del+asma%2C+as%C3%AD+que+abr%C3%ADguese+bien+en+el+invierno+y+cu%C3%ADdese+cuando+pase+de+una+habitaci%C3%B3n+caliente+a+las+temperaturas+fr%C3%ADas+del+exterior.+Una+bufanda+alrededor+de+la+cara+le+ayudar%C3%A1+a+calendar+el+aire+antes+de+respirarlo+y+conserve+su+inhalador+de+alivio+con+usted.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EOto%C3%B1o+e+invierno+son+usualmente+las+%C3%A9pocas+del+a%C3%B1o+cuando+con+m%C3%A1s+frecuencia+sufrimos+de+resfriados%2C+influenza+y+otras+infecciones+que+pueden+desencadenar+el+asma.+Es+una+buena+idea+consultar+al+profesional+de+la+salud+que+lo+atiende+en+relaci%C3%B3n+a+lo+que+usted+puede+hacer+para+prevenir+estas+infecciones%2C+y+qu%C3%A9+medicamentos+o+vacunas+pueden+serle+adecuados.+Si+le+da+gripa+o+influenza+es+importante+vigilar+de+cerca+su+asma+y+tratar+pronto+cualquier+complicaci%C3%B3n+o+empeoramiento+de+los+s%C3%ADntomas+de+su+asma.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"259","title":"Sexo y Asma","bodytext":"%3Ch1%3ESexo+y+Asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EPara+muchas+personas+el+sexo+es+una+parte+importante+de+una+relaci%C3%B3n+sana+y+de+su+bienestar+general.+Sin+embargo%2C+para+algunas+personas+el+asma+es+un+obst%C3%A1culo+para+el+sexo+-+en+una+encuesta+a+personas+que+hab%C3%ADan+tenido+visitas+de+hospitalizaci%C3%B3n+relacionadas+con+el+asma%2C+casi+el+60%25+dijo+que+su+actividad+sexual+estaba+limitada+por+su+asma.+Esto+no+ocurrir%C3%A1+si+usted+tiene+el+tratamiento+correcto%2C+y+si+ocurre%2C+debe+hablar+con+el+profesional+de+la+salud+que+lo+atiende+y+revisar+su+plan+de+acci%C3%B3n+personal+contra+el+asma.+La+mayor%C3%ADa+de+las+personas+no+han+hablado+con+el+profesional+de+la+salud+tratante+sobre+este+tema%2C+pero+realmente+deber%C3%ADan+hacerlo.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EHay+varias+cosas+que+usted+podr%C3%ADa+hacer+para+ayudar+a+controlar+cualquier+s%C3%ADntoma+que+pudiera+experimentar+durante+la+actividad+sexual.+Algunas+veces%2C+simplemente+el+uso+de+su+inhalador+de+alivio+inmediatamente+antes+de+tener+relaciones+sexuales%2C+puede+ser+todo+lo+que+necesita%3B+pero+algunas+veces+su+medicamento+regular+necesitar%C3%A1+cambiar.+Asimismo%2C+al+igual+que+con+otras+formas+de+ejercicio+f%C3%ADsico%2C+hay+maneras+de+mejorar+su+estado+y+salud+general+que+pueden+ser+ben%C3%A9ficas.+Visite+la+secci%C3%B3n+de+Ejercicio+para+mayores+detalles%2C+%3Ca+href%3D%22content_248%22%3Eseleccionando+el+v%C3%ADnculo+%3C%2Fa%3E.%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"},{"content_id":"260","title":"Fumar","bodytext":"%3Ch1%3EFumar+y+Asma%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EIndudablemente+usted+ya+lo+escuch%C3%B3+antes%2C+pero+fumar+puede+da%C3%B1ar+seriamente+su+salud.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESin+embargo%2C+si+usted+tiene+asma%2C+fumar+es+particularmente+malo+ya+que+puede+empeorar+sus+s%C3%ADntomas%2C+reduce+la+efectividad+del+medicamento%2C+causa+da%C3%B1o+pulmonar+permanente+y+constricci%C3%B3n+irreversible+de+las+v%C3%ADas+a%C3%A9reas.+Fumar+es+uno+de+los+detonadores+principales+del+asma%2C+con+un+82%25+de+personas+que+la+sufren+que+dicen+que+el+humo+del+tabaco+de+otras+personas+desencadena+sus+s%C3%ADntomas.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEl+humo+de+tabaco+puede+da%C3%B1ar+de+manera+permanente+la+mucosa+de+las+v%C3%ADas+a%C3%A9reas.+No+solamente+puede+deteriorar+la+funci%C3%B3n+general+de+sus+pulmones%2C+tambi%C3%A9n+puede+reducir+la+capacidad+de+sus+pulmones+para+responder+ante+otros+irritantes+tales+como+el+polen.+Este+puede+causar+una+acumulaci%C3%B3n+adicional+de+moco+en+los+pulmones%2C+el+cual+a+su+vez+puede+desencadenar+otros+s%C3%ADntomas+de+asma.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEl+fumar+de+manera+pasiva+o+secundaria%2C+tambi%C3%A9n+puede+empeorar+los+s%C3%ADntomas+del+asma+y+puede+desencadenar+ataques.+En+un+estudio+se+encontr%C3%B3+que+los+hijos+de+padres+fumadores+eran+1.5+veces+m%C3%A1s+propensos+a+desarrollar+asma%2C+y+tambi%C3%A9n+se+ha+demostrado+que+los+ni%C3%B1os+expuestos+al+humo+pasivo+tienen+mayor+riesgo+de+infecciones+tor%C3%A1cicas+y+otras+enfermedades+respiratorias.%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3EEs+por+eso+que+reducir%2C+y+aun+mejor%2C+dejar+de+fumar+no+solo+es+bueno+para+usted%2C+sino+tambi%C3%A9n+para+todos+los+que+lo+rodean.%3C%2Fp%3E%0D%0A%0D%0A%3Ch1%3E%C2%BFEst%C3%A1+pensando+en+dejarlo%3F%3C%2Fh1%3E%0D%0A%0D%0A%3Cp%3EDejar+de+fumar+no+es+f%C3%A1cil.+La+nicotina+es+muy+adictiva+y+el+fumar+puede+haberse+convertido+en+parte+de+su+rutina+diaria%2C+pero+todos+los+d%C3%ADas+hay+personas+que+est%C3%A1n+dejando+de+fumar+y+que+est%C3%A1n+experimentando+los+beneficios+en+su+propia+salud+y+finanzas%2C+as%C3%AD+como+beneficiando+a+las+personas+que+los+rodean.+%3C%2Fp%3E%0D%0A%0D%0A%3Cp%3ESi+usted+desea+dejar+de+fumar%2C+aqu%C3%AD+hay+algunos+tips+que+le+pueden+ayudar%3A%3C%2Fp%3E%0D%0A%0D%0A%3Cul%3E%0D%0A%3Cli%3EActualmente+hay+mucha+ayuda+y+recomendaciones+disponibles+con+el+profesional+de+la+salud+que+lo+atiende.+%C3%9Aselas+si+de+verdad+desea+dejar+de+fumar.+Lo+que+es+m%C3%A1s%2C+%C2%A1funciona%21+Hay+m%C3%A1s+probabilidad+de+%C3%A9xito+para+dejar+de+fumar+cuando+la+gente+tiene+este+apoyo.%3C%2Fli%3E%0D%0A%3Cli%3EHaga+una+lista+de+todas+las+razones+por+las+que+quiere+dejar+de+fumar+%E2%80%93+y+rev%C3%ADselas+cada+vez+que+sienta+el+deseo+de+fumar+un+cigarro.%3C%2Fli%3E%0D%0A%3Cli%3EEstablezca+una+fecha+para+dejar+de+fumar+y+piense+en+las+alternativas+para+superarlo+cuando+normalmente+usted+fumar%C3%ADa%2C+tales+como+una+noche+fuera+o+en+una+situaci%C3%B3n+de+estr%C3%A9s.%3C%2Fli%3E%0D%0A%3Cli%3ESi+los+amigos+o+la+familia+fuma%2C+expl%C3%ADqueles+su+situaci%C3%B3n+y+pida+su+apoyo+para+que+no+fumen+cerca+de+usted+ni+le+ofrezcan+un+cigarro.%3C%2Fli%3E%0D%0A%3C%2Ful%3E%0D%0A%0D%0A%3Cp%3ENunca+es+demasiado+tarde+para+dejar+de+fumar.+Su+salud+recibir%C3%A1+un+beneficio+al+dejar+de+fumar%2C+no+importa+la+edad+que+tenga.+As%C3%AD+que%2C+%C2%BFqu%C3%A9+le+detiene+para+dejarlo%3F+%3C%2Fp%3E%0D%0A","imagelist":[],"registered_only":"1"}]';
    
    
    if (app.currentUser.data.version < version) {
        app.stores.content.removeAll ();
        app.currentUser.data.version = version;
        app.currentUser.data.last_content_sync = new Date ();
        app.currentUser.save ();
        var jsonData = Ext.util.JSON.decode(jsonc);
        for (var i=0;i<jsonData.length;i++) {
            //alert (i + ". " + jsondata[i].title);
            //console.log (decodeURIComponent (jsonData[i].bodytext.split ("+").join (" ").split ("%92").join("'").split("%91").join("'").split("%96").join("-").split("%3F").join("?")));
            app.stores.content.add({
                                   id: jsonData[i].content_id,
                                   title: jsonData[i].title,
                                   bodytext: decodeURIComponent (jsonData[i].bodytext.split ("+").join (" ").split ("%92").join("'").split("%91").join("'").split("%96").join("-").split("%3F").join("?")),
                                   registered_only: Number(jsonData[i].registered_only),
                                   imagelist : jsonData[i].imagelist
							       
                                   });
            
            
        }
        
        
        if (jsonData.length > 0) {
            app.stores.content.sync ();
            
        }
        
        app.stores.content.sort('title', 'ASC');
        
    }
    
    
}



